/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc. All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/
#include "World.h"
#include "../common/NexUtil.h"

//-----------------------------------------------------------------------------
// Initialization
//-----------------------------------------------------------------------------
void World::InitDO()
{
    NEX_DEMO_LOG("*** World Init DO!!\n");
}

//-----------------------------------------------------------------------------
// Set the boundary
//-----------------------------------------------------------------------------
void World::SetBoundary(qReal minx, qReal miny, qReal maxx, qReal maxy)
{
    m_dsBoundaries.minX = minx;
    m_dsBoundaries.maxX = maxx;
    m_dsBoundaries.minY = miny;
    m_dsBoundaries.maxY = maxy;
}

//-----------------------------------------------------------------------------
// Get the boundary
//-----------------------------------------------------------------------------
void World::GetBoundary(qReal& minx, qReal& miny, qReal& maxx, qReal& maxy)
{
    minx = m_dsBoundaries.minX;
    maxx = m_dsBoundaries.maxX;
    miny = m_dsBoundaries.minY;
    maxy = m_dsBoundaries.maxY;
}

//-----------------------------------------------------------------------------
// Update
//-----------------------------------------------------------------------------
void World::DoPhysic()
{
    // Does not do anything
}

//-----------------------------------------------------------------------------
// Rendering
//-----------------------------------------------------------------------------
void World::Render()
{
    NEX_DEMO_LOG("WORLD INFO minx:%f miny:%f maxx:%f maxy:%f\n",
                 m_dsBoundaries.minX, m_dsBoundaries.minY, m_dsBoundaries.maxX, m_dsBoundaries.maxY);
}


