/*--------------------------------------------------------------------------
  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/




#include "SceneError.h"

#include "../common/DemoFramework.h"
#include "../common/ErrorUtil.h"
#include "../common/ErrorHandling.h"

namespace
{

}  // End of anonymous namespace


//
SceneError::SceneError(void)
{
    mSceneId = SCENE_ID_ERROR;
}


//
SceneError::~SceneError(void)
{
}


SceneBase* SceneError::GetInstance(void)
{
    static SceneError s_instance;
    return &s_instance;
}


void SceneError::Initialize(void)
{
    UTIL_TRACE(SAMPLE_TRACE_SCENE, _T("SceneError::Initialize"));
}

void SceneError::Finalize(void)
{
    UTIL_TRACE(SAMPLE_TRACE_SCENE, _T("SceneError::Finalize"));
}


SceneBase* SceneError::Update(void)
{
    (void)SceneBase::Update();

    return this;
}

void SceneError::Render(void) const
{
    RenderInfo("<SceneError>");

    const s32 STEP = 14;
    s32 y = 60;

    DemoFramework::GetInstance()->DrawText(0, y+=STEP, "NEX error is detected.");

    nn::nex::qResult result = ErrorHandling::GetCommonResultCode();
    DemoFramework::GetInstance()->DrawText(0, y+=STEP, " Facility   :  %4d", result.GetFacility());
    DemoFramework::GetInstance()->DrawText(0, y+=STEP, " ReturnCode :  %4d", result.GetReturnCode());
}
