﻿/*--------------------------------------------------------------------------
  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/




#include "SceneExitNetZSession.h"

#include "../common/DemoFramework.h"

#include "SceneSelectNetZSession.h"

#include "../common/NetZManager.h"

namespace
{

}  // end of anonymous namespace


SceneExitNetZSession::SceneExitNetZSession(void)
{
    mSceneId = SCENE_ID_EXIT_NETZ_SESSION;
}


SceneExitNetZSession::~SceneExitNetZSession(void)
{
}


SceneBase* SceneExitNetZSession::GetInstance(void)
{
    static SceneExitNetZSession s_instance;
    return &s_instance;
}


void SceneExitNetZSession::Initialize(void)
{
    UTIL_TRACE(SAMPLE_TRACE_SCENE, _T("SceneExitNetZSession::Initialize"));
    SceneBase::Initialize();

    m_context.Reset();

    NetZManager::GetInstance()->TerminateNetZ(&m_context);

}

void SceneExitNetZSession::Finalize(void)
{
    UTIL_TRACE(SAMPLE_TRACE_SCENE, _T("SceneExitNetZSession::Finalize"));
}


SceneBase* SceneExitNetZSession::Update(void)
{
    (void)SceneBase::Update();

    if(isTerminating())
    {
        return this;
    }
    else
    {
        if(NetZManager::GetInstance()->IsCreatedNetZ())
        {
            NetZManager::GetInstance()->DestroyNetZ();
        }

        if(DemoFramework::GetInstance()->IsTrigger(DEMO_BUTTON_A))
        {
            return SceneSelectNetZSession::GetInstance();
        }
        else
        {
            return this;
        }
    }
}

void SceneExitNetZSession::Render(void) const
{
    RenderInfo("<SceneExitNetZSession>");

    if(isTerminating())
    {
        DemoFramework::GetInstance()->DrawText(DRAW_POSITION_OPERATION_X, DRAW_POSITION_OPERATION_Y, "Terminating NetZ...");
    }
    else
    {
        DemoFramework::GetInstance()->DrawText(DRAW_POSITION_OPERATION_X, DRAW_POSITION_OPERATION_Y, "A: SceneSelectNetZSession");
    }
}


bool SceneExitNetZSession::isTerminating(void) const
{
    return m_context.GetState() == nn::nex::CallContext::CallInProgress;
}
