/*--------------------------------------------------------------------------
  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/



#ifndef SCENESESSIONCREATING_H_
#define SCENESESSIONCREATING_H_

#include "SceneBase.h"

/* Please see man pages for details 
  
  */
class SceneSessionCreating : public SceneBase
{
public:
    static SceneBase* GetInstance(void);

    virtual ~SceneSessionCreating(void);

    virtual void Initialize(void);
    virtual void Finalize(void);
    virtual SceneBase* Update(void);
    virtual void Render(void) const;

private:
    SceneSessionCreating(void);   // Force use of GetInstance function.
    SceneSessionCreating           (const SceneSessionCreating&);
    SceneSessionCreating& operator=(const SceneSessionCreating&);

    static void CreateProc(SceneSessionCreating *p); // Thread for CreateSession function.

    enum SubState
    {
        UNKNOWN,
        SUCCESS,
        FAILURE
    };

    enum SubState m_subState;
};

#endif  // end of SCENESESSIONCREATING_H_
