/*--------------------------------------------------------------------------
  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/


#ifndef SCENESESSIONJOINING_H_
#define SCENESESSIONJOINING_H_

#include "SceneBase.h"

#include <OnlineCore/src/Core/CallContext.h>

/*
  Participating in the session. "Please wait" ... state.
  */
class SceneSessionJoining : public SceneBase
{
public:
    static SceneBase* GetInstance(void);

    virtual ~SceneSessionJoining(void);

    virtual void Initialize(void);
    virtual void Finalize(void);
    virtual SceneBase* Update(void);
    virtual void Render(void) const;

private:
    SceneSessionJoining(void);   // Force use of GetInstance function.
    SceneSessionJoining           (const SceneSessionJoining&);
    SceneSessionJoining& operator=(const SceneSessionJoining&);

    nn::nex::CallContext m_context;
};


#endif  // end of SCENESESSIONJOINING_H_
