/*--------------------------------------------------------------------------
  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef SCENESESSIONPARTICIPANT_H_
#define SCENESESSIONPARTICIPANT_H_

#include "SceneBase.h"
#include "SceneSessionGame.h"

class SceneSessionParticipant : public SceneSessionGame
{
public:
    static SceneBase* GetInstance(void);

    virtual ~SceneSessionParticipant(void);

    virtual void Initialize(void);

    virtual SceneSessionGame* GetSceneSessionGameInstance();

    virtual SceneBase* Update(void);
    virtual void Render(void) const;

private:
    SceneSessionParticipant(void);   // Force use of GetInstance function.
    SceneSessionParticipant           (const SceneSessionParticipant&);
    SceneSessionParticipant& operator=(const SceneSessionParticipant&);
};




#endif  // end of SCENESESSIONPARTICIPANT_H_
