﻿/*--------------------------------------------------------------------------
  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/


#ifndef CTR_HEAPMANAGER_H_
#define CTR_HEAPMANAGER_H_

#include <cstdio>

namespace CTR
{
//
class HeapManager
{
public:
    HeapManager(void) {}
    ~HeapManager(void) {}

    static bool IsInitialized (void);
    static void Initialize    (void);
    static void Finalize      (void);
    static void PrintDebugInfo(bool bDetail = false);  // Set bDetail to true to print details.
    static void Age           (void);

    static bool IsClean       (void);
    static bool IsStarved     (void);  // Is memory almost depleted?

    // Returns total free memory.
    static std::size_t GetTotalFreeSize(void);

    //n1769 For debugging (primarily memory leak detection)
    static void ClearLog      (void);
    static void Analyze       (void);
    static void EnableLogging (void);
    static void DisableLogging(void);

private:
    //
    HeapManager           (const HeapManager&);
    HeapManager& operator=(const HeapManager&);
};

}  // end of namespace CTR

#endif  // end of CTR_HEAPMANAGER_H_
