/*--------------------------------------------------------------------------
  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef DEMO_SHADER_MANAGER_H_
#define DEMO_SHADER_MANAGER_H_

#include <nn/gx.h>
#include <nn/math.h>

#include "demo/ShaderProgram/demo_ProgramObject.h"
#include "demo/ShaderProgram/demo_ColorFillProgram.h"
#include "demo/ShaderProgram/demo_FontProgram.h"
#include "demo/ShaderProgram/demo_DecalTextureProgram.h"

namespace demo
{

/* Please see man pages for details 



*/
const u32 MAX_SHADER_BINARY_NUM = 1;

/* Please see man pages for details 



*/
const u32 MAX_SHADER_PROGRAM_NUM = 3;

/* Please see man pages for details 



*/
enum ShaderType
{
    COLOR_FILL_SHADER = 0,   //
    FONT_SHADER = 1,         //
    DECAL_TEXTURE_SHADER = 2, //
    BASIC_SHADER_BINARY_SHADER_NUM = 3 //
};

/* Please see man pages for details 



*/
const u32 BASIC_SHADER_BINARY_INDEX = 0;

/* Please see man pages for details 
    

    
*/

class ShaderManager : private nn::util::NonCopyable<ShaderManager>
{
public:
    /* Please see man pages for details 
    

    
    */
    ShaderManager(void);

    /* Please see man pages for details 
    

    
    */
    virtual ~ShaderManager(void);

public:
    /* Please see man pages for details 
    

    
    */
    virtual bool Initialize(void);

    /* Please see man pages for details 
    

    
    */
    virtual bool Finalize(void);
protected:
    virtual bool InitializeBasicShader(void);

public:
    /* Please see man pages for details 
    

    
    
    
    */
    u32 GetVertexAttributes(const ShaderType shaderType);

    /* Please see man pages for details 
    

    

    
    
    */
    ProgramObject* GetShaderProgram(const ShaderType shaderType);

protected:
    bool m_Initialized;
    u8 m_Padding[3];
    GLuint m_ShaderProgramIdArray[MAX_SHADER_BINARY_NUM][MAX_SHADER_PROGRAM_NUM];
    ProgramObject* m_ShaderProgramPtrArray[MAX_SHADER_BINARY_NUM][MAX_SHADER_PROGRAM_NUM];

protected:
    ColorFillProgram m_ColorFillProgram;
    FontProgram m_FontProgram;
    DecalTextureProgram m_DecalTextureProgram;
};

}

#endif
