﻿/*--------------------------------------------------------------------------
  Copyright (C) 2011-2014 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef DEMO_MEMORY_MANAGER_H_
#define DEMO_MEMORY_MANAGER_H_

#include "demo/Utility/demo_Utility.h"

namespace demo
{

namespace detail
{
/* Please see man pages for details 
    

           
*/

class MemoryManager : private nn::util::NonCopyable<MemoryManager>
{
public:
    /* Please see man pages for details 
        
    */
    MemoryManager(void);

    /* Please see man pages for details 
    
    */
    virtual ~MemoryManager();

    /* Please see man pages for details 
        

                  
                  

                  

        
        
    */
    void Initialize(const uptr fcramAddress, const size_t memorySize);

    /* Please see man pages for details 
        
    */
    void Finalize(void);

    /* Please see man pages for details 
        

        
        
        
        

        
    */
    void* Allocate(GLenum area, GLenum aim, GLuint id, GLsizei size);

    /* Please see man pages for details 
        

                  

        
        
        
        
    */
    void    Deallocate(GLenum area, GLenum aim, GLuint id, void* addr);


    /* Please see man pages for details 
        
    */
    void PrintFreeMemorySize(void);

private:
    bool            m_Initialized;
    u8              m_Pad[3];
    uptr            m_pStartAddrFcram;
    uptr            m_CurrentAddrVramA;
    uptr            m_CurrentAddrVramB;
    nn::fnd::ExpHeap    m_HeapOnFcram;
    size_t              m_AllocatedBlockSize;
};
} // namespace detail

/* Please see man pages for details 
    

    
    
*/
void InitializeMemoryManager(const uptr fcramAddress, const size_t memorySize);

/* Please see man pages for details 
    
*/
void FinalizeMemoryManager(void);

/* Please see man pages for details 
    
*/
void PrintMemoryManagerInfo(void);

/* Please see man pages for details 
    

    
    
    
    

    
*/
void* GetAllocator(GLenum area, GLenum aim, GLuint id, GLsizei size);

/* Please see man pages for details 
    

    
    
    
    
*/
void GetDeallocator(GLenum area, GLenum aim, GLuint id, void* addr);

/* Please see man pages for details 
    

    

    
    

    

    
*/
void* Alloc(size_t size);

/* Please see man pages for details 
    

    

    

    
*/
void Free(void* ptr);
}

#endif
