/*--------------------------------------------------------------------------
  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/


#ifndef DEFINES_H_
#define DEFINES_H_

// Thread mode related.
#define THREAD_MODE_VOID                      0
#define THREAD_MODE_UNSAFE_USER_SINGLE_THREAD 1
#define THREAD_MODE_UNSAFE_USER_MULTI_THREAD  2
#define THREAD_MODE_UNSAFE_TRANSPORT_BUFFER   3
#define THREAD_MODE_SAFE_USER_THREAD          4
#define THREAD_MODE_SAFE_TRANSPORT_BUFFER     5
#define THREAD_MODE_INTERNAL                  6


#define TRANSPORT_THREAD_PRIORITY NN_NEX_PRIORITY_LOW

#if defined(CTR_TARGET)
#include <nn/os.h>

#define THREAD_SYNC_PRIORITY_SLEEP nn::os::LOWEST_THREAD_PRIORITY
#define THREAD_SYNC_PRIORITY_NEX   TRANSPORT_THREAD_PRIORITY
#define THREAD_SYNC_PRIORITY_JOIN (nn::os::DEFAULT_THREAD_PRIORITY - 1)
#elif defined(CAFE_TARGET)
#include <cafe/os.h>

#define THREAD_SYNC_PRIORITY_SLEEP OS_PRIORITY_MAX
#define THREAD_SYNC_PRIORITY_NEX   TRANSPORT_THREAD_PRIORITY
#define THREAD_SYNC_PRIORITY_JOIN (OS_PRIORITY_APP_DEFAULT - 1)
#else /*!CTR_TARGET && !CAFE_TARGET*/

#endif


// Trace related.
#define SAMPLE_TRACE_ALWAYS    (1<<0)
#define SAMPLE_TRACE_ERROR     (1<<1)
#define SAMPLE_TRACE_BUTTON    (1<<2)
#define SAMPLE_TRACE_UDS       (1<<3)
#define SAMPLE_TRACE_TRANSPORT (1<<4)
#define SAMPLE_TRACE_UPDATE    (1<<5)
#define SAMPLE_TRACE_ROUTE     (1<<6)

#define SAMPLE_TRACE_SCENE     (1<<10)
#define SAMPLE_TRACE_AVATAR    (1<<11)
#define SAMPLE_TRACE_POSITION  (1<<12)
#define SAMPLE_TRACE_WORLD     (1<<13)
#define SAMPLE_TRACE_LATENCY   (1<<14)


#endif  // end of DEFINES_H_
