﻿/*--------------------------------------------------------------------------
  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _StatisticValue_H_
#define _StatisticValue_H_

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>

BEGIN_NAMESPACE_NEX

class StatisticValue : public RootObject
{
public:
    qUnsignedInt64 m_Value;
    qUnsignedInt64 m_ValueMax;
    qUnsignedInt64 m_ValueMaxResult;
    qUnsignedInt64 m_ValueMin;
    qUnsignedInt64 m_ValueMinResult;
    qUnsignedInt64 m_ValueSum;
    qUnsignedInt32 m_Count;
    qUnsignedInt64 m_Average;

    StatisticValue()
    {
        ResetValue();
    }

    void ResetValue()
    {
        m_Value = 0;
        m_ValueMax = 0;
        m_ValueMaxResult = 0;
        m_ValueMin = 0xFFFFFFFFFFFFFFFF;
        m_ValueMinResult = 0;
        m_ValueSum = 0;
        m_Count = 0;
        m_Average = 0;
    }

    void AddValue(qUnsignedInt64 value)
    {
        m_Value = value;
        m_ValueSum += m_Value;
        m_Count ++;
        if(m_Value > m_ValueMax)
        {
            m_ValueMax = m_Value;
        }
        if(m_Value < m_ValueMin)
        {
            m_ValueMin = m_Value;
        }
    }

    void CalcAverage()
    {
        m_Average = m_ValueSum / m_Count;
        m_ValueMaxResult = m_ValueMax;
        m_ValueMinResult = m_ValueMin;
    }
};

END_NAMESPACE_NEX

#endif
