﻿/*--------------------------------------------------------------------------
  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _ConsoleTrace_H_
#define _ConsoleTrace_H_

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include <OnlineCore/src/Platform/Core/Log.h>

BEGIN_NAMESPACE_NEX

#define UTIL_TRACE(FLAG, ARGS)      \
    if ((NAMESPACE_NEX UtilTrace::GetInstance()->GetFlags() & (FLAG))) {\
        NAMESPACE_NEX StringStream __ss; __ss << ARGS;\
        NAMESPACE_NEX UtilTrace::GetInstance()->OutputString(__ss.CStr());\
    }

#define _UTIL_TRACE(FLAG, ARGS)     \
    if ((NAMESPACE_NEX UtilTrace::GetInstance()->GetFlags() & (FLAG))) {\
        NAMESPACE_NEX UtilTrace::GetInstance()->Output ARGS;\
    }

class UtilTrace : public Log
{
public:
    static UtilTrace* GetInstance()
    {
        if(s_pUtilTraceInstance == NULL)
        {
            s_pUtilTraceInstance = new UtilTrace();
        }
        return s_pUtilTraceInstance;
    }

    static void DeleteInstance()
    {
        if( s_pUtilTraceInstance )
        {
            delete s_pUtilTraceInstance;
            s_pUtilTraceInstance = NULL;
        }
    }

    UtilTrace();
    virtual ~UtilTrace() {}

    void ClearFlags()
    {
        m_uiTraceFlags = 0;
    }

    qUnsignedInt64 GetFlags()
    {
        return m_uiTraceFlags;
    }

    void SetFlag( qUnsignedInt64 uiFlags )
    {
        m_uiTraceFlags |= uiFlags;
    }

private:
    static UtilTrace* s_pUtilTraceInstance;
    qUnsignedInt64 m_uiTraceFlags;
};

END_NAMESPACE_NEX

#endif
