/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc. All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef NEXDEMO_CONSOLE_H_
#define NEXDEMO_CONSOLE_H_

#include <demo.h>

namespace nexdemo
{
class Console
{
public:
    // Font size
    static const u8 FONT_SIZE = 8;

public:
    /* Please see man pages for details 
        
    */
    Console();

    /* Please see man pages for details 
        
    */
    virtual ~Console();

    /* Please see man pages for details 
        

        
        
        
        
        
        
        
    */
    void Initialize(s16 x, s16 y, u16 windowCharsPerLine, u16 windowLines, u32 bufferCharsPerLine, u32 bufferLines, u8 lineSpace = 2);

    /* Please see man pages for details 
        

        
        
        
        
        
    */
    void Initialize(s16 x, s16 y, u16 charsPerLine, u16 lines, u8 lineSpace = 2)
    {
        Initialize(x, y, charsPerLine, lines, charsPerLine, lines, lineSpace);
    }

    /* Please see man pages for details 
        
    */
    void Finalize();

    /* Please see man pages for details 
        
    */
    void Clear();

    /* Please see man pages for details 
        

        
        
    */
    void Printf(const char* pFormat, ...);

    /* Please see man pages for details 
        

        
    */
    void PutString(const char* pString);

    /* Please see man pages for details 
        

        
    */
    void Render(demo::RenderSystemDrawing* pRenderSystem);

    /* Please see man pages for details 
        

        
        
    */
    void Scroll(s16 scrollX, s16 scrollY);

    /* Please see man pages for details 
        
    */
    s16 GetX() const
    {
        return m_x;
    }

    /* Please see man pages for details 
        
    */
    s16 GetY() const
    {
        return m_y;
    }

    /* Please see man pages for details 
        

        
    */
    s32 GetScrollX() const
    {
        return m_scrollX;
    }

    /* Please see man pages for details 
        

        
    */
    s32 GetScrollY() const
    {
        return m_scrollY;
    }

    /* Please see man pages for details 
        

        
    */
    u16 GetWindowCharsPerLine() const
    {
        return m_windowCharsPerLine;
    }

    /* Please see man pages for details 
        

        
    */
    u16 GetWindowLines() const
    {
        return m_windowLines;
    }

    /* Please see man pages for details 
        

        
    */
    u32 GetBufferCharsPerLine() const
    {
        return m_bufferCharsPerLine;
    }

    /* Please see man pages for details 
        

        
    */
    u32 GetBufferLines() const
    {
        return m_bufferLines;
    }

    /* Please see man pages for details 
        

        
    */
    u32 GetUsedBufferCharsPerLine() const
    {
        return m_usedBufferCharsPerLine;
    }

    /* Please see man pages for details 
        

        
    */
    u32 GetUsedBufferLines() const
    {
        return m_usedBufferLines;
    }

    /* Please see man pages for details 
        

        
    */
    u16 GetLineHeight() const
    {
        return FONT_SIZE + m_lineSpace;
    }

    /* Please see man pages for details 
        

        
    */
    u8 GetMargin() const
    {
        return m_lineSpace / 2;
    }

    /* Please see man pages for details 
        

        
    */
    bool IsInitialized() const
    {
        return m_isInitialized;
    }

    /* Please see man pages for details 
        

        
    */
    void SetScrollX(s32 scrollX);

    /* Please see man pages for details 
        

        
    */
    void SetScrollY(s32 scrollY);

protected:
    // Add the character(s) to the buffer.
    void PutChar(char c);

protected:
    // Buffer
    char** m_ppBuffer;
    char*  m_pRenderBuffer;
    // Coordinates
    u16 m_x;
    u16 m_y;
    // Window
    u16 m_windowCharsPerLine;
    u16 m_windowLines;
    // Screen buffer
    u16 m_bufferCharsPerLine;
    u16 m_bufferLines;
    // Used screen buffer
    u16 m_usedBufferCharsPerLine;
    u16 m_usedBufferLines;
    // Space between lines
    u8 m_lineSpace;
    // cursor position
    u32 m_cursorX;
    u32 m_cursorY;
    // Scroll position
    s32 m_scrollX;
    s32 m_scrollY;
    // Flags
    bool m_isInitialized;
    bool m_isOver;
    bool m_isFull;
};
}

#endif // NEXDEMO_CONSOLE_H_
