﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#include "DemoMem.h"
#include <nn/fnd.h>

NEXUTIL_BEGIN

namespace
{
nn::fnd::ThreadSafeExpHeap s_nexHeap;
}

void DemoMem::InnerInitialize(void* memBlock, size_t memSize)
{
    s_nexHeap.Initialize(reinterpret_cast<uptr>(memBlock), memSize);
}

void DemoMem::InnerFinalize()
{
    s_nexHeap.Finalize();
}

void DemoMem::InnerInvalidate()
{
    s_nexHeap.Invalidate();
}

void* DemoMem::InnerAlloc(size_t size)
{
    return s_nexHeap.Allocate(size, DemoMem::ALIGNMENT);
}

void DemoMem::InnerFree(void* p)
{
    s_nexHeap.Free(p);
}

void DemoMem::Dump()
{
    s_nexHeap.Dump();
}

size_t DemoMem::GetBlockSize(const void* p) const
{
    return s_nexHeap.GetSizeOf(p);
}

NEXUTIL_END

