/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc. All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _DEMOPAD_H_
#define _DEMOPAD_H_

#include "NexUtil.h"

NEXUTIL_BEGIN

#define DEMO_PAD_BUTTON_LEFT         0x0001
#define DEMO_PAD_BUTTON_RIGHT        0x0002
#define DEMO_PAD_BUTTON_DOWN         0x0004
#define DEMO_PAD_BUTTON_UP           0x0008
#define DEMO_PAD_BUTTON_R            0x0020
#define DEMO_PAD_BUTTON_L            0x0040
#define DEMO_PAD_BUTTON_A            0x0100
#define DEMO_PAD_BUTTON_B            0x0200
#define DEMO_PAD_BUTTON_X            0x0400
#define DEMO_PAD_BUTTON_Y            0x0800

struct PadStatus
{
    qUnsignedInt16 hold;
    qUnsignedInt16 trigger;
    qUnsignedInt16 release;
};

class DemoPad
{
public:

    // Initialize
    static void Initialize();

    // Finalize
    static void Finalize();

    // Update button input
    static void Update(PadStatus* pButton);
};

NEXUTIL_END

#endif // _DEMOPAD_H_
