﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

// This file must have the name of the Dataset that it implements, ConnectionInfo.h

#ifndef _ConnectionInfo_H_
#define _ConnectionInfo_H_

#include <NetZ/src/Core/DOCore/ObjDupDecl.h>
#include <NetZ/src/Core/DOCore/DataSet.h>
#include <NetZ/src/Core/DOCore/ConnectionInfoDDL.h>

BEGIN_NAMESPACE_NEX

class ConnectionInfo: public DATASET(ConnectionInfo)
{
public:
    ConnectionInfo();
    virtual ~ConnectionInfo();

    const qChar *GetURL(qInt iIndex) const;
    void  SetURL(qInt iIndex, const qChar *szTransportURL);
    void  AddURL(const qChar* szTransportURL);
    void  AddURL(const StationURL& urlStation);
private:
    qBool SameURLs(const StationURL& urlStation1, const StationURL& urlStation2);
    qBool ReplaceURL(const StationURL &urlStation1, const StationURL &urlStation2, qInt iIndex);
};

END_NAMESPACE_NEX

#endif
