﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _DOClassTemplate_H_
#define _DOClassTemplate_H_

#include <NetZ/src/Core/DOCore/ObjDupImpl.h>
#include <NetZ/src/Core/DOCore/DuplicatedObject.h>

BEGIN_NAMESPACE_NEX

// Group=Object Duplication Subsystem

template <class DO, class ParentClass> class DOClassTemplate: public ParentClass
{
public:
    DOClassTemplate(qUnsignedInt32 uiClassID): ParentClass(uiClassID) {}
    virtual ~DOClassTemplate() {};

    // A few general methods...
    virtual qResult SpecificUpdate(DuplicatedObject* pDO, DataSet *pDataset, const Time& tUpdateTime)
    {
        return ((DO*)pDO)->SpecificUpdate(pDataset, tUpdateTime);
    }

    virtual qBool SpecificRefresh(DuplicatedObject* pDO, DataSet *pDataset, const Time& tRefreshTime)
    {
        return ((DO*)pDO)->SpecificRefresh(pDataset, tRefreshTime);
    }

    virtual void SpecificAddDSToDiscoveryMessage(DuplicatedObject* pDO, Station* pStation, Message* pMsg)
    {
        ((DO*)pDO)->SpecificAddDSToDiscoveryMessage(pMsg, pStation);
    }


    virtual void SpecificExtractDSFromDiscoveryMessage(DuplicatedObject* pDO, Message* pMsg)
    {
        ((DO*)pDO)->SpecificExtractDSFromDiscoveryMessage(pMsg);
    }

    virtual qBool SpecificExtractADataset(DuplicatedObject* pDO, Message* pMsg, qByte byDatasetIndex)
    {
        return ((DO*)pDO)->SpecificExtractADataset(pMsg, byDatasetIndex);
    }

    virtual qBool ValidCastTowards(qUnsignedInt32 uiClassID)
    {
        if (uiClassID==ParentClass::GetID())
        {
            return true;
        }
        else
        {
            return ParentClass::ValidCastTowards(uiClassID);
        }
    }
};

END_NAMESPACE_NEX

#endif
