﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc. All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _DirectTransport_H_
#define _DirectTransport_H_

#include <NetZ/src/Core/DOCore/Station.h>
#include <OnlineCore/src/Core/SystemComponent.h>

#include <OnlineCore/src/Transport/PRUDP/PRUDPUserProtocol.h>

BEGIN_NAMESPACE_NEX

/* Please see man pages for details 
    

    
    
 */
class DirectTransport: public SystemComponent
{
public:
    DECLARE_SYSCOMPONENT_METHODS(DirectTransport,SystemComponent);

    /* Please see man pages for details 
    
     */
    DirectTransport();

    /* Please see man pages for details 
    
     */
    virtual ~DirectTransport();

    /* Please see man pages for details 
    

    
     */
    static DirectTransport* GetInstance();

public:
    /* Please see man pages for details 
    

    
    

    
    
    
    

    

    
     */
    void RegisterUserReceiveCallback( PRUDPUserReceiveCallback callback );

    /* Please see man pages for details 
    
     */
    void UnregisterUserReceiveCallback();

    /*
    n1589: Can only be used with the thread that called Scheduler::Dispatch
    In transport thread mode, the callback set with RegisterUserReceiveCallback
    is called from the transport thread,
    so the direct calling of send/receive APIs from inside the callback is prohibited.
    */
    /* Please see man pages for details 
    

    

    
    
    

    
    
    

    
    
    
    
    
     */
    qResult SendUnreliable(StationID destId, qByte* buffer, qUnsignedInt32 size);

    /* Please see man pages for details 
    

    
    
    


    
    

    
    
    
    
    */
    qResult SendUnreliableAll(qByte* buffer, qUnsignedInt32 size);

    /* Please see man pages for details 
    

    

    
    
    
    
    

    
    
    

    
    
    
    
    
     */
    qResult SendReliable(StationID destId, qByte* buffer, qUnsignedInt32 size);

    /* Please see man pages for details 
    

    
    
    
    
    

    
    

    
    
    
    
     */
    qResult SendReliableAll(qByte* buffer, qUnsignedInt32 size);
};

END_NAMESPACE_NEX

#endif
