﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _ParticipationManager_H_
#define _ParticipationManager_H_

#include <NetZ/src/Core/DOCore/ObjDupDecl.h>
#include <OnlineCore/src/Transport/Interface/EndPoint.h>
#include <OnlineCore/src/Transport/Interface/Message.h>
#include <OnlineCore/src/Platform/Core/qList.h>

BEGIN_NAMESPACE_NEX

// Group=Results Classes

/*
Summary: This class defines the context of a call to a duplicated object.
Remarks: This class is used to define the call context of calls made to fetch and migrate
duplicated objects and of RMCs.
*/
class ParticipationManager: public RootObject
{
    //Group=Type Definitions
    class Pretendant;
public:
    ParticipationManager();
    virtual ~ParticipationManager();

    // {secret}
    qBool PrepareParticipantsMessage(Message *pMessage);
    static qBool ExtractStationProbeList(Message *pMessage, StationProbeList *plstStationProbe );

    // {secret}
    qBool AddPretendantURL(EndPoint *pEndPoint, Message *pMessage);
    qBool RemovePretendantURL(EndPoint *pEndPoint);

    void Trace(qUnsignedInt64 uiTraceFlags = TRACE_ALWAYS);

private:
    qList<Pretendant*>  m_lstPretendants;
};


END_NAMESPACE_NEX

#endif
