﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

// This file must have the name of the Dataset that it implements, SessionState.h

#ifndef _SessionState_H_
#define _SessionState_H_

#include <NetZ/src/Core/DOCore/ObjDupDecl.h>
#include <NetZ/src/Core/DOCore/DataSet.h>
#include <NetZ/src/Core/DOCore/SessionStateDDL.h>
#include <OnlineCore/src/Core/PseudoGlobalVariable.h>

BEGIN_NAMESPACE_NEX

class Operation;

class SessionState: public DATASET(SessionState)
{
public:
    SessionState();
    virtual ~SessionState() {};

    void OperationEnd(const DOOperation* pOperation);

    void SetState(qByte byNewState);
    qByte GetState();

    // The persistent state is the session state, but remains
    // valid before the object construction, and also after its
    // destruction.
    static qUnsignedInt32 GetPersistentState();

private:

    static PseudoGlobalVariable<qUnsignedInt32> s_ulPersistentSystemState;
};

END_NAMESPACE_NEX

#endif
