﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _StationState_H_
#define _StationState_H_

#include <NetZ/src/Core/DOCore/ObjDupDecl.h>
#include <NetZ/src/Core/DOCore/StationStateDDL.h>

BEGIN_NAMESPACE_NEX

class StationState: public DATASET(StationState)
{
public:

    StationState();
    virtual ~StationState();

    void AssociatedStation(Station* pAssociatedStation)
    {
        m_pAssociatedStation=pAssociatedStation;
    }

    qUnsignedInt16 Get() const
    {
        return m_ui16State;
    }
    void Set(qUnsignedInt16 ui16Value);

    void    OperationBegin(DOOperation * pOperation);
    void    OperationEnd(DOOperation * pOperation);

    const qChar* GetStateString() const
    {
        return GetStateString(m_ui16State);
    }
    const qChar* GetStateString(qUnsignedInt16 ui16State) const;

    void ValidateTransition(qUnsignedInt16 uiInit, qUnsignedInt16 uiFinal);

private:
    Station* m_pAssociatedStation;
};

END_NAMESPACE_NEX

#endif
