﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _PHBDRVar_H_
#define _PHBDRVar_H_

#include <NetZ/src/Core/DOCore/ObjDupDecl.h>
#include <OnlineCore/src/Core/Statistics.h>

BEGIN_NAMESPACE_NEX

class PHBDRVarRoot: public RootObject
{
public:
    PHBDRVarRoot() {};
    virtual ~PHBDRVarRoot() {};

    static Statistics& GetPredictionDelayStats()
    {
        return s_stPredictionDelay;
    }
    static Statistics& GetTrackingErrorStats()
    {
        return s_stTrackingError;
    }
    static Statistics& GetLocalCorrectionErrorStats()
    {
        return s_stLocalCorrectionError;
    }
    static Statistics& GetLocalCorrectionDuration()
    {
        return s_stLocalCorrectionDuration;
    }
    static void EnableStats()
    {
        s_bRecordStats=true;
    }
    static void DisableStats()
    {
        s_bRecordStats=false;
    }

protected:

    static qBool s_bRecordStats;
    static Statistics s_stTrackingError;
    static Statistics s_stLocalCorrectionError;
    static Statistics s_stPredictionDelay;
    static Statistics s_stLocalCorrectionDuration;
};

END_NAMESPACE_NEX


#include <NetZ/src/Extensions/PHBDR/PHBDRTemplate_float.h>
#include <NetZ/src/Extensions/PHBDR/_PHBDRVar.h>

#include <NetZ/src/Extensions/PHBDR/PHBDRTemplate_int32.h>
#include <NetZ/src/Extensions/PHBDR/_PHBDRVar.h>

#include <NetZ/src/Extensions/PHBDR/PHBDRTemplate_int16.h>
#include <NetZ/src/Extensions/PHBDR/_PHBDRVar.h>

#include <NetZ/src/Extensions/PHBDR/PHBDRTemplate_int8.h>
#include <NetZ/src/Extensions/PHBDR/_PHBDRVar.h>

#include <NetZ/src/Extensions/PHBDR/PHBDRTemplate_double.h>
#include <NetZ/src/Extensions/PHBDR/_PHBDRVar.h>

#define PHBDRVAR(type) PHBDRVar_##type

#ifdef TEST_ENABLED
BEGIN_NAMESPACE_NEX
qBool PHBDRTest();
END_NAMESPACE_NEX
#endif

#endif
