﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef __ONLINECORE_SRC_CORE_FILENAMEPARSER_H__
#define __ONLINECORE_SRC_CORE_FILENAMEPARSER_H__

#include <OnlineCore/src/Core/CoreDecl.h>
#include <OnlineCore/src/Platform/Core/String.h>

BEGIN_NAMESPACE_NEX

class OSDK_API FilenameParser: public RootObject
{
public:
    FilenameParser();
    ~FilenameParser();

    /* \internal
      \brief Builds the import name from the python file
      \param[in]filename The python file name with/without the folder.
      \returns The import name extracted from the file name
      \example
      - ServiceFolder/ServiceFilename.py  => ServiceFolder.ServiceFilename
        ServiceFolder\\ServiceFilename.py => ServiceFolder.ServiceFilename
        this way the from ServiceFolder.ServiceFilename import ServiceClassName will work
    */
    static const String GetImportName(const String& filename);
    static const String NormalizePath(const String& filename);
};

END_NAMESPACE_NEX

#endif // __ONLINECORE_SRC_CORE_FILENAMEPARSER_H__
