/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc. All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _FirstErrorHolder_H_
#define _FirstErrorHolder_H_

#include <OnlineCore/src/Platform/Core/Result.h>
#include <OnlineCore/src/Platform/Core/ScopedCS.h>
#include <OnlineCore/src/Platform/Core/CriticalSection.h>

BEGIN_NAMESPACE_NEX

/* Please see man pages for details 
 
 
 
 
 
 */
class FirstErrorHolder : public RootObject
{
public:
    FirstErrorHolder() :
        m_FirstError(true)
    {}

    /* Please see man pages for details 
     
     
     
     
     */
    void SetIfFirst(qResult error)
    {
        ScopedCS lock(m_Lock);
        if ( m_FirstError == true ) // Set only when no errors have occurred
        {
            SYSTEMCHECK(error==false);
            m_FirstError = error;
        }
    }

    qResult Get() const
    {
        ScopedCS lock(m_Lock);
        return m_FirstError;
    }

private:
    mutable CriticalSection m_Lock;
    qResult m_FirstError;
};


END_NAMESPACE_NEX

#endif

