﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _FixedSizePooledObject_H_
#define _FixedSizePooledObject_H_

#include <OnlineCore/src/Core/FixedSizeMemoryPool.h>

#ifdef NON_SUPPORT_B_OPTIMISATION_ENABLED

#define DEFINE_FIXED_SIZE_POOLED_OBJECT(ClassName,NbInstance) \
public: \
void *operator new(size_t size) { return Allocate(size); } \
void *operator new(size_t size, qChar *file, qUnsignedInt32 line) { DUMMY_PARAM(file); DUMMY_PARAM(line); return Allocate(size); } \
void operator delete(void* uptr) { Free(uptr); } \
void operator delete(void *uptr, qChar * /*file*/, qUnsignedInt32 /*line*/){ Free(uptr); } \
static void *Allocate(size_t size) { DUMMY_PARAM(size); return s_o##ClassName##Pool.Allocate(); } \
static void Free(void* uptr) { s_o##ClassName##Pool.Free(uptr); } \
private: \
FixedSizeMemoryPool *GetMemoryPool() { return &s_o##ClassName##Pool; } \
static FixedSizeMemoryPool  s_o##ClassName##Pool;

#define DECLARE_FIXED_SIZE_POOLED_OBJECT(ClassName,NbInstance) \
FixedSizeMemoryPool ClassName::s_o##ClassName##Pool(sizeof(ClassName),NbInstance);

#else

#define DEFINE_FIXED_SIZE_POOLED_OBJECT(ClassName,NbInstance)
#define DECLARE_FIXED_SIZE_POOLED_OBJECT(ClassName,NbInstance)

#endif

#endif
