﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _PseudoGlobalVariableList_H_
#define _PseudoGlobalVariableList_H_

#include <OnlineCore/src/Core/CoreDecl.h>
#include <OnlineCore/src/Core/InstantiationContext.h>

#define UNDEFINED_VARIABLE  0xFFFF


BEGIN_NAMESPACE_NEX

class PseudoGlobalVariableRoot;

class PseudoGlobalVariableList: public RootObject
{
public:
    PseudoGlobalVariableList();
    virtual ~PseudoGlobalVariableList();

#ifdef TEST_ENABLED
    static qBool Test();
#endif

    static PseudoGlobalVariableRoot* GetVariable(qUnsignedInt uiIndex);
    static qUnsignedInt FindVariableIndex(PseudoGlobalVariableRoot* pVariable);
    static qUnsignedInt GetNbOfVariables();

    void AddVariable(PseudoGlobalVariableRoot* pVariable);
    void RemoveVariable(PseudoGlobalVariableRoot* pVariable);
    void AllocateExtraContextsForAllVariables();
    void FreeExtraContextsForAllVariables();
    void ResetContextForAllVariables(ICContext icContext);

private:
    static PseudoGlobalVariableRoot* s_pVariableListHead;
    static qUnsignedInt m_uiNbOfVariables;
};

END_NAMESPACE_NEX

#endif
