﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _PseudoGlobalVariableRoot_H_
#define _PseudoGlobalVariableRoot_H_

#include <OnlineCore/src/Core/CoreDecl.h>
#include <OnlineCore/src/Core/PseudoGlobalVariableList.h>


BEGIN_NAMESPACE_NEX

class PseudoGlobalVariableRoot: public RootObject
{
public:
    PseudoGlobalVariableRoot();
    virtual ~PseudoGlobalVariableRoot();

    static void AllocateExtraContextsForAllVariables(qUnsignedInt uiNbOfExtraContexts);
    static void FreeExtraContextsForAllVariables();
    static void ResetContextForAllVariables(ICContext icContext);
    static qUnsignedInt GetNbOfExtraContexts();

    virtual void AllocateExtraContexts() = 0;
    virtual void FreeExtraContexts() = 0;
    virtual void ResetContext(ICContext icContext)=0;

    virtual PseudoGlobalVariableRoot* GetNext() = 0;
    virtual void SetNext(PseudoGlobalVariableRoot* pNextVariable) = 0;

protected:
    static PseudoGlobalVariableList s_oList;

    PseudoGlobalVariableRoot* m_pNext;

    static qUnsignedInt s_uiNbOfExtraContexts;
};

END_NAMESPACE_NEX

#endif
