﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc. All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/
#ifndef _SingleStepJob_H_
#define _SingleStepJob_H_

#include <OnlineCore/src/Core/StepSequenceJob.h>

BEGIN_NAMESPACE_NEX

/* Please see man pages for details 
 
 
 */
class SingleStepJob : public StepSequenceJob
{
public:
    /* Please see man pages for details 
     
     
     */
    SingleStepJob()
        : StepSequenceJob(Job::Core, _T("SingleStepJob"))
        , m_AssociatedCallID(0)
    {}
    /* Please see man pages for details 
     
     
     */
    virtual ~SingleStepJob(){}

    /* Please see man pages for details 
     
     
     
     
     
     
     
     
     
     */
    qBool Start(CallContext* pContext, qBool deleteOnCompletion=false);

    /* Please see man pages for details 
     
     
     
     
     
     
     
     
     */
    virtual qBool OnStep(qResult* result) = 0;

    static const qUnsignedInt32 DELAY_TIME_MSEC = 16; //
private:
    void SingleStep();

    void CompleteJob(const qResult& rResult);

    qUnsignedInt32 m_AssociatedCallID;
};

END_NAMESPACE_NEX

#endif
