/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc. All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _DOClassID_H_
#define _DOClassID_H_

BEGIN_NAMESPACE_NEX
// System reserved DOClassIDs:

enum
{
    INVALID_CLASSID            =0,
    DuplicatedObject_ClassID   =1,
    FIRST_COREDOCLASSID        =2,
    FIRST_USERDOCLASSID            =100,
    MAX_DOCLASSID        =255
};

/*
    \ingroup group_onlinecore_core
    \brief A DOClassID is a unique identifier for a given DOClass.

    A DOClassID is a 8-bit value automatically generated by the DDL compiler for each duplicated
    object class. As this value is generated, it may change when you recompile your project, alter
    your DDL file, or upgrade to a new version of this framework.

    For example, if the following is defined in the DDL file:

         doclass CustomSessionObject;

    The DDL compiler will generate the appropriate DOClassID that can be accessed via the DOCLASSID
    macro as follows:

         DOCLASSID(CustomSessionObject)

    The DOHandle of a duplicated object is made up of the object's DOClassID and its DOID.
    \sa DDL File Syntax, Duplicated Object Overview, DOCLASSID
*/
/* Please see man pages for details 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 */
typedef qUnsignedInt32 DOClassID;

END_NAMESPACE_NEX

#endif
