﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _NameSpaceRef_H_
#define _NameSpaceRef_H_

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include <OnlineCore/src/Platform/Core/String.h>
#include <OnlineCore/src/ParseTree/NameSpaceItem.h>

BEGIN_NAMESPACE_NEX

class NameSpace;
class NameSpaceItem;

class OSDK_API NameSpaceRef: public RootObject
{
public:
    NameSpaceRef();
    NameSpaceRef(NameSpace *pNS, const String& strName);
    virtual ~NameSpaceRef();

    qBool Resolve();
    void Release();
    qBool ReverseLookup();

    void SetItem(NameSpaceItem* pItem);
    NameSpaceItem* GetItem() const
    {
        return m_pItem;
    }

    void SetName(const String& strName);
    const String& GetName() const
    {
        return m_strName;
    }

    // For object that aren't references - such a the template
    // instance.
    void SetDummyNameInfo(NameSpaceItem* pItem);

    void SetNameSpace(NameSpace* pNS);
    NameSpace* GetNameSpace() const
    {
        return m_pNS;
    }

private:
    String m_strName;
    NameSpace *m_pNS;
    NameSpaceItem *m_pItem;
};

END_NAMESPACE_NEX

#endif
