/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc. All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

/* NOTE: This file is read in two different contexts: Imakefile and CPP files. */
/* Regular CPP comments cannot be used in it */

/* n1589:memo: mkmf is required if revised */

#ifndef _Capabilities_H_
#define _Capabilities_H_

#if !defined(NON_SUPPORT_B_TARGET) && !defined(NON_SUPPORT_A_TARGET)
#define CPP_EXCEPTION_SUPPORT
#endif

#if (defined(WIN32_TARGET) && !defined(NON_SUPPORT_D_FAMILY)) || defined(UNIX_FAMILY)
#define MULTIPROCESS_SUPPORT
#endif

#ifdef UNIX_FAMILY
/* See bug 1980 */
//#undef MULTIPROCESS_SUPPORT
#endif


/*
This is used when we need to write methods for all basic types, to
indicate if qChar16 should be done as well, or it overlaps with
one of the other basic types */

#if defined(VS2005_COMPILER) || defined(VS2008_COMPILER) || defined(VS2010_COMPILER) || defined(NON_SUPPORT_C_TARGET) || defined(NON_SUPPORT_E_TARGET) || defined(CTR_UNICODE) || defined(CAFE_UNICODE)
#define DISTINCT_UNICODE_TYPE
#endif

#if defined(WIN_FAMILY) || defined(NON_SUPPORT_C_TARGET) || defined(CTR_UNICODE) || defined(UNIX_FAMILY) || defined(CAFE_UNICODE)
#define UNICODE_SUPPORT
#define SNPRINTF_SUPPORT
#endif

#if defined(WIN32_TARGET)
#define CODEPAGE_SUPPORT
#endif


#if defined(WII_TARGET) || defined(CAFE_TARGET) || defined(CAFEIOP_TARGET)
#define SNPRINTF_SUPPORT
#endif

#if defined(WIN_FAMILY) && !defined(NON_SUPPORT_D_FAMILY)
#define REGISTRY_SUPPORT
#endif

#if defined(WIN32_TARGET) || defined(UNIX_FAMILY)
#define ENV_VARIABLE_SUPPORT
#endif

#if defined(WIN32_TARGET) && defined(INTERNAL_VERSION)
#define DBG_STACKWALK_SUPPORT
#endif

#if defined(WIN32_TARGET)
#define STACK_TRACER_SUPPORT
#endif

#if defined(WIN32_TARGET) || defined(UNIX_FAMILY)
#define FILE_SUPPORT
#define FILE_STREAM_SUPPORT     /* ofstream, ifstream, etc. */
#endif

#define LEAKTRACKER_SUPPORT

#if !defined(NON_SUPPORT_B_TARGET) && !defined(NON_SUPPORT_A_TARGET) && !defined(NON_SUPPORT_C_TARGET) && !defined(CTR_TARGET) && !defined(CAFE_TARGET) && !defined(CAFEIOP_TARGET)
#define THREAD_SCRAMBLER_SUPPORT
#endif

#ifdef DYNAMIC_LIBRARY_VERSION
#define DYNAMIC_LIBRARY_SUPPORT
#endif

#ifdef FAST_CALL_VERSION
/* With the FastCall version of the Win32 library, we do not support
 * DLL's */
#undef DYNAMIC_LIBRARY_SUPPORT
#undef LEAKTRACKER_SUPPORT
#endif

#ifndef UNIX_FAMILY
#define PRIVATE_DESTRUCTOR_SUPPORT
#endif

#define NAMESPACE_SUPPORT
#define WATERMARK_SUPPORT

#if defined(CAFE_TARGET) || defined(CAFEIOP_TARGET)
#undef WATERMARK_SUPPORT
#endif

/* n2494 */
#if defined(CTR_SHIPPING_VERSION)
#undef WATERMARK_SUPPORT
#endif

#ifdef WIN32_TARGET
#define FP_EXCEPTION_SUPPORT    /* Floating-point support */
#endif

/* Configure ALLOCATOR_SUPPORT */

#define ALLOCATOR_SUPPORT

#if defined(ALLOCATOR_SUPPORT) && defined(__MWERKS__)
#define STD_TREE_PAIR_ALLOCATOR_SUPPORT
#endif

#if defined(ALLOCATOR_SUPPORT) && defined(MACOSX_TARGET)
#define STD_TREE_PAIR_ALLOCATOR_SUPPORT
#endif

#if defined(ALLOCATOR_SUPPORT) && (defined(CTR_TARGET) || defined(CAFE_TARGET) || defined(CAFEIOP_TARGET))
#define STD_TREE_PAIR_ALLOCATOR_SUPPORT
#endif


#ifdef WIN32_TARGET
#define PYTHON_SUPPORT
#endif

#if defined(WIN32_TARGET)
#define EXCEPTION_HANDLER_SUPPORT
#endif

#if defined(WIN32_TARGET) || defined(LINUX_TARGET) || defined(MACOSX_TARGET)
#define TARGET_IS_HOST
#endif

/* Configure SERVICE_HOST_SUPPORT */

#if defined(WIN32_TARGET) && defined(ANSI_VERSION)
#define SERVICE_HOST_SUPPORT
#endif

#if defined(LINUX_TARGET)
#define SERVICE_HOST_SUPPORT
#endif

#ifdef CRYSTALD_BUILD
#undef SERVICE_HOST_SUPPORT
#endif

#if defined(VS2005_COMPILER)
/* We will not support 2005 for the backend */
#undef SERVICE_HOST_SUPPORT
#endif

#if !defined(WII_DWC)
#define SERVICE_CLIENT_SUPPORT
#endif

/*
 TODO.  This macro is still used in the code.  The code portions it
 controls should probably be deleted or fixed and enabled [bug 5563]
 This variable controls if config files can be used to read the license keys
 (e.g., for the ddl compiler).

 FILE_VARIABLE_SUPPORT

*/

/*
  Thread Capabilities - Enables setting the thread affinity of
  $PRODUCTNAME$ processes.  If the list of target platforms changes, we must change the
  documentation in the Core::SetDefaultThreadAffinity method
  appropriately.
 */

#if defined(WIN32_TARGET) || defined(NON_SUPPORT_E_TARGET) || defined(CAFE_TARGET)
#define THREAD_AFFINITY_SUPPORT
#endif

/*
 * STL Capabilities - Used for the STL extensions.
 */

#if !defined(NON_SUPPORT_B_TARGET) || !defined(NON_SUPPORT_A_TARGET)
#define STL_BITSET_SUPPORT
#endif

#if !defined(WIN32_TARGET) || (defined(DOT_NET_COMPILER) && !defined(STL_PORT))
#define STL_REBIND_SUPPORT
#endif

/* Defines if the STL defines std::iterator correctly or not */

#ifndef SN_COMPILER
#define STD_BASE_ITERATOR_SUPPORT
#endif


/*
 * Services Capabilities
 */

#ifdef WIN32_TARGET
#define MANAGEMENT_CONSOLE_SUPPORT
#if !defined(LIVE_FAMILY)
#define WINDOWS_MFC_SUPPORT
#endif
#endif

#if (defined(VS2008_COMPILER) && defined(UNREAL_BUILD)) || defined(VS_EXPRESS_COMPILER)
#undef WINDOWS_MFC_SUPPORT
#endif

#if (defined(VS2010_COMPILER) && defined(UNREAL_BUILD)) || defined(VS_EXPRESS_COMPILER)
#undef WINDOWS_MFC_SUPPORT
#endif


#if defined(SERVICE_HOST_SUPPORT)
#define ROTATING_LOG_SUPPORT
#endif

/*
 * FileStorage support
 */

#if defined(WIN32_TARGET) || defined(NON_SUPPORT_B_TARGET) || defined(NON_SUPPORT_D_FAMILY)
#define FILESTORAGE_SUPPORT
#endif

/*
 * PSAPI - to access process information, in the ControlProtocol.
 */

#ifdef WIN32_TARGET
#define PSAPI_SUPPORT
#endif

#if defined(VS2005_COMPILER) || defined(VS2008_COMPILER) || defined(VS2010_COMPILER)
/* TODO: This should be fixed */
#undef PSAPI_SUPPORT
#endif

/*
 * Console IO support
 */
#define CONIO_SUPPORT
#if defined(NON_SUPPORT_D_FAMILY) || defined(NON_SUPPORT_B_TARGET) || defined(NON_SUPPORT_A_TARGET) || defined(NON_SUPPORT_C_TARGET) || defined(NINTENDO_FAMILY)
#undef CONIO_SUPPORT
#endif

#if defined(LINUX_TARGET) || defined(MACOSX_TARGET)
/* It is supported... but the syntax is not equivalent.  It is easier to simply disable it for now. */
#undef CONIO_SUPPORT
#endif

#if defined(NON_SUPPORT_D_FAMILY) || defined(WIN32_TARGET)
#define DIRECTX_SUPPORT
#endif

#if defined(NON_SUPPORT_B_TARGET) || defined(WIN32_TARGET) || defined(NON_SUPPORT_D_FAMILY) || defined(NON_SUPPORT_A_TARGET) || defined(NON_SUPPORT_C_TARGET) || defined(NINTENDO_FAMILY)
/* The NON_SUPPORT_A and Wii target is there for specific clients that request this, it is not really supported */
#define AVSTREAM_SUPPORT
#endif

#if defined(WIN32_TARGET) && !defined(USE_DX10)
#define AVSTREAM_SUPPORT
#endif


#if defined(DEBUG_VERSION) || defined(TRACE_BLOCKING_CALLS) || defined(DEVELOPMENT_VERSION)
/* Please see man pages for details */
#define LOCK_DEBUG_ENABLED
#endif

/*
 * ConsoleUI support.  For Spark's text sample
 */

#if defined(NON_SUPPORT_B_TARGET) || defined(NON_SUPPORT_A_TARGET) || defined(NON_SUPPORT_C_TARGET) || defined(NON_SUPPORT_E_TARGET)
#define CONSOLEUI_SUPPORT
#endif

#if defined(WIN32_TARGET) && !defined(USE_DX10)
#define CONSOLEUI_SUPPORT
#endif

/*
 * ContentSharing support (only a subset of platforms for now)
 */
#if defined(NON_SUPPORT_C_TARGET) || defined(LIVE_FAMILY) || defined(WIN32_TARGET)
#define CONTENT_SHARING_SUPPORT
#endif


/*
 * SFTP support: a subset of platforms having CONTENT_SHARING_SUPPORT supports SFTP.
 */
#if defined(NON_SUPPORT_C_TARGET) || (defined(WIN32_TARGET) && !defined(WINLIVE_TARGET))
#define SFTP_SUPPORT
#endif


/*
 * For some custom builds, we might want to disable SFTP in some circumstance.
 */
#if defined(NO_SFTP_SUPPORT)
#undef SFTP_SUPPORT
#endif


/*
 * UPnP support: platforms for which UPnP extension is supported.
 */
/* n2208 */
#if !defined(LIVE_FAMILY) && !defined(NON_SUPPORT_C_TARGET) && !defined(WII_DWC) && !defined(UNIX_FAMILY) && !defined(NON_SUPPORT_A_TARGET) && !defined(NEX_CLIENT_OPTIMIZATION) && !defined(CAFE_TARGET) && !defined(CAFEIOP_TARGET)
//#define UPNP_SUPPORT
#endif


/*
 * NATCheck support
 */
#if !defined(LIVE_FAMILY) && !defined(WII_DWC)
#define RV_NAT_SUPPORT
#endif


/*
 * NAT PMP support: platforms for which NatPMP extension is supported.
 */
/* n2208 */
#if defined(WIN32_TARGET) && !defined(LIVE_FAMILY) && !(defined(CTR_TARGET) || defined(CAFE_TARGET) || defined(CAFEIOP_TARGET))
//#define NAT_PMP_SUPPORT
#endif


/*
 * Endianness
 */

#if !defined(LINUX_TARGET) && !defined(MACOSX_TARGET)
#define NN_NEX_BIG_ENDIAN 1
#define NN_NEX_LITTLE_ENDIAN 2
#if defined(NON_SUPPORT_E_TARGET) || defined(NON_SUPPORT_C_TARGET) || defined(WII_TARGET) || defined(CAFE_TARGET) || defined(CAFEIOP_TARGET)
#define NN_NEX_BYTE_ORDER NN_NEX_BIG_ENDIAN
#else
#define NN_NEX_BYTE_ORDER NN_NEX_LITTLE_ENDIAN
#endif
#endif

/*
Little Endian (Intel)
0xfffffdb3 (2 Bytes Int)
0xb3    0xfd
0xffd993dd (4 Bytes Int)
0xdd    0x93    0xd9    0xff
0xf9fe63b7f8e89162 (8 Bytes Int)
0x62    0x91    0xe8    0xf8    0xb7    0x63    0xfe    0xf9


Big Endian (PowerPC)
lv2(3): 0xfffffdb3 (2 Bytes Int)
lv2(3): 0xfd    0xb3
lv2(3): 0xffd993dd (4 Bytes Int)
lv2(3): 0xff    0xd9    0x93    0xdd
lv2(3): 0xf9fe63b7f8e89162 (8 Bytes Int)
lv2(3): 0xf9    0xfe    0x63    0xb7    0xf8    0xe8    0x91    0x62
*/


/*
 * Win32 CrtSetReportHook: this run-time lib function is used to associate a handler that
 * will be executed if an exception is raised.
 */
#if defined(WIN32_TARGET) && defined(EXCEPTION_HANDLER_SUPPORT) && (defined(LIVE_VERSION) || defined(INTERNAL_VERSION))
#define CRT_SET_REPORT_HOOK_SUPPORT
#endif

/*
 * Obsolete API support - still supporting client API with error code returned as qBool/qResult
 */
#ifndef NO_OBSOLETE_API_SUPPORT     /* for example, Samples */
#define OBSOLETE_API_SUPPORT
#endif

#ifdef NO_DISTINCT_UNICODE_TYPE
#undef DISTINCT_UNICODE_TYPE
#endif

#ifdef NO_FILE_STREAM_SUPPORT
#undef FILE_STREAM_SUPPORT
#endif

#endif

#if (defined(SN_COMPILER) && !defined(NON_SUPPORT_C_TARGET)) || defined(SN_TARGET_NON_SUPPORT_B)
#define TURN_MATHWARN_OFF
#endif


/* n1589: Required when the NN success rate is not high */
#define ROUTING_SUPPORT


/* CTR FPD Build */
#if defined(FPD_BUILD)
/* n1589: Temporarily deleted because when using undef, there are places that become ROUTING_SUPPORT OFF with mkmf and ROUTING_SUPPORT ON with build */
/* #undef ROUTING_SUPPORT */
#endif
