﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _Defs_H_
#define _Defs_H_

#define WAIT_INFINITE_TIMEOUT   0xFFFFFFFF

#define _TANSI(a)               a
#define _TUNICODE(a)            L ## a

#define SIZEOFARRAY(array) (sizeof(array) / sizeof(array[0]))

#define qMax(a,b)   (((a) > (b)) ? (a) : (b))
#define qMin(a,b)   (((a) < (b)) ? (a) : (b))

#ifdef WIN_FAMILY
#define STDCALL __stdcall
#define __CDECL __cdecl
#define IN_ADDR_ADDRESS(a)      a.S_un.S_addr
#define GetLastOSError()        GetLastError()
#else // !WIN_FAMILY
#define STDCALL
#define __CDECL
#ifndef NULL
#define NULL                    0
#endif // !NULL
#endif // WIN_FAMILY


// *** _T definition for non-WIN_FAMILY platforms ***

#ifndef WIN_FAMILY
#ifndef _T

#if defined(CTR_UNICODE)
#define __T(a)                  L ## a
#define _T(a)                   __T(a)
#elif defined(CAFE_UNICODE)
#define __T(a)                  L ## a
#define _T(a)                   __T(a)
#else
#define _T(a)                   a
#endif

#endif // ifndef _T
#endif // ifndef WIN_FAMILY



#if defined(GCC_COMPILER_FAMILY) || defined(SNC_TARGET_NON_SUPPORT_C)
#define DUMMY_PARAM(X)
#elif defined(CTR_TARGET)
#define DUMMY_PARAM(X)         ((void)&X);
#elif defined(CAFE_TARGET) || defined(CAFEIOP_TARGET)
#define DUMMY_PARAM(X)         (void)X;
#else
#define DUMMY_PARAM(X)          (X);
#endif // GCC_COMPILER_FAMILY

#ifdef WIN_FAMILY
#define NEX_INVALID_HANDLE_VALUE INVALID_HANDLE_VALUE
#endif


#if defined(UNIX_FAMILY)
#define NEX_INVALID_HANDLE_VALUE    static_cast<pthread_t>(NULL)
#define CALLBACK
#define WINAPI
#define ERROR_SUCCESS           0
#define GetLastOSError()        errno
#endif // UNIX_FAMILY


#if defined(WII_TARGET) || defined(CAFE_TARGET)
#define NEX_INVALID_HANDLE_VALUE    static_cast<OSThread*>(NULL)
#endif // defined(WII_TARGET) || defined(CAFE_TARGET)

#if defined(CAFEIOP_TARGET)
#define NEX_INVALID_HANDLE_VALUE    static_cast<IOSThreadId*>(NULL)
#endif // CAFEIOP_TARGET

#if defined(CTR_TARGET)
#define NEX_INVALID_HANDLE_VALUE    static_cast<Thread*>(NULL)
#endif // CTR_TARGET

#ifdef MW_COMPILER
extern "C" {
    void mwInit();
    void mwExit();
}
#endif

#endif
