﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _NameSpaceDefinition_H_
#define _NameSpaceDefinition_H_

#ifdef NAMESPACE_SUPPORT

// If another definition for the namespace macros, we keep it.  This
// definition is done in the INTERNAL_VERSION, to test namespaces (see
// NameClash, CompleteNameSpaceTest).

#ifndef BEGIN_NAMESPACE_NEX  /* CS:skipline ignore this BEGIN_NAMESPACE_NEX when matching begin/end namespace macros */
#define BEGIN_NAMESPACE_NEX namespace nn { namespace nex {
#endif

#define END_NAMESPACE_NEX   }}

#ifndef USING_NAMESPACE_NEX
#define USING_NAMESPACE_NEX using namespace nn::nex;
#endif

#ifndef NAMESPACE_NEX
#define NAMESPACE_NEX               nn::nex::
#endif

// Ensure the namespace exists.
BEGIN_NAMESPACE_NEX
END_NAMESPACE_NEX

// [NEX1][LINUS] Unify namespaces (TEMP)
#ifndef NAMESPACE_QUAZAL
#define NAMESPACE_QUAZAL NAMESPACE_NEX
#define NS_QUAZAL NAMESPACE_QUAZAL
#define BEGIN_NAMESPACE_QUAZAL BEGIN_NAMESPACE_NEX
#define END_NAMESPACE_QUAZAL END_NAMESPACE_NEX
#define USING_NAMESPACE_QUAZAL USING_NAMESPACE_NEX
#define OSDK_API
#endif

#else

#define BEGIN_NAMESPACE_NEX
#define END_NAMESPACE_NEX
#define USING_NAMESPACE_NEX
#define NAMESPACE_NEX

// [NEX1][LINUS] Unify namespaces (TEMP)
#ifndef NAMESPACE_QUAZAL
#define NAMESPACE_QUAZAL
#define NS_QUAZAL
#define BEGIN_NAMESPACE_QUAZAL
#define END_NAMESPACE_QUAZAL
#define USING_NAMESPACE_QUAZAL
#define OSDK_API
#endif

#endif //NAMESPACE_SUPPORT

#endif //_NameSpaceDefinition_H_
