﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _PlatformImpl_H_
#define _PlatformImpl_H_

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>

#ifdef CAFEIOP_TARGET
#include <ioslibc.h>
#include <sys_printf_interface.h>
#include <OnlineCore/src/Platform/Core/WideCharIOP.h>
#else  // CAFEIOP_TARGET
#include <stdio.h>
#endif // CAFEIOP_TARGET

#ifndef TEST_ENABLED
// {Secret}
// The following modules should be in ifdefs... But makedepend does not work
// well when some includes are between ifdefs. The easy solution is to define
// the macros that protect them!
#define _UnitTesting_H_
#endif

#include <OnlineCore/src/Platform/Core/Platform.h>
#include <OnlineCore/src/Platform/Core/UnitTesting.h>
#include <OnlineCore/src/Platform/Core/SystemError.h>
#include <OnlineCore/src/Platform/Core/Tokenizer.h>
#include <OnlineCore/src/Platform/Core/Result.h>
#include <OnlineCore/src/Platform/Core/OutputFormat.h>

#ifdef COMPILING_Q_PLATFORM
// This file is included when the Q Platform is compiled... but also included
// since the templates declaration include PlatformImpl.h. We want to
// automatically use the Quazal namespace only when we compile the system.
USING_NAMESPACE_NEX

#endif

#endif

