﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _RandomNumberGenerator_H_
#define _RandomNumberGenerator_H_

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>

BEGIN_NAMESPACE_NEX

const qUnsignedInt RNGStateVectorSize = 624;

class RandomNumberGenerator
{
public:
    RandomNumberGenerator();
    ~RandomNumberGenerator();

    void SetRandomNumberSeed(qUnsignedInt32 uiSeed);
    qReal GetRealRandomNumber(qReal fMaxValue);
    qUnsignedInt32 GetRandomNumber(qUnsignedInt32 uiMaxValue);

#ifdef TEST_ENABLED
    static qBool Test();
#endif

protected:
    qUnsignedInt32  m_mt[RNGStateVectorSize]; /* the array for the state vector  */
    qUnsignedInt    m_mti;
    qUnsignedInt32  m_mag01[2];
};

END_NAMESPACE_NEX

#endif
