﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc. All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C) 2011-2014 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

/* NOTE: This file is read in two different contexts: Imakefile and CPP files. */
/* Regular CPP comments cannot be used in it */

#ifndef _TargetDefinition_H_
#define _TargetDefinition_H_

/* This file is used to define optional macros to enable or disable
 some specific functionality, given the capabilities and target
 selection macros (DEBUG, INTERNAL_VERSION, UNICODE).
 */


/* undef support or enable some optional functionality */

#ifdef DEBUG_VERSION
#ifdef INTERNAL_VERSION
#define GLOBALNEW_DETECTION_ENABLED
#endif
#endif

#if defined(NON_SUPPORT_B_TARGET) || defined(NON_SUPPORT_D_FAMILY) || defined(NON_SUPPORT_A_TARGET)
#undef GLOBALNEW_DETECTION_ENABLED
#endif

#ifdef RELEASE_VERSION
#undef THREAD_SCRAMBLER_SUPPORT
#endif

#if defined(INTERNAL_VERSION) && !defined(TEST_ENABLED)
//#define TEST_ENABLED // [NEX1][LINUS] TEST_ENABLED is deprecated.
#endif

#if !defined(INTERNAL_VERSION) && !defined(NEX_ENABLE_PSEUDOSINGLETON_OPTIMIZATION)
//n2690 removed
//#define NEX_ENABLE_PSEUDOSINGLETON_OPTIMIZATION //[NEX1][LINUS] Retain NEX behavior - optimize pseudosingleton access in non-internal versions.
#endif

#ifdef FPD_BUILD
#undef TEST_ENABLED
#endif

#if defined(DEBUG_VERSION) || defined(DEVELOPMENT_VERSION)
#define SYSTEMCHECK_ENABLED
#endif

#ifdef DEBUG_VERSION
#ifdef INTERNAL_VERSION
#define LOCK_RESTRICTIONS_ENABLED
#endif
#endif

#if defined(NEX_GLOBAL_HEAP_CHECK_ONLY) && defined(LOCK_RESTRICTIONS_ENABLED)
#undef LOCK_RESTRICTIONS_ENABLED
#endif

#ifdef SN_COMPILER
#undef LOCK_RESTRICTIONS_ENABLED
#endif

/* Apply patches macro: defined in the internal version, and in the Q
 * Platform, for all targets */

#ifdef INTERNAL_VERSION
#define APPLY_PATCHES
#endif

#ifdef COMPILING_Q_PLATFORM
#define APPLY_PATCHES
#endif

// [NEX1][LINUS] No patches.

#if defined(WATERMARK_SUPPORT)
#define WATERMARK_ENABLED
#endif

#if defined(NEX_GLOBAL_HEAP_CHECK_ONLY)
#undef WATERMARK_ENABLED
#endif

#if !defined(NEX_CLIENT_OPTIMIZATION) || defined(TEST_ENABLED)
#define PERFCOUNTER_ENABLED
#endif

#if defined(CTR_SHIPPING_VERSION) || defined(NEX_GLOBAL_HEAP_CHECK_ONLY)
#undef PERFCOUNTER_ENABLED
#endif

/* n1589:the following define enable to trace in !DEBUG_VERSION
#define ENABLE_TRACES
*/

#if defined(DEBUG_VERSION) || defined(ENABLE_TRACES)
#define TRACE_ENABLED
#endif

#define LOG_ENABLED

/* n2605 */
//[NEX1][SYLVAIN] added compatibility for builds other than debug, on platforms other than ctr
#if (defined(CTR_SHIPPING_VERSION) && defined(RELEASE_VERSION)) || (defined(CAFE_TARGET) && defined(RELEASE_VERSION))
#undef LOG_ENABLED
#endif

#if defined(NO_LOG_SUPPORT)
#undef LOG_ENABLED
#endif

/* we want to have more traces on the backend. */
#if defined(TRACE_ENABLED) || defined (LIVE_VERSION) || NEX_DISABLE_USING_CTR_PROFILING_UNIT == 0
#define JOB_TRACE_INFO_ENABLED
#endif

#if defined(NON_SUPPORT_B_TARGET) && 0
#define NON_SUPPORT_B_OPTIMISATION_ENABLED
#endif

#ifdef DEBUG_VERSION
/* It may cause a leak, I believe, in some tests. */
/* n1589 */
/* #define DEBUG_REFERENCES */
#endif


#if defined(DEBUG_VERSION) && !defined(NON_SUPPORT_A_TARGET) && !defined(NON_SUPPORT_B_TARGET)
#ifndef HEAP_DEBUGGING_ENABLED
#define HEAP_DEBUGGING_ENABLED
#endif
#endif

#if defined(EXCEPTION_HANDLER_SUPPORT) /*&& (defined(INTERNAL_VERSION) || defined(LIVE_VERSION))*/
#define EXCEPTION_TRAPPING_ENABLED
#endif

#if defined(DEBUG_VERSION) || defined(INTERNAL_VERSION)
#define LEAK_DETECTION_ENABLED
#endif

// Definition for "define" to reduce memory usage when building from the application in the CafeIOP environment.
#if defined(CAFEIOP_TARGET) && !defined(COMPILING_Q_PLATFORM)
#ifndef IOP_SIZE_OPTIMIZE
#define IOP_SIZE_OPTIMIZE
#endif
#endif

// Controls the linking of the debug python library (python27_d.lib) when including Python.h for the debug build
#define SWIG_PYTHON_INTERPRETER_NO_DEBUG

#endif
