/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc. All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _TimeProvider_H_
#define _TimeProvider_H_

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>

BEGIN_NAMESPACE_NEX

// Group = Time Management

/*
Description: This class provides the actual time used by $PRODUCTNAME$ in various time-related
computations.
Remarks: A custom TimeProvider may be used to provide the time that $PRODUCTNAME$ uses for
time related computations, such as those associated with the SessionClock and LocalClock.
In order to implement your own TimeProvider you must sub class this class and implement
the GetTime method.
One situation where you may want to implement your own TimeProvider is where you require time
related computations within your game to be identical to those performed by $PRODUCTNAME$.
*/
/* Please see man pages for details 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 */
class TimeProvider: public RootObject
{
public:
    //group=Methods
    TimeProvider() {}
    virtual ~TimeProvider() {}

    /*
    Description: Returns the Time as defined by this TimeProvider.
    Returns: The current Time as defined by this TimeProvider.
    Remarks: If you sub class the TimeProvider class you must implement this method.
    */
    /* Please see man pages for details 
     
     
     
     
     
     */
    virtual Time GetTime() = 0;
};

END_NAMESPACE_NEX


#endif // _TimeProvider_H_
