﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _Tokenizer_H_
#define _Tokenizer_H_


#include <OnlineCore/src/Platform/Core/PlatformDecl.h>

BEGIN_NAMESPACE_NEX

#define MAXTOKENNUM 64

class Tokenizer: public RootObject
{

public:
    Tokenizer(const qChar *tzString, qChar tDelim);
    Tokenizer(const qChar *tzString, const qChar *pDelim);
    virtual ~Tokenizer();

    qUnsignedInt32 GetNbTokens() const
    {
        return m_uiNbTokens;
    }
    qChar*& operator[](const qUnsignedInt32& uiIndex);

#ifdef TEST_ENABLED
    static qBool Test();
#endif

    void Trace(qUnsignedInt64 uiTraceFlag);

private:
    void Tokenize(const qChar *tzString, const qChar* pDelim);
    const qChar* FindNextNonDelim(const qChar* pString, const qChar* pDelim, qUnsignedInt32 delimSize);
    const qChar* FindNextDelim(const qChar* pString, const qChar* pDelim);
    void AssignToken(const qChar* pStart, qUnsignedInt32 TokenSize);

protected:
    qChar* m_atzToken[MAXTOKENNUM];
    qUnsignedInt32 m_uiNbTokens;
};

END_NAMESPACE_NEX

#endif
