/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc. All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/


#ifndef _Utility_H_
#define _Utility_H_

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include <OnlineCore/src/Platform/Core/TraceLog.h>


BEGIN_NAMESPACE_NEX


//


//n1769 Because it was irritating to always write out QTRACE(TRACE_ALWAYS, _T("Hogehoge...")).
#if 1  //n1769 Let's make this 0 for when you would like to end all traces at once.
#define ALWAYS_TRACE(str) alwaysTraceImpl(_T(str), _T(__FILE__), __LINE__)
#else
#define ALWAYS_TRACE(str)
#endif

//n1769 We do not recommend calling this function directly. This function should be called from the ALWAYS_TRACE macro.
void alwaysTraceImpl(const qChar *pStr, const qChar *pFilename, unsigned int line);

END_NAMESPACE_NEX


#endif  // end of _Utility_H_
