﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _Wrappers_H_
#define _Wrappers_H_

#include <OnlineCore/src/Platform/Core/PlatformDeclInternal.h>

#if defined(NINTENDO_FAMILY)
#include <string.h>
#include <wchar.h>
#endif

#ifdef CAFEIOP_TARGET
#include <OnlineCore/src/Platform/Core/WideCharIOP.h>
#endif

#if defined(UNIX_FAMILY) || defined(WII_TARGET) || defined(CTR_ANSI) || defined(CAFE_ANSI)


#ifndef _tmain
#define _tmain      main
#endif

#ifndef _snprintf
#define _snprintf   snprintf
#endif

#ifndef _sntprintf
#define _sntprintf  snprintf
#endif

#ifndef _tprintf
#define _tprintf    printf
#endif

#ifndef _stprintf
#define _stprintf   sprintf
#endif

#ifndef _vstprintf
#define _vstprintf  vsprintf
#endif

#ifndef _ftprintf
#define _ftprintf   fprintf
#endif

#ifndef _vftprintf
#define _vftprintf  vfprintf
#endif

#ifndef _tcsftime
#define _tcsftime   strftime
#endif

#ifndef _vsntprintf
#define _vsntprintf vsnprintf
#endif

#ifndef _tfopen
#define _tfopen     fopen
#endif

#ifndef _tcscat
#define _tcscat     strcat
#endif

#ifndef _tcsncat
#define _tcsncat    strncat
#endif

#ifndef lstrcat
#define lstrcat     strcat
#endif

#ifndef _tcscmp
#define _tcscmp     strcmp
#endif

#ifndef _tcscspn
#define _tcscspn    strcspn
#endif

#ifndef _tcsicmp
#define _tcsicmp    strcasecmp
#endif

#ifndef _tcsncmp
#define _tcsncmp    strncmp
#endif

#ifndef _tcscpy
#define _tcscpy     strcpy
#endif

#ifndef _tcsncpy
#define _tcsncpy    strncpy
#endif

#ifndef _tcslen
#define _tcslen     strlen
#endif

#ifndef _tcschr
#define _tcschr     strchr
#endif

#ifndef _tcsrchr
#define _tcsrchr    strrchr
#endif

#ifndef _tcsstr
#define _tcsstr     strstr
#endif

#ifndef _tcsdup
#define _tcsdup     strdup
#endif

#ifndef _tcserror
#define _tcserror   strerror
#endif

#ifndef _tgetenv
#define _tgetenv    getenv
#endif

#ifndef _ttoi
#define _ttoi       atoi
#endif

#ifndef _tstof
#define _tstof      atof
#endif

#ifndef _getts
#define _getts      gets
#endif

#ifndef _fgetts
#define _fgetts     fgets
#endif

#ifndef _tcsdup
#define _tcsdup     strdup
#endif

#ifndef _getch
#define _getch      getch
#endif

#ifndef __const
#define __const     const
#endif

#ifndef _tremove
#define _tremove    remove
#endif

#ifndef _trename
#define _trename    rename
#endif

#if defined(WII_TARGET) || defined(CAFE_TARGET) || defined(UNIX_FAMILY)
#ifndef _tcstoul
#define _tcstoul    strtoul
#endif

#ifndef _tcstol
#define _tcstol     strtol
#endif

#ifndef _tcstod
#define _tcstod     strtod
#endif
#endif

//  bug:3692: printf-like string formatter spec
#define SZ_FMT      _T("%s")

#if defined(CAFE_TARGET)
#ifndef _stprintf_s
#define _stprintf_s snprintf
#endif
#endif

#endif

#if defined(CAFE_UNICODE) //copied from CTR_UNICODE
#ifndef _tcscpy
#define _tcscpy     wcscpy
#endif

#ifndef _tcslen
#define _tcslen     wcslen
#endif

#ifndef _tcsstr
#define _tcsstr     wcsstr
#endif

#ifndef _tcschr
#define _tcschr     wcschr
#endif

#ifndef _tcsrchr
#define _tcsrchr    wcsrchr
#endif

#ifndef _tcscat
#define _tcscat     wcscat
#endif

#ifndef _tcsncat
#define _tcsncat    wcsncat
#endif

#ifndef _tcscmp
#define _tcscmp     wcscmp
#endif

#ifndef _tcsicmp
#define _tcsicmp    _tcscmp             // No non-case-sensitive version found
#endif

#ifndef _tcsncmp
#define _tcsncmp    wcsncmp
#endif

#ifndef _tcsupr
#define _tcsupr     wgccupr //strupr
#endif

#ifndef _tcstoul
#define _tcstoul    wcstoul
#endif

#ifndef _tcsnicmp
#define _tcsnicmp   _tcsncmp            // No non-case-sensitive version found
#endif

#ifndef _tstoi
#define _tstoi(s)   wcstoul(s, 0, 10)
#endif

#ifndef _tstof
#define _tstof(s)   wcstod(s, 0)
#endif

#ifndef _tcstod
#define _tcstod     wcstod
#endif

#ifndef _tcsncpy
#define _tcsncpy    wcsncpy
#endif

#ifndef _tcscspn
#define _tcscspn    wcscspn
#endif

#ifndef _tprintf
#define _tprintf    wprintf
#endif

#ifndef _sntprintf
#define _sntprintf  swprintf
#endif

#ifndef _stprintf
#define _stprintf   swprintf
#endif


#ifndef _vsntprintf
#define _vsntprintf vswprintf
#endif

#ifndef _ftprintf
#define _ftprintf   fwprintf
#endif

#ifndef _ttoi
#define _ttoi       _tstoi
#endif

#ifndef _fgetts
#define _fgetts     fgetws
#endif

#ifndef _vstprintf
#define _vstprintf  vwprintf
#endif

#ifndef _tmain
#define _tmain      main
#endif

//  bug:3692: printf-like string formatter spec
#define SZ_FMT      _T("%ls")

#ifndef _tremove
#define _tremove    remove
#endif

#ifndef _tfopen
#define _tfopen     fopen
#endif

#ifndef _tcsftime
#define _tcsftime   strftime
#endif

#endif//if defined CAFE_UNICODE

#if defined(CTR_UNICODE)

#ifndef _tcscpy
#define _tcscpy     wcscpy
#endif

#ifndef _tcslen
#define _tcslen     wcslen
#endif

#ifndef _tcsstr
#define _tcsstr     wcsstr
#endif

#ifndef _tcschr
#define _tcschr     wcschr
#endif

#ifndef _tcsrchr
#define _tcsrchr    wcsrchr
#endif

#ifndef _tcscat
#define _tcscat     wcscat
#endif

#ifndef _tcsncat
#define _tcsncat    wcsncat
#endif

#ifndef _tcscmp
#define _tcscmp     wcscmp
#endif

#ifndef _tcsicmp
#define _tcsicmp    _tcscmp             // No non-case-sensitive version found
#endif

#ifndef _tcsncmp
#define _tcsncmp    wcsncmp
#endif

#ifndef _tcsupr
#define _tcsupr     wgccupr //strupr
#endif

#ifndef _tcstoul
#define _tcstoul    wcstoul
#endif

#ifndef _tcsnicmp
#define _tcsnicmp   _tcsncmp            // No non-case-sensitive version found
#endif

#ifndef _tstoi
#define _tstoi(s)   wcstoul(s, 0, 10)
#endif

#ifndef _tstof
#define _tstof(s)   wcstod(s, 0)
#endif

#ifndef _tcstod
#define _tcstod     wcstod
#endif

#ifndef _tcsncpy
#define _tcsncpy    wcsncpy
#endif

#ifndef _tcscspn
#define _tcscspn    wcscspn
#endif

#ifndef _tprintf
#define _tprintf    wprintf
#endif

#ifndef _sntprintf
#define _sntprintf  swprintf
#endif

#ifndef _vsntprintf
#define _vsntprintf vswprintf
#endif

#ifndef _ftprintf
#define _ftprintf   fwprintf
#endif

#ifndef _ttoi
#define _ttoi       _tstoi
#endif

#ifndef _fgetts
#define _fgetts     fgetws
#endif

#ifndef _vstprintf
#define _vstprintf  vwprintf
#endif

#ifndef _tmain
#define _tmain      main
#endif


//  bug:3692: printf-like string formatter spec
#define SZ_FMT      _T("%ls")

#endif


#ifdef WIN_FAMILY

//  bug:3692: printf-like string formatter spec
#define SZ_FMT      _T("%s")

#if !defined(snprintf) && !defined(HAVE_SNPRINTF)
#define HAVE_SNPRINTF
#define snprintf _snprintf_s
#define vsnprintf _vsnprintf
#endif

#endif


#ifdef UNICODE_VERSION
#define SZ_LOG_FMT  _TANSI("%ls")
#else
#define SZ_LOG_FMT  _TANSI("%s")
#endif


#ifdef UNIX_FAMILY
#define closesocket(a) close(a)

BEGIN_NAMESPACE_NEX
void _tcsupr(qChar* strString);
END_NAMESPACE_NEX
#endif


#endif
