﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _MultiMap_H_
#define _MultiMap_H_

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include <OnlineCore/src/Platform/Core/MemAllocator.h>

// STL compiles with level 4 warnings...
#ifdef WIN_FAMILY
#pragma warning( push, 1 )
#include <map>
#pragma warning( pop ) /* restore previous warning */
#else
#include <map>
#endif

BEGIN_NAMESPACE_NEX

//==============================================================================
// Inherits all operations from the std::multimap using the appropriate allocator.
//==============================================================================
template <typename Key, typename T> class qMultiMap
#if defined(STD_TREE_PAIR_ALLOCATOR_SUPPORT)
    : public std::multimap<Key, T, std::less<Key>, MemAllocator<std::pair<const Key,T> > >
#elif defined(ALLOCATOR_SUPPORT)
    : public std::multimap<Key, T, std::less<Key>, MemAllocator<T> >
#else
    : public std::multimap<Key, T>
#endif
{
};

END_NAMESPACE_NEX

#endif
