/*---------------------------------------------------------------------------*
  Copyright (C)2011-2014 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.
 *---------------------------------------------------------------------------*/

#ifndef _EndPointInfo_H_
#define _EndPointInfo_H_

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include <OnlineCore/src/Platform/Core/Time.h>
#include <OnlineCore/src/Platform/Core/ConnectionID.h>
#include <OnlineCore/src/Transport/Interface/NetFaults.h>
BEGIN_NAMESPACE_NEX
/* Please see man pages for details 
 
 
 
 
 
 */
struct EndPointInfo : public RootObject
{
    Time resetTime; //

    //Makes the connectionID the first of the primitive data types. See Reset.
    ConnectionID   connectionID;
    qByte          streamID; //
    qByte          sessionID;
    qByte          peerSessionID;
    NetFaultReason netFaultReason; //
    qUnsignedInt32 rtt; //
    qUnsignedInt32 rttAverage; //

    qUnsignedInt32 sendCount; //
    qUnsignedInt32 sendUnreliableCount; //
    qUnsignedInt32 sendUnreliableDataCount; //
    qUnsignedInt32 sendUnreliableBroadcastCount; //
    qUnsignedInt32 sendUnreliableSendMultiCount; //
    qUnsignedInt32 sendPingCount; //
    qUnsignedInt32 sendTimeoutCount; //
    qUnsignedInt32 sendDisconnectWaitCount; //
    qUnsignedInt32 sendUnreliableSizeOverCount; //

    qUnsignedInt32 sendTotalSize; //
    qUnsignedInt32 sendUnreliableTotalSize; //
    qUnsignedInt32 sendUnreliableDataTotalSize; //
    qUnsignedInt32 sendUnreliableBroadcastTotalSize; //
    qUnsignedInt32 sendUnreliableSendMultiTotalSize; //

    qUnsignedInt32 receiveUnreliableCount; //
    qUnsignedInt32 receiveUnreliableDataCount; //
    qUnsignedInt32 receiveUnreliableBroadcastCount; //
    qUnsignedInt32 receiveUnreliableSendMultiCount; //

    qUnsignedInt32 receiveUnreliableTotalSize; //
    qUnsignedInt32 receiveUnreliableDataTotalSize; //
    qUnsignedInt32 receiveUnreliableBroadcastTotalSize; //
    qUnsignedInt32 receiveUnreliableSendMultiTotalSize; //

    qUnsignedInt32 receivePingCount; //
    qUnsignedInt32 receiveAckWantedCount; //
    qUnsignedInt32 receiveUselessAckCount; //
    qUnsignedInt32 receiveUnreliableDropCount; //
    qUnsignedInt32 receiveUnreliableNeglectCount; //
    qUnsignedInt32 receiveUnreliableDuplicateReorderingCount; //

    qUnsignedInt32 sendReliableCount; //
    qUnsignedInt32 sendReliableTotalSize; //
    qUnsignedInt32 sendReliableFragCount; //
    qUnsignedInt32 sendReliableFailureCount; //
    qUnsignedInt32 sendReliableRetransmitCount; //
    qUnsignedInt32 sendReliableRetransmitTotalSize; //
    qUnsignedInt32 sendReliableRetransmitMax; //

    qUnsignedInt32 pushReliableCount; //
    qUnsignedInt32 pushReliableFailureCount; //

    qUnsignedInt32 receiveReliableCount; //
    qUnsignedInt32 receiveReliableTotalSize; //

    qUnsignedInt32 rtoMax; //
    qUnsignedInt32 rtoMin; //

    // For debugging
    qUnsignedInt32 sendPingLastSeqNo; // SeqNo of the last ping sent
    qUnsignedInt32 receivePingLastSeqNo; // SeqNo of the last ping received
    //Makes the receivePingLastSeqNo the last of the primitive data types. See Reset.



    EndPointInfo();

    /* Please see man pages for details 
     
     */
    void Reset();

    /* Please see man pages for details 
     
     
     
     
     */
    void Trace(EventLog::LogLevel logLevel = EventLog::Debug) const;
};

END_NAMESPACE_NEX
#endif /* _EndPointInfo_H_ */
