﻿/*---------------------------------------------------------------------------*
  Copyright (C)2011-2014 Nintendo Co., Ltd.  All rights reserved.
  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.
 *---------------------------------------------------------------------------
*/

#ifndef NEX_ONLINECORE_SRC_TRANSPORT_INTERFACE_JOBSTARTNATSESSION_H_
#define NEX_ONLINECORE_SRC_TRANSPORT_INTERFACE_JOBSTARTNATSESSION_H_

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include <OnlineCore/src/Platform/Core/NonCopyable.h>
#include <OnlineCore/src/Core/StepSequenceJob.h>
#include <OnlineCore/src/Core/CallContext.h>

BEGIN_NAMESPACE_NEX

class JobResolveRelayInfo;

class JobStartNATSession : public StepSequenceJob, public NonCopyable
{
public:
    static const qUnsignedInt32 DEFAULT_JOB_DELAY_INTERNAL_THREAD = 10;
    JobStartNATSession(CallContext* associatedCallContext);
    virtual ~JobStartNATSession();

    //Set a Job and start. When false, delete this object with RELEASEREF. When true, you do not need to delete it because Scheduler will do it.
    //The CallContext that can be retrieved using GetCallContext must already be initialized and registered to CallContextRegister before starting.
    qBool StartJob();

    void CompleteJob(const qResult& result);
    void StepReady();
    void StepCallCompletion();
    void StepDNSCallCompletion();
    void StepFinish();

    //After instantiating the CallContext object, it must be initialized using this GetCallContext function.
    CallContext* GetCallContext() { return &m_callContext;}


private:

    CallContext* m_AssociatedCallContext;
    CallContext m_callContext;
    qUnsignedInt32 m_AssociatedCallID;

    CallContext m_resolveRelayCallContext;
    JobResolveRelayInfo* m_pJobResloveRelayInfo;
    CallContext m_dnsResolveCallContext;

};

END_NAMESPACE_NEX


#endif /* NEX_ONLINECORE_SRC_TRANSPORT_INTERFACE_JOBSTARTRESOLVERELAYINFOCALLBACK_H_ */
