/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc. All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _OutputEmulationDevice_H_
#define _OutputEmulationDevice_H_

#include <OnlineCore/src/Transport/Interface/TransportDecl.h>
#include <OnlineCore/src/Transport/Interface/EmulationDevice.h>


BEGIN_NAMESPACE_NEX

//Group = Network Emulation

/*
Summary: This class defines an output EmulationDevice.
Remarks: An output emulation device object can be referenced using
RootTransport::GetOutputEmulationDevice. For example,

    RootTransport::GetInstance()->GetOutputEmulationDevice();

You must call EmulationDevice::Enable before using an emulation device.

The OutputEmulationDevice class has no specific methods of its own
but inherits all methods from the EmulationDevice class.

See Also: EmulationDevice, InputEmulationDevice, RootTransport, /Network Emulation/
in the /Net-Z User Guide/ for an example of how to use this class.
*/


/* Please see man pages for details 
 
 
 
 
 
 
 
 
 
 
 
 
 
 */

class OutputEmulationDevice: public EmulationDevice
{

};


END_NAMESPACE_NEX

#endif
