/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc. All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/
//n2788:

#ifndef _VirtualNetwork_H_
#define _VirtualNetwork_H_

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
//#include <Platform/Stack/Core/SocketDriver.h>
#include <OnlineCore/src/Transport/Interface/VirtualSocketDriver.h>

BEGIN_NAMESPACE_NEX

class TransportAdapter;

/* Please see man pages for details 


        
        
        

        
        
        
*/
class VirtualNetwork: public RootObject
{
public:
    /* Please see man pages for details 
    

            

            
            

            
            
    */
    VirtualNetwork() {};

    /* Please see man pages for details 
    

            

            
            
    */
    virtual ~VirtualNetwork() {};

    virtual TransportAdapter* GetTransportAdapter()=0;
    virtual void DestroyTransportAdapter()=0;

    virtual qBool ReceiveFrom(
        qByte* pBuffer,
        qUnsignedInt uiBufferSize,
        SocketDriver::InetAddress* pSourceAddress,
        qUnsignedInt* puiNbBytesRecvd,
        SocketDriver::SocketFlag flags = SocketDriver::NonBlock
    )=0;

    virtual qBool SendTo(
        qByte* pBuffer,
        qUnsignedInt uiBufferSize,
        const SocketDriver::InetAddress &refDestinationAddress,
        qUnsignedInt* puiNbBytesSent
    )=0;

    virtual qBool Shutdown()=0;

    virtual VirtualMessageIn* ProcessReceiveMessage()=0;
    virtual qBool HandlingMessage(
        VirtualMessageIn* pMessage,
        SocketDriver::InetAddress* pSourceAddress
    )=0;

    virtual qUnsignedInt16 GetReceivePort()=0;

    virtual qBool CanBecomeSessionMaster()=0;
    virtual qBool CanBecomeSessionClient()=0;

    virtual qBool IsFatalReliableSendBufferFull(NODE_ID_TYPE nodeId) = 0;
    virtual qBool IsDisconnected()const
    {
        return false;
    }
};

END_NAMESPACE_NEX

#endif
