﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc. All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

// n2370
//#ifndef _PacketIn_H
#ifndef _PacketIn_H_
#define _PacketIn_H_

#include <OnlineCore/src/Transport/Interface/TransportDecl.h>
#include <OnlineCore/src/Transport/UDP/Packet.h>
#include <OnlineCore/src/Core/ByteStream.h>
#include <OnlineCore/src/Core/FixedSizePooledObject.h>

BEGIN_NAMESPACE_NEX

class PacketIn: public Packet
{

    DEFINE_FIXED_SIZE_POOLED_OBJECT(PacketIn, 64);

public:

    PacketIn();
    virtual ~PacketIn() {}


#ifdef TRACE_ENABLED    // n2370
    virtual void Trace(qUnsignedInt64 uiTraceFlags = D_TRACE_TRANSPORT_PACKET)
    {
        TraceImpl(uiTraceFlags, true);
    }
#endif  // TRACE_ENABLED

#ifdef TEST_ENABLED
    static qBool Test();
#endif

#ifdef NEX_CLIENT_PBPOOL // Client only.
    /* 
     
            
     */
    qBool IsValid()
    {
        if (!GetPayload() || !GetPayload()->IsValid())
        {
            // In spite of the constructor specifying qNew PacketBuffer, neither PacketBuffer itself nor its payload buffer exists. (Buffer depleted)
            QTRACE(D_TRACE_MEMORY, _T("PacketIn::IsValid() false"));
            return false;
        }

        return true;
    }
#endif // NEX_CLIENT_PBPOOL
};

END_NAMESPACE_NEX

#endif
