﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _TicketManager_H
#define _TicketManager_H

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include <OnlineCore/src/Platform/Core/qMap.h>
#include <OnlineCore/src/Platform/Core/PrincipalID.h>
#include <OnlineCore/src/Core/CallContextRegister.h>
#include <RendezVous/Core/src/Common/TicketGrantingProtocolDDL.h>
#include <RendezVous/Core/src/Common/Ticket.h>
#include <RendezVous/Core/src/Common/DataHolder.h>
#include <RendezVous/Core/src/Client/BackEndServices.h>

BEGIN_NAMESPACE_NEX

class ConnectionManager;
class QuazalAuthenticationPlugin;
class AuthenticationClient;

class OSDK_API TicketManager: public RootObject
{
public:
    TicketManager(AuthenticationClient *pClient);
    ~TicketManager();

    qBool Login(CallContext *pContext, qResult *pqResult, const String& strName, const qChar8* szPassword,
                PrincipalID *pidSource, RVConnectionData* pConnectionData, String* pstrReturnMsg, DataHolder *pAnyData);

    qBool LoginWithData(CallContext *pContext, qResult *pqResult, const qChar8* szPassword, PrincipalID *pidSource,
                        RVConnectionData* pConnectionData, LoginDataHolder* ploginData);

    qBool AcquireTicket(CallContext *pContext, PrincipalID idMyself, PrincipalID idTarget, Ticket** ppTicket);

    Ticket* FindTicket(PrincipalID pid);
    void InsertTicket(PrincipalID pid, Ticket* pTicket);

    void ReleaseTicket(Ticket* pTicket);

    AuthenticationClient* GetAuthenticationClient()
    {
        return m_pClient;
    };

private:
    OSDK_DISABLE_EXPORT_WARNING(qMap<PrincipalID, Ticket*> m_mapTickets);
    AuthenticationClient *m_pClient;
};

END_NAMESPACE_NEX

#endif

