﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _NATCheckClient_H_
#define _NATCheckClient_H_

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include <OnlineCore/src/Platform/Stack/Core/InetAddress.h>
#include <OnlineCore/src/Transport/Interface/StationURL.h>

BEGIN_NAMESPACE_NEX

// Forward declarations
class CallContext;
class NATRelayInterface;

class NATCheckClient: public RootObject
{
    // Methods
public:
    NATCheckClient();
    NATCheckClient(const InetAddress &rInterfaceAddress);
    ~NATCheckClient();

    qBool DetectFullNATProperties(CallContext *pCallContext);
    qBool DetectSimplifiedNATProperties(CallContext *pCallContext);
    qBool DetectNATCurrentPortMapping(CallContext *pCallContext, qBool bPublicPortIncremental);

    // Data members
private:
    InetAddress m_oInterfaceAddress;
};

END_NAMESPACE_NEX

#endif //-- #ifndef _NATCheckClient_H_
