﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _KeyDerivation_H
#define _KeyDerivation_H

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include <OnlineCore/src/Platform/Core/PrincipalID.h>

#ifdef DEBUG_VERSION
#include <OnlineCore/src/Core/Key.h>
#endif


BEGIN_NAMESPACE_NEX

class Key;
class KeyCache;
class CallContext;

class OSDK_API KeyDerivation: public RootObject
{
public:
    KeyDerivation() {}
    virtual ~KeyDerivation() {}
    virtual Key CreateKey(PrincipalID id, const qChar8* szPassword)=0;
    virtual Key InitializeKey(const qChar8* szPassword)=0;
    virtual Key FinalizeKey(PrincipalID id, const Key & oPartialKey)=0;

    // async equivalent
    virtual qBool CreateKey(CallContext* pCallContext, PrincipalID id, const qChar8* szPassword, Key* pkeyResult,KeyCache* pKeyCache=NULL)=0;
    virtual qBool InitializeKey(CallContext* pCallContext, const qChar8* szPassword, Key* pkeyResult)=0;
    virtual qBool FinalizeKey(CallContext* pCallContext, PrincipalID id, const Key & oPartialKey, Key* pkeyResult)=0;
};

END_NAMESPACE_NEX

#endif // _KeyDerivation_H

