﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc.  All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _MessageRecipient_H
#define _MessageRecipient_H

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include <OnlineCore/src/Platform/Core/PrincipalID.h>
#include <RendezVous/Core/src/Common/MessageRecipientDDL.h>
#include <RendezVous/Core/src/Common/Constants/IdentifierTypes.h>


BEGIN_NAMESPACE_NEX


class OSDK_API DDLCLASS(MessageRecipient);
class OSDK_API MessageRecipient: public DDLCLASS(MessageRecipient)
{

public:
    /** \brief Default constructor. */
    MessageRecipient()
    {
        m_idRecipient = 0;
        m_uiRecipientType = static_cast<qUnsignedInt32>( IdentifierTypes::InvalidType );
    }

    MessageRecipient(qUnsignedInt32 uiRecipientType, qUnsignedInt32 uiRecipientId)
    {
        SYSTEMCHECK((uiRecipientType==IdentifierTypes::PIDType) || (uiRecipientType==IdentifierTypes::GIDType));
        m_idRecipient = uiRecipientId;
        m_uiRecipientType = uiRecipientType;
    }

    qUnsignedInt32 GetRecipientID() const
    {
        return m_idRecipient;
    }

    void SetRecipientID(qUnsignedInt32 uiID)
    {
        m_idRecipient = uiID;
    }
    qUnsignedInt32 GetRecipientType() const
    {
        return (m_uiRecipientType);
    }

    void SetRecipientType(qUnsignedInt32 uiType)
    {
        m_uiRecipientType = uiType;
    }

    void Trace(qUnsignedInt64 uiTraceFlags)
    {
        DUMMY_PARAM(uiTraceFlags);
        QTRACE(uiTraceFlags, _T("MessageRecipient (ID=") << m_idRecipient << _T(", Type") << m_uiRecipientType);
    }

};


END_NAMESPACE_NEX

#endif
