#ifndef _Quazal_MonitoringProtocolDDL_H_
#define _Quazal_MonitoringProtocolDDL_H_
#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma push
#pragma diag_suppress 228,381,550,1300,1301,2530
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)


#include <OnlineCore/src/DDLTypes/CGCoreExports.h>

#include <RendezVous/Core/src/Common/ClientProtocol.h>
#include <RendezVous/Core/src/Common/ServerProtocol.h>
#include <OnlineCore/src/Core/CallContextRegister.h>
#include <RendezVous/Core/src/Common/ProtocolCGMacros.h>
#include <RendezVous/Core/src/Common/ProtocolCallContext.h>
#include <RendezVous/Core/src/Common/ProtocolRequestBrokerInterface.h>
#include <RendezVous/Core/src/Common/Protocol.h>
#include <RendezVous/Core/src/Common/ProtocolList.h>
#include <OnlineCore/src/Transport/Interface/TransportError.h>
#include <RendezVous/Core/src/Client/RVClientCore.h>
#include <RendezVous/Core/src/Client/ProtocolRegistry.h>
#include "OnlineCore/src/DDLTypes/OnlineCoreTypes.h"
#include "OnlineCore/src/DDLTypes/STLExtTypes.h"

BEGIN_NAMESPACE_NEX

PROTO_DEFINE_RMCID(MonitoringProtocol, PingDaemon, 1 );
PROTO_DEFINE_RMCID(MonitoringProtocol, GetClusterMembers, 2 );
PROTO_DEFINE_NUM_RMC(MonitoringProtocol, 2);

class MonitoringProtocolClient : public ClientProtocol {
    public:
        typedef DDLTYPE(bool) TPingDaemon_result;
        PROTO_RMCIMPL_RETURN(MonitoringProtocol, PingDaemon)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TPingDaemon_result,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(std_list)< DDLTYPE(string) > TGetClusterMembers_strValues;
        PROTO_RMCIMPL_RETURN(MonitoringProtocol, GetClusterMembers)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetClusterMembers_strValues,1);
            PROTO_RETURNSTUB_END();
        };
        
        MonitoringProtocolClient(ProtocolID uiProtocolID=ProtocolList::Unknown);
        virtual ClientProtocol* CreateResponder() const { return qNew MonitoringProtocolClient(); }
        virtual void ExtractCallSpecificResults(Message *pMessage, ProtocolCallContext* pContext);
        
        qBool CallPingDaemon(ProtocolCallContext *pContext, DDLTYPE(bool)::CPPType *pReturn);
        static qBool PingDaemon_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(bool)::CPPType *pReturn);
        qBool CallGetClusterMembers(ProtocolCallContext *pContext, DDLTYPE(std_list)< DDLTYPE(string) >::CPPType* strValues);
        static qBool GetClusterMembers_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(std_list)< DDLTYPE(string) >::CPPType* strValues);
        
        protected:
        static ProtoReturnFunction s_protoReturnFunctions[PROTO_NUM_RMC(MonitoringProtocol) + 1];
};

class DDLPROTOCOL(MonitoringProtocolServer) : public ServerProtocol {
    public:
        typedef DDLTYPE(bool) TPingDaemon_result;
        PROTO_RMCIMPL_STUB(MonitoringProtocol, PingDaemon)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(bool)::CPPType __result=pProtocol->PingDaemon(  );
            PROTO_PREPARE_RETURN(MonitoringProtocol,PingDaemon);
            _MSG_ADD_VARIABLE(TPingDaemon_result,__result);
        }
        
        typedef DDLTYPE(std_list)< DDLTYPE(string) > TGetClusterMembers_strValues;
        PROTO_RMCIMPL_STUB(MonitoringProtocol, GetClusterMembers)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(std_list)< DDLTYPE(string) >::CPPType strValues;
            pProtocol->GetClusterMembers( &strValues );
            PROTO_PREPARE_RETURN(MonitoringProtocol,GetClusterMembers);
            _MSG_ADD_VARIABLE(TGetClusterMembers_strValues, strValues);
        }
        
        private:
        // Call this function with a message previously generated by a
        // <RMC name>_PrepareRequest() call to have it dispatched to the correct RMC.
        virtual void DispatchProtocolMessage( Message *pMessage, Message *pReturnMessage, qBool *boReturnsMessage, EndPoint *pEndPoint);
        public:
        
        virtual DDLTYPE(bool)::CPPType PingDaemon() = 0;
        virtual void GetClusterMembers(DDLTYPE(std_list)< DDLTYPE(string) >::CPPType* strValues) = 0;
    };


END_NAMESPACE_NEX

#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma pop
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#endif // _Quazal_MonitoringProtocolDDL.h_H_
