#ifndef _Quazal_PropertyDDL_H_
#define _Quazal_PropertyDDL_H_
#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma push
#pragma diag_suppress 228,381,550,1300,1301,2530
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)

#include <OnlineCore/src/DDLTypes/CGCoreExports.h>
#include "OnlineCore/src/DDLTypes/OnlineCoreTypes.h"

BEGIN_NAMESPACE_NEX
class Property;
END_NAMESPACE_NEX

BEGIN_NAMESPACE_NEX

class DDLCLASS(Property): public RootObject {
public:
    DDLCLASS(Property)():_mRevision_Property(0)
     {};
    DDLCLASS(Property)(const DDLCLASS(Property) &oOther):
        RootObject(oOther),
        _mRevision_Property(oOther._mRevision_Property),
        m_ID(oOther.m_ID),
        m_value(oOther.m_value)
    {
    }
    virtual ~DDLCLASS(Property)() {};
    const DDLCLASS(Property) &operator=(const DDLCLASS(Property) &oOther);
    qBool operator==(const DDLCLASS(Property) &oOther) const;
    #ifdef OSDK_DLL_SUPPORT
    qBool operator<(const DDLCLASS(Property) &oOther) const;
    #endif
    static void Add(Message *pMessageToSend, const DDLCLASS(Property) &oValue);
    static void Extract(Message *pReceivedMessage, DDLCLASS(Property) *pValue);
    qByte _mRevision_Property;
    qByte GetClassRevision_Property() const {return _mRevision_Property;}
    void SetClassRevision_Property(qByte revision) {_mRevision_Property=revision;}
    static qByte GetKnownMaxClassRevision_Property() {return 0;}
    DDLTYPE(uint32)::CPPType m_ID;
    NEX_CLASS_VALID_REVISION_DEF(m_ID, 0);
    qBool NEX_CLASS_ISVALID(m_ID) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(int32)::CPPType m_value;
    NEX_CLASS_VALID_REVISION_DEF(m_value, 0);
    qBool NEX_CLASS_ISVALID(m_value) const { return true; /* The revision is 0. Always true */}
};


class DDLTYPE(Property): public DDLType {
public:
    typedef Property CPPType;
    static void Add(Message* pMessageToSend, const DDLCLASS(Property)& oProperty) {
        DDLCLASS(Property)::Add(pMessageToSend,oProperty);
    }
    static void Extract(Message* pReceivedMessage, DDLCLASS(Property)* pPropertyToRefresh) {
        DDLCLASS(Property)::Extract(pReceivedMessage,pPropertyToRefresh);
    }
};


END_NAMESPACE_NEX

#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma pop
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#endif // _Quazal_PropertyDDL.h_H_
