﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc. All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _ProtocolFoundationProperties_H_
#define _ProtocolFoundationProperties_H_

// The class name has been put into CLASS and *DDL.cpp is created with PropertyCG::GeneratePublicDecl.
#define _PR_dataclass_methods_pudecl(CLASS)          \
    virtual Data* Clone() const;        \
    virtual String GetDataType() const;                 \
    virtual qBool IsA(const String& strClass) const;                    \
    virtual qBool IsAKindOf(const String& strClass) const;                  \
    virtual void StreamIn(Message* pMessageToSend) const;       \
    virtual void StreamOut(Message* pReceivedMessage); \
    static CLASS* DynamicCast(Data* pData); \
    static const CLASS* DynamicCast(const Data* pData);

#define _PR_dataclass_methods_prdecl()

// Base/derivative class common.
#define _dataclass_methods_common_impl(CLASS)   \
    Data* DDLCLASS(CLASS)::Clone() const {Data *pData = qNew CLASS; ((DDLCLASS(CLASS) &)*pData) = *this; return pData;}     \
    String DDLCLASS(CLASS)::GetDataType() const {return _T(#CLASS);}            \
    qBool DDLCLASS(CLASS)::IsA(const String& strClass) const {return strClass==_T(#CLASS);} \
    void DDLCLASS(CLASS)::StreamIn(Message* pMessageToSend) const {CLASS::Add(pMessageToSend, *this);} \
    void DDLCLASS(CLASS)::StreamOut(Message* pReceivedMessage) {CLASS::Extract(pReceivedMessage, this);} \
    CLASS* DDLCLASS(CLASS)::DynamicCast(Data* pData) \
    {if (pData!=NULL && pData->IsAKindOf(_T(#CLASS))) {return reinterpret_cast<CLASS*>(pData);} else {return NULL;}}        \
    const CLASS* DDLCLASS(CLASS)::DynamicCast(const Data* pData)           \
    {if (pData!=NULL && pData->IsAKindOf(_T(#CLASS))) {return reinterpret_cast<const CLASS*>(pData);} else {return NULL;}}

// For the base class.
#define _PR_dataclass_methods_impl(CLASS)   \
    _dataclass_methods_common_impl(CLASS) \
    qBool DDLCLASS(CLASS)::IsAKindOf(const String& strClass) const {return strClass==_T(#CLASS);}

// For the derivative class.
#define _PR_dataclass_methods_derived_impl(CLASS,PARENT)    \
    _dataclass_methods_common_impl(CLASS) \
    qBool DDLCLASS(CLASS)::IsAKindOf(const String& strClass) const {return strClass==_T(#CLASS) || DDLCLASS(PARENT)::IsAKindOf(strClass);}


#endif

