#ifndef _Quazal_AuthenticationInfoDDL_H_
#define _Quazal_AuthenticationInfoDDL_H_
#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma push
#pragma diag_suppress 228,381,550,1300,1301,2530
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)

#include <OnlineCore/src/DDLTypes/CGCoreExports.h>
#include "RendezVous/Core/src/Common/ProtocolFoundationProperties.h"
#include "RendezVous/Core/src/Common/Data.h"
#include "OnlineCore/src/DDLTypes/OnlineCoreTypes.h"

BEGIN_NAMESPACE_NEX
class AuthenticationInfo;
END_NAMESPACE_NEX

BEGIN_NAMESPACE_NEX

class DDLCLASS(AuthenticationInfo): public Data {
public:
    DDLCLASS(AuthenticationInfo)():_mRevision_AuthenticationInfo(0)
     {};
    DDLCLASS(AuthenticationInfo)(const DDLCLASS(AuthenticationInfo) &oOther):
        Data(oOther),
        _mRevision_AuthenticationInfo(oOther._mRevision_AuthenticationInfo),
        m_authToken(oOther.m_authToken),
        m_ngsVersion(oOther.m_ngsVersion),
        m_base64type(oOther.m_base64type),
        m_serverVersion(oOther.m_serverVersion)
    {
    }
    virtual ~DDLCLASS(AuthenticationInfo)() {};
    const DDLCLASS(AuthenticationInfo) &operator=(const DDLCLASS(AuthenticationInfo) &oOther);
    qBool operator==(const DDLCLASS(AuthenticationInfo) &oOther) const;
    #ifdef OSDK_DLL_SUPPORT
    qBool operator<(const DDLCLASS(AuthenticationInfo) &oOther) const;
    #endif
    static void Add(Message *pMessageToSend, const DDLCLASS(AuthenticationInfo) &oValue);
    static void Extract(Message *pReceivedMessage, DDLCLASS(AuthenticationInfo) *pValue);
    qByte _mRevision_AuthenticationInfo;
    qByte GetClassRevision_AuthenticationInfo() const {return _mRevision_AuthenticationInfo;}
    void SetClassRevision_AuthenticationInfo(qByte revision) {_mRevision_AuthenticationInfo=revision;}
    static qByte GetKnownMaxClassRevision_AuthenticationInfo() {return 0;}
    DDLTYPE(string)::CPPType m_authToken;
    NEX_CLASS_VALID_REVISION_DEF(m_authToken, 0);
    qBool NEX_CLASS_ISVALID(m_authToken) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(uint32)::CPPType m_ngsVersion;
    NEX_CLASS_VALID_REVISION_DEF(m_ngsVersion, 0);
    qBool NEX_CLASS_ISVALID(m_ngsVersion) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(byte)::CPPType m_base64type;
    NEX_CLASS_VALID_REVISION_DEF(m_base64type, 0);
    qBool NEX_CLASS_ISVALID(m_base64type) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(uint32)::CPPType m_serverVersion;
    NEX_CLASS_VALID_REVISION_DEF(m_serverVersion, 0);
    qBool NEX_CLASS_ISVALID(m_serverVersion) const { return true; /* The revision is 0. Always true */}
    public:
	_PR_dataclass_methods_pudecl(AuthenticationInfo)
    protected:
	_PR_dataclass_methods_prdecl()
};


class DDLTYPE(AuthenticationInfo): public DDLType {
public:
    typedef AuthenticationInfo CPPType;
    static void Add(Message* pMessageToSend, const DDLCLASS(AuthenticationInfo)& oAuthenticationInfo) {
        DDLCLASS(AuthenticationInfo)::Add(pMessageToSend,oAuthenticationInfo);
    }
    static void Extract(Message* pReceivedMessage, DDLCLASS(AuthenticationInfo)* pAuthenticationInfoToRefresh) {
        DDLCLASS(AuthenticationInfo)::Extract(pReceivedMessage,pAuthenticationInfoToRefresh);
    }
};


END_NAMESPACE_NEX

#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma pop
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#endif // _Quazal_AuthenticationInfoDDL.h_H_
