﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc. All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef DATASTORE_LOGICSERVER_CLIENT_H__
#define DATASTORE_LOGICSERVER_CLIENT_H__

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include <RendezVous/Core/src/Client/ServiceClient.h>
#include <RendezVous/Services/Jugem/DataStore/src/Common/DataStoreDDF.h>
#include <RendezVous/Services/Jugem/DataStore/src/Common/DataStoreProtocolDDL.h>
#include <RendezVous/Services/Jugem/DataStore/src/Common/DataStoreConstants.h>
#include <RendezVous/Services/Jugem/DataStore/src/Client/DataStoreLogicServerClientInterface.h>

BEGIN_NAMESPACE_NEX

/* Please see man pages for details 
    
*/
class DataStoreLogicServerClient : public ServiceClient, public DataStoreLogicServerClientInterface
{
public:
    /* Please see man pages for details 
        
        
    */
    DataStoreLogicServerClient();

    /* Please see man pages for details 
        
        
    */
    virtual ~DataStoreLogicServerClient();

    void UpdateProtocolsDefaultCredentials(Credentials* pCredentials);

    /* Please see man pages for details 
        

        

        
    */
    virtual qBool Bind(Credentials* pCredentials);

    /* Please see man pages for details 
        

        
    */
    virtual qBool Unbind();

    /* Please see man pages for details 
        
        

        
        
        

        
        
    */
    virtual qBool PrepareGetObject(ProtocolCallContext *pContext, const DataStorePrepareGetParam& param, DataStoreReqGetInfo* pReqGetInfo);

    /* Please see man pages for details 
        
        

        
        
        

        
        
    */
    virtual qBool PrepareGetObject(ProtocolCallContext *pContext, const DataStorePrepareGetParamV1& param, DataStoreReqGetInfoV1* pReqGetInfo);

    /* Please see man pages for details 
        
        

        
        
        
        

        
        
    */
    virtual qBool PrepareGetObjectOrMetaBinary(ProtocolCallContext *pContext, const DataStorePrepareGetParam& param, DataStoreReqGetInfo* pReqGetInfo, DataStoreReqGetAdditionalMeta* pReqGetAdditionalMeta);

    /* Please see man pages for details 
        
        

        
        
        
        

        
        
    */
    virtual qBool PrepareGetObjectOrMetaBinary(ProtocolCallContext *pContext, const DataStorePrepareGetParamV1& param, DataStoreReqGetInfoV1* pReqGetInfo, DataStoreReqGetAdditionalMeta* pReqGetAdditionalMeta);

    /* Please see man pages for details 
        
        

        
        
        

        
        
    */
    virtual qBool PreparePostObject(ProtocolCallContext *pContext, const DataStorePreparePostParam& param, DataStoreReqPostInfo* pReqPostInfo);

    /* Please see man pages for details 
        
        

        
        
        

        
        
    */
    virtual qBool PreparePostObject(ProtocolCallContext *pContext, const DataStorePreparePostParamV1& param, DataStoreReqPostInfoV1* pReqPostInfo);

    /* Please see man pages for details 
        
        

        
        

        
        
    */
    virtual qBool CompletePostObject(ProtocolCallContext *pContext, const DataStoreCompletePostParam& param);

    /* Please see man pages for details 
        
        

        
        

        
        
    */
    virtual qBool CompletePostObject(ProtocolCallContext *pContext, const DataStoreCompletePostParamV1& param);

    /* Please see man pages for details 
        

            
            
            
            
            
            
            
            
            
            
            

        
        
                    

        
        
    */
    virtual qBool CompleteSuspendedPostObject(ProtocolCallContext* pContext, const qVector<qUnsignedInt64>& dataIds);

    /* Please see man pages for details 
        
        

        
        
        

        
        
    */
    virtual qBool PostMetaBinary(ProtocolCallContext *pContext, const DataStorePreparePostParam& param, qUnsignedInt64* pDataId);

    /* Please see man pages for details 
        
        

        
        
        

        
        
    */
    virtual qBool PostMetaBinaryWithDataId(ProtocolCallContext *pContext, const qUnsignedInt64 dataId, const DataStorePreparePostParam& param);

    /* Please see man pages for details 
        
        

        
        
        
        
        

        
        
    */
    virtual qBool PostMetaBinaryWithDataIds(ProtocolCallContext *pContext, const qVector< qUnsignedInt64 >& dataIds, const DataStorePreparePostParam& param, const qBool transactional = true, qVector<qResult>* pResults = NULL);

    /* Please see man pages for details 
        
        

        
        
        
        

        
        
    */
    virtual qBool PostMetaBinariesWithDataId(ProtocolCallContext *pContext, const qVector< std::pair<qUnsignedInt64, DataStorePreparePostParam> >& params, const qBool transactional = true, qVector<qResult>* pResults = NULL);

    /* Please see man pages for details 
        
        

        
        
        

        
        
    */
    virtual qBool PrepareUpdateObject(ProtocolCallContext *pContext, const DataStorePrepareUpdateParam& param, DataStoreReqUpdateInfo* pReqUpdateInfo);

    /* Please see man pages for details 
        
        

        
        

        
        
    */
    virtual qBool CompleteUpdateObject(ProtocolCallContext *pContext, const DataStoreCompleteUpdateParam& param);

    /* Please see man pages for details 
        

            
            

        
        

        
        
    */
    virtual qBool DeleteObject(ProtocolCallContext *pContext, const DataStoreDeleteParam& param);

    /* Please see man pages for details 
        

            
            
            

        
        

        
        
    */
    virtual qBool DeleteObject(ProtocolCallContext *pContext, const qUnsignedInt64& dataId);

    /* Please see man pages for details 
        

            
            
            
            

        
        
        
        

        
        
    */
    virtual qBool DeleteObject(ProtocolCallContext *pContext, const qVector<DataStoreDeleteParam>& params, const qBool transactional = true,  qVector<qResult>* pResults = NULL);

    /* Please see man pages for details 
        

            
            
            
            
            

        
        
        
        

        
        
    */
    virtual qBool DeleteObject(ProtocolCallContext *pContext, const qVector<qUnsignedInt64>& dataIds, const qBool transactional = true, qVector<qResult>* pResults = NULL);

    /* Please see man pages for details 
        

            

            
            

        
        

        
        
    */
    virtual qBool ChangeMeta(ProtocolCallContext *pContext, const DataStoreChangeMetaParam& param);

    /* Please see man pages for details 
        
        

            
            

        
        

        
        
    */
    virtual qBool ChangeMeta(ProtocolCallContext *pContext, const DataStoreChangeMetaParamV1& param);

    /* Please see man pages for details 
        

            
            
            
            
            
            

            

        
        
        
        
        

        
        
    */
    virtual qBool ChangeMeta(ProtocolCallContext *pContext, const qVector<qUnsignedInt64>& dataIds, const DataStoreChangeMetaParam& param, const qBool transactional = true, qVector<qResult>* pResults = NULL);

    /* Please see man pages for details 
        
        

            
            
            
            
            
            

        
        
        
        
        

        
        
    */
    virtual qBool ChangeMeta(ProtocolCallContext *pContext, const qVector<qUnsignedInt64>& dataIds, const DataStoreChangeMetaParamV1& param, const qBool transactional = true, qVector<qResult>* pResults = NULL);

    /* Please see man pages for details 
        

            
            
            
            
            

            

        
        
        
        

        
        
    */
    virtual qBool ChangeMeta(ProtocolCallContext *pContext, const qVector<DataStoreChangeMetaParam>& params, const qBool transactional = true, qVector<qResult>* pResults = NULL);

    /* Please see man pages for details 
        
        

            
            
            
            
            

        
        
        
        

        
        
    */
    virtual qBool ChangeMeta(ProtocolCallContext *pContext, const qVector<DataStoreChangeMetaParamV1>& params, const qBool transactional = true, qVector<qResult>* pResults = NULL);

    /* Please see man pages for details 
        

       

            
            
            

        
        
        

        
        
    */
    virtual qBool GetMeta(ProtocolCallContext *pContext, const DataStoreGetMetaParam& param, DataStoreMetaInfo* pMetaInfo);

    /* Please see man pages for details 
        

        

            
            
            
            
            
            
            
            
            

        
        
        
        
        

        
        
    */
    virtual qBool GetMeta(ProtocolCallContext *pContext, const qVector<qUnsignedInt64>& dataIds, const DataStoreGetMetaParam& param, qVector<DataStoreMetaInfo>* pMetaInfos, qVector<qResult>* pResults = NULL);

    /* Please see man pages for details 
        

        

            
            
            
            
            
            
            

        
        
        
        

        
        
    */
    virtual qBool GetMeta(ProtocolCallContext *pContext, const qVector<DataStoreGetMetaParam>& params, qVector<DataStoreMetaInfo>* pMetaInfos, qVector<qResult>* pResults = NULL);

    /* Please see man pages for details 
        

            

        
        
        

        
        
    */
    virtual qBool SearchObject(ProtocolCallContext *pContext, const DataStoreSearchParam& param, DataStoreSearchResult* pSearchResult);

    /* Please see man pages for details 
        
        

        
        
        

        
        
    */
    virtual qBool GetNotificationUrl(ProtocolCallContext *pContext, const DataStoreGetNotificationUrlParam& param, DataStoreReqGetNotificationUrlInfo* info);

    /* Please see man pages for details 
        
        

        
        
        
        

        
        
    */
    virtual qBool GetNewArrivedNotifications(ProtocolCallContext *pContext, const DataStoreGetNewArrivedNotificationsParam& param, qVector<DataStoreNotification>* pResult, qBool* pHasNext);

    /* Please see man pages for details 
        
        

        
        
        
        

        
        
    */
    virtual qBool GetNewArrivedNotifications(ProtocolCallContext *pContext, const DataStoreGetNewArrivedNotificationsParam& param, qVector<DataStoreNotificationV1>* pResult, qBool* pHasNext);

    /* Please see man pages for details 
        

        

            
            
            
            
            
            

        
        
        
        

        
        
    */
    virtual qBool RateObject(ProtocolCallContext* pContext, const DataStoreRatingTarget& target, const DataStoreRateObjectParam& param, DataStoreRatingInfo* pRating);

    /* Please see man pages for details 
        

        

            
            
            

            
            
            
            
            
            

        
        
        
        
        
        

        
        
    */
    virtual qBool RateObject(ProtocolCallContext* pContext, const qVector<DataStoreRatingTarget>& targets, const DataStoreRateObjectParam& param,
        const qBool transactional=true, qVector<DataStoreRatingInfo>* pRatings=NULL, qVector<qResult>* pResults=NULL);

    /* Please see man pages for details 
        

        

            
            
            
            

            
            
            
            
            
            

        
        
        
        
        
        

        
        
    */
    virtual qBool RateObject(ProtocolCallContext* pContext, const qVector<DataStoreRatingTarget>& targets, const qVector<DataStoreRateObjectParam> & params,
        const qBool transactional=true, qVector<DataStoreRatingInfo>* pRatings=NULL, qVector<qResult>* pResults=NULL);




    /* Please see man pages for details 
        

            
            

        
        
        
        

        
        
    */
    virtual qBool GetRating(ProtocolCallContext* pContext, const DataStoreRatingTarget& target, DataStoreRatingInfo* pRating, qUnsignedInt64 accessPassword=DataStoreConstants::INVALID_PASSWORD);

    /* Please see man pages for details 
        
        

            
            

        
        
        
        
        

        
        
    */
    virtual qBool GetRating(ProtocolCallContext* pContext, const qVector<qUnsignedInt64>& dataIds, qVector< qVector< DataStoreRatingInfoWithSlot > > *pRatings,
                            qVector<qResult>* pResults=NULL, qUnsignedInt64 accessPassword=DataStoreConstants::INVALID_PASSWORD);



    /* Please see man pages for details 
       
	   
        

            
            
            
            

            
            
            

            
            
            
            

        
        
        
        
        
        
        

        
        

        
    */
    virtual qBool RateObjectsWithPosting(ProtocolCallContext* pContext,
            const qVector<DataStoreRatingTarget>& targets,
            const qVector<DataStoreRateObjectParam> & rateParams,
            const qVector<DataStorePostParam> & postParams,
            qBool transactional=true, qVector<DataStoreRatingInfo>* pRatings=NULL, qVector<qResult>* pResults=NULL);

    /* Please see man pages for details 
       
        
		

            
            
            

            
            
            

            
            
            
            

        
        
        
        
        
        
        

        
        

        
    */
    virtual qBool RateObjectsWithPosting(ProtocolCallContext* pContext,
            const qVector<DataStoreRatingTarget>& targets,
            const DataStoreRateObjectParam& rateParam,
            const DataStorePostParam& postParam,
            qBool transactional=true, qVector<DataStoreRatingInfo>* pRatings=NULL, qVector<qResult>* pResults=NULL);

    /* Please see man pages for details 
        

            
            
            
            

            
            
            
            

        
        
        
        
        

        
        

        
    */
    virtual qBool RateObjectWithPosting(ProtocolCallContext* pContext,
            const DataStoreRatingTarget& target,
            const DataStoreRateObjectParam& rateParam,
            const DataStorePostParam& postParam,
            DataStoreRatingInfo* pRating=NULL);


    /* Please see man pages for details 
        

        

            
            

        
        
        

        
        
    */
    virtual qBool ResetRating(ProtocolCallContext* pContext, const DataStoreRatingTarget& target, qUnsignedInt64 updatePassword=DataStoreConstants::INVALID_PASSWORD);

    /* Please see man pages for details 
        

        

            
            

        
        

        
        
    */
    virtual qBool ResetRating(ProtocolCallContext* pContext, const qUnsignedInt64& dataId);

    /* Please see man pages for details 
        

        

            
            
            
            

        
        
        
        

        
        
    */
    virtual qBool ResetRating(ProtocolCallContext* pContext, const qVector<qUnsignedInt64>& dataIds, const qBool transactional = true,  qVector<qResult>* pResults = NULL);

    /* Please see man pages for details 
        
        

        
        
        

        
        
    */
    virtual qBool GetSpecificMeta(ProtocolCallContext* pContext, const DataStoreGetSpecificMetaParam& param, qVector<DataStoreSpecificMetaInfo>* pMetaInfos);

    /* Please see man pages for details 
        
        

        
        
        

        
        
    */
    virtual qBool GetSpecificMeta(ProtocolCallContext* pContext, const DataStoreGetSpecificMetaParamV1& param, qVector<DataStoreSpecificMetaInfoV1>* pMetaInfos);

    /* Please see man pages for details 
        

            
            
            

        
        

        
        
    */
    virtual qBool TouchObject(ProtocolCallContext *pContext, const DataStoreTouchObjectParam& param);

    /* Please see man pages for details 
        
        

            

        
        
        
        
        

        
        
    */
    virtual qBool GetRatingWithLog(ProtocolCallContext* pContext, const DataStoreRatingTarget& target, DataStoreRatingInfo* pRating, DataStoreRatingLog* pRatingLog, qUnsignedInt64 accessPassword=DataStoreConstants::INVALID_PASSWORD);

    /* Please see man pages for details 
        

       

            
            
            

        
        
        
        

        
        
    */
    virtual qBool GetPersistenceInfo(ProtocolCallContext* pContext, qUnsignedInt32 pid, qUnsignedInt16 persistenceSlotId, DataStorePersistenceInfo* pPersistenceInfo);

    /* Please see man pages for details 
        

       

            
            
            
            
            

        
        
        
        
        

        
        
    */
    virtual qBool GetPersistenceInfo(ProtocolCallContext* pContext, qUnsignedInt32 pid, qVector<qUnsignedInt16> persistenceSlotIds, qVector<DataStorePersistenceInfo>* pPersistenceInfos, qVector<qResult>* pResults=NULL);

    /* Please see man pages for details 
        

            
            
            
            
            
            
            

        
        
        
        

        
        
    */
    virtual qBool PerpetuateObject(ProtocolCallContext* pContext, qUnsignedInt16 persistenceSlotId, qUnsignedInt64 dataId, qBool deleteLastObject = true);

    /* Please see man pages for details 
        

            
            

        
        
        

        
        
    */
    virtual qBool UnperpetuateObject(ProtocolCallContext* pContext, qUnsignedInt16 persistenceSlotId, qBool deleteLastObject = false);

    /* Please see man pages for details 
        

        

            
            

        
        
        

        
        
    */
    virtual qBool GetPasswordInfo(ProtocolCallContext* pContext, qUnsignedInt64 dataId, DataStorePasswordInfo* pPasswordInfo);

    /* Please see man pages for details 
        

        

            
            
            
            
            

        
        
        
        

        
        
    */
    virtual qBool GetPasswordInfo(ProtocolCallContext* pContext, const qVector<qUnsignedInt64>& dataIds, qVector<DataStorePasswordInfo>* pPasswordInfos, qVector<qResult>* pResults=NULL);

protected:
    virtual qUnsignedInt32 GetMyPrincipalId() const
    {
        return GetCredentials()==NULL ? INVALID_PRINCIPALID : GetCredentials()->GetPrincipalID();
    }
    // Returns whether it is necessary to set credentials for this client.
    virtual qBool IsCredentialsNeeded() const
    {
        return true;
    };

private:
    // Registered flag
    qBool m_bProtocolRegistered;
    // Protocol object
    DataStoreProtocolClient m_oProtocol;

    void CreateExtraData(qVector<String>& extraData) const;
};

END_NAMESPACE_NEX

#endif // DATASTORE_LOGICSERVER_CLIENT_H__
