/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc. All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _DATA_STORE_COMPLETE_POST_PARAM_H
#define _DATA_STORE_COMPLETE_POST_PARAM_H

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include "DataStoreCompletePostParamDDL.h"
#include "DataStorePreparePostParamDDL.h"
#include "DataStoreConstants.h"

BEGIN_NAMESPACE_NEX

/* Please see man pages for details 
    
    
*/
class DataStoreCompletePostParam: public DDLCLASS(DataStoreCompletePostParam)
{
public:
    /* Please see man pages for details 
        
    */
    DataStoreCompletePostParam()
    {
        Reset();
    }

    /* Please see man pages for details 
        
    */
    virtual ~DataStoreCompletePostParam() {}

    void SetDataId(qUnsignedInt64 dataId)
    {
        this->dataId = dataId;
    }
    qUnsignedInt64 GetDataId() const
    {
        return this->dataId;
    }
    void SetIsSuccess(qBool isSuccess)
    {
        this->isSuccess = isSuccess;
    }
    qBool GetIsSuccess() const
    {
        return this->isSuccess;
    }

    /* Please see man pages for details 
        
        

        
    */
    void SetPreparePostParam(const DataStorePreparePostParam& preparePostParam)
    {
        (void)preparePostParam;
    }

    /* Please see man pages for details 
        
        
    */
    void Reset()
    {
        SetDataId(DataStoreConstants::INVALID_DATAID);
        SetIsSuccess(false);
    }

    /* Please see man pages for details 
        
        

        
    */
    void Trace(qUnsignedInt64 uiTraceFlags=TRACE_ALWAYS) const
    {
        QTRACE(uiTraceFlags, _T("DataStoreCompletePostParam: (")
               << _T("dataId=") << dataId
               << _T(", isSuccess=") << isSuccess
               << _T(")")
              );
    }
};

END_NAMESPACE_NEX

#endif
