﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc. All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C) 2011-2014 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _DATA_STORE_PREPARE_POST_PARAM_V1_H
#define _DATA_STORE_PREPARE_POST_PARAM_V1_H

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include "DataStorePreparePostParamV1DDL.h"
#include "DataStoreConstants.h"

BEGIN_NAMESPACE_NEX

/* Please see man pages for details 
    
    
*/
class DataStorePreparePostParamV1: public DDLCLASS(DataStorePreparePostParamV1)
{
public:
    /* Please see man pages for details 
        
    */
    DataStorePreparePostParamV1()
    {
        SetSize(0);
        SetName("");
        SetDataType(0);
        SetAccessPermission(DataStorePermission(DataStoreConstants::PERMISSION_PRIVATE));
        SetDeletePermission(DataStorePermission(DataStoreConstants::PERMISSION_PRIVATE));
        SetDataFlag(DataStoreConstants::DATA_FLAG_NONE);
        SetPeriod(DataStoreConstants::DEFAULT_PERIOD);
        SetReferDataId(DataStoreConstants::INVALID_DATAID_V1);
        SetTags(qVector<String>());
        SetMetaBinary(NULL, 0);
    }

    /* Please see man pages for details 
        
    */
    virtual ~DataStorePreparePostParamV1() {}

    /* Please see man pages for details 
        

            
            
            

        
    */
    void SetSize(qUnsignedInt32 size)
    {
        this->size = size;
    }

    /* Please see man pages for details 
        

        
    */
    qUnsignedInt32 GetSize() const
    {
        return this->size;
    }

    /* Please see man pages for details 
        

            
            

        
    */
    void SetName(const String& name)
    {
        this->name = name;
    }

    /* Please see man pages for details 
        

        
    */
    const String& GetName() const
    {
        return this->name;
    }

    /* Please see man pages for details 
        

            
            

        
    */
    void SetDataType(const qUnsignedInt16 dataType)
    {
        this->dataType = dataType;
    }

    /* Please see man pages for details 
        

        
    */
    qUnsignedInt16 GetDataType() const
    {
        return this->dataType;
    }

    /* Please see man pages for details 
        

            
            

        
    */
    void SetAccessPermission(const DataStorePermission& permission)
    {
        this->permission = permission;
    }

    /* Please see man pages for details 
        

        
    */
    const DataStorePermission& GetAccessPermission() const
    {
        return this->permission;
    }

    /* Please see man pages for details 
        

            
            

        
    */
    void SetDeletePermission(const DataStorePermission& delPermission)
    {
        this->delPermission = delPermission;
    }

    /* Please see man pages for details 
        

        
    */
    const DataStorePermission& GetDeletePermission() const
    {
        return this->delPermission;
    }

    /* Please see man pages for details 
        

            
            

        
    */
    void SetDataFlag(qUnsignedInt32 flag)
    {
        this->flag = flag;
    }

    /* Please see man pages for details 
        

        
    */
    qUnsignedInt32 GetDataFlag() const
    {
        return this->flag;
    }

    /* Please see man pages for details 
        

            
            
            
            
            
            

        
    */
    void SetPeriod(qUnsignedInt16 period)
    {
        this->period = period;
    }

    /* Please see man pages for details 
        

        
    */
    qUnsignedInt16 GetPeriod() const
    {
        return this->period;
    }

    /* Please see man pages for details 
        
        

            
            

        
    */
    void SetReferDataId(qUnsignedInt32 referDataId)
    {
        this->referDataId = referDataId;
    }

    /* Please see man pages for details 
        
        

        
    */
    qUnsignedInt32 GetReferDataId() const
    {
        return this->referDataId;
    }

    /* Please see man pages for details 
        

            
            
            


        
    */
    void SetTags(const qVector<String>& tags)
    {
        this->tags = tags;
    }

    /* Please see man pages for details 
        

        
    */
    const qVector<String>& GetTags() const
    {
        return this->tags;
    }

    /* Please see man pages for details 
        

            
            
            

        
    */
    void SetRatingSetting(const qMap<qInt8, DataStoreRatingInitParam>& ratingInitParam)
    {
        this->ratingInitParams.clear();
        qMap<qInt8, DataStoreRatingInitParam>::const_iterator it = ratingInitParam.begin();
        for (; it != ratingInitParam.end(); ++it)
        {
            DataStoreRatingInitParamWithSlot paramSlot;
            paramSlot.slot = it->first;
            paramSlot.param = it->second;
            this->ratingInitParams.push_back(paramSlot);
        }
    }

    /* Please see man pages for details 
        

        
    */
    void GetRatingSetting(qMap<qInt8, DataStoreRatingInitParam>& ratingInitParam) const
    {
        ratingInitParam.clear();
        qVector<DataStoreRatingInitParamWithSlot>::const_iterator it = this->ratingInitParams.begin();
        for (; it != this->ratingInitParams.end(); ++it)
        {
            ratingInitParam.insert(std::make_pair(it->slot, it->param));
        }
    }

    /* Please see man pages for details 
        

            
            

        
        
    */
    void SetMetaBinary(const void* p, qUnsignedInt32 size)
    {
        this->metaBinary.clear();
        if (p != NULL)
        {
            const qByte* pb = static_cast<const qByte*>(p);
            this->metaBinary.push_back(pb, size);
        }
    }

    /* Please see man pages for details 
        

        

        
    */
    qVector<qByte> GetMetaBinary() const
    {
        // Conversion from qBuffer to qVector<qByte>
        qVector<qByte> vb;
        vb.assign(this->metaBinary.begin(), this->metaBinary.end());
        return vb;
    }

    /* Please see man pages for details 
        

        

        

        
    */
    void GetMetaBinary(qVector<qByte>& metaBinary) const
    {
        // Conversion from qBuffer to qVector<qByte>
        metaBinary.assign(this->metaBinary.begin(), this->metaBinary.end());
    }
};

END_NAMESPACE_NEX

#endif
