/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc. All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _DATA_STORE_PREPARE_UPDATE_PARAM_H
#define _DATA_STORE_PREPARE_UPDATE_PARAM_H

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include "DataStorePrepareUpdateParamDDL.h"
#include "DataStoreConstants.h"

BEGIN_NAMESPACE_NEX

/* Please see man pages for details 
    

    
*/
class DataStorePrepareUpdateParam: public DDLCLASS(DataStorePrepareUpdateParam)
{
public:
    /* Please see man pages for details 
        
    */
    DataStorePrepareUpdateParam()
    {
        Reset();
    }

    /* Please see man pages for details 
        
    */
    virtual ~DataStorePrepareUpdateParam() {}

    /* Please see man pages for details 
        

            

        
    */
    void SetDataId(qUnsignedInt64 dataId)
    {
        this->dataId = dataId;
    }

    /* Please see man pages for details 
        

        
    */
    qUnsignedInt64 GetDataId() const
    {
        return this->dataId;
    }

    /* Please see man pages for details 
        

            
            

        
    */
    void SetSize(qUnsignedInt32 size)
    {
        this->size = size;
    }

    /* Please see man pages for details 
        

        
    */
    qUnsignedInt32 GetSize() const
    {
        return this->size;
    }

    /* Please see man pages for details 
        

            
            
            
            
            

        
    */
    void SetUpdatePassword(qUnsignedInt64 updatePassword)
    {
        this->updatePassword = updatePassword;
    }

    /* Please see man pages for details 
        

        
    */
    qUnsignedInt64 GetUpdatePassword() const
    {
        return this->updatePassword;
    }

    /* Please see man pages for details 
        
    */
    void Reset()
    {
        SetDataId(DataStoreConstants::INVALID_DATAID);
        SetSize(0);
        SetUpdatePassword(DataStoreConstants::INVALID_PASSWORD);
        this->extraData.clear();
    }

    /* Please see man pages for details 
        

        
    */
    void Trace(qUnsignedInt64 uiTraceFlags=TRACE_ALWAYS) const
    {
        QTRACE(uiTraceFlags, _T("DataStorePrepareUpdateParam: (")
               << _T("dataId=") << dataId
               << _T(", size=") << size
               << _T(", updatePassword=") << updatePassword
               << _T(")")
              );
    }
};

END_NAMESPACE_NEX

#endif
