/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc. All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _DATA_STORE_RATE_OBJECT_PARAM_H
#define _DATA_STORE_RATE_OBJECT_PARAM_H

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include "DataStoreRateObjectParamDDL.h"
#include "DataStoreConstants.h"

BEGIN_NAMESPACE_NEX

/* Please see man pages for details 
    
*/
class DataStoreRateObjectParam: public DDLCLASS(DataStoreRateObjectParam)
{
public:
    /* Please see man pages for details 
        
    */
    DataStoreRateObjectParam()
    {
        Reset();
    }

    /* Please see man pages for details 
        
    */
    virtual ~DataStoreRateObjectParam() {}

    /* Please see man pages for details 
        
                    

        
    */
    void SetRatingValue(qInt32 ratingValue)
    {
        this->ratingValue = ratingValue;
    }

    /* Please see man pages for details 
        

        
    */
    qInt32 GetRatingValue() const
    {
        return this->ratingValue;
    }

    /* Please see man pages for details 
        

            
            
            
            
            

        
    */
    void SetAccessPassword(qUnsignedInt64 accessPassword)
    {
        this->accessPassword = accessPassword;
    }

    /* Please see man pages for details 
        

        
    */
    qUnsignedInt64 GetAccessPassword() const
    {
        return this->accessPassword;
    }

    /* Please see man pages for details 
        
    */
    void Reset()
    {
        SetRatingValue(1);
        SetAccessPassword(DataStoreConstants::INVALID_PASSWORD);
    }

    /* Please see man pages for details 
        

        
    */
    void Trace(qUnsignedInt64 uiTraceFlags=TRACE_ALWAYS) const
    {
        QTRACE(uiTraceFlags, _T("DataStoreRateObjectParam: (")
               << _T("ratingValue=") << ratingValue
               << _T(", accessPassword=") << accessPassword
               << _T(")")
              );
    }
};

END_NAMESPACE_NEX

#endif
