/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc. All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _DATA_STORE_RATING_INIT_PARAM_H
#define _DATA_STORE_RATING_INIT_PARAM_H

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include "DataStoreRatingInitParamDDL.h"
#include "DataStoreRatingLockInitParam.h"
#include "DataStoreConstants.h"

BEGIN_NAMESPACE_NEX

/* Please see man pages for details 
    
*/
class DataStoreRatingInitParam: public DDLCLASS(DataStoreRatingInitParam)
{
public:
    /* Please see man pages for details 
        
    */
    DataStoreRatingInitParam()
    {
        Reset();
    }

    /* Please see man pages for details 
        
    */
    virtual ~DataStoreRatingInitParam() {}


    /* Please see man pages for details 
        
        
    */
    void SetInitialValue(qInt64 initialValue)
    {
        this->initialValue = initialValue;
    }

    /* Please see man pages for details 
        
        
    */
    void SetRangeMin(qInt32 min)
    {
        this->rangeMin = min;
        this->internalFlag |= DataStoreConstants::RATING_INTERNAL_FLAG_USE_RANGE_MIN;
    }

    /* Please see man pages for details 
        
        
    */
    void SetRangeMax(qInt32 max)
    {
        this->rangeMax = max;
        this->internalFlag |= DataStoreConstants::RATING_INTERNAL_FLAG_USE_RANGE_MAX;
    }

    /* Please see man pages for details 
        
        

            

        
        
                                   
                                   
                                   
                                   
        
    */
    void SetLock(DataStoreConstants::RatingLockType lockType, qInt16 periodDuration = 0, qInt8 periodHour = 0)
    {
        this->lockType = static_cast<qByte>(lockType);
        this->periodDuration = periodDuration;
        this->periodHour = periodHour;
    }

    /* Please see man pages for details 
        
        

        
    */
    void SetLock(const DataStoreRatingLockInitParam& ratingLockInitParam)
    {
        this->lockType = static_cast<qByte>(ratingLockInitParam.GetLockType());
        this->periodDuration = ratingLockInitParam.GetPeriodDuration();
        this->periodHour = ratingLockInitParam.GetPeriodHour();
    }
    /* Please see man pages for details 
        

            

        
    */
    void SetFlag(qUnsignedInt32 flag)
    {
        this->flag = static_cast<qByte>(flag);
    }

    /* Please see man pages for details 
        
    */
    void Reset()
    {
        this->flag = 0;
        this->internalFlag = 0;
        this->lockType = 0;
        this->initialValue = 0;
        this->rangeMin = 0;
        this->rangeMax = 0;
        this->periodHour = 0;
        this->periodDuration = 0;
    }

    /* Please see man pages for details 
        

        
    */
    void Trace(qUnsignedInt64 uiTraceFlags=TRACE_ALWAYS) const
    {
        QTRACE(uiTraceFlags, *this);
    }

    /* Please see man pages for details 
        
        
    */
    inline friend StringStream& operator<<(StringStream& oStr, const DataStoreRatingInitParam& oRatingInitParam);
};

inline StringStream& operator<<(StringStream& oStr, const DataStoreRatingInitParam& oRatingInitParam)
{
    oStr << _T("DataStoreRatingInitParam: (")
         << _T("flag=") << oRatingInitParam.flag
         << _T(", internalFlag=") << oRatingInitParam.internalFlag
         << _T(", lockType=") << oRatingInitParam.lockType
         << _T(", initialValue=") << oRatingInitParam.initialValue
         << _T(", rangeMin=") << oRatingInitParam.rangeMin
         << _T(", rangeMax=") << oRatingInitParam.rangeMax
         << _T(", periodHour=") << oRatingInitParam.periodHour
         << _T(", periodDuration=") << oRatingInitParam.periodDuration
         << _T(")");

    return oStr;
}

END_NAMESPACE_NEX

#endif
