/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc. All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _DATA_STORE_RATING_TARGET_H
#define _DATA_STORE_RATING_TARGET_H

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include "DataStoreRatingTargetDDL.h"
#include "DataStoreConstants.h"

BEGIN_NAMESPACE_NEX

/* Please see man pages for details 
    
*/
class DataStoreRatingTarget: public DDLCLASS(DataStoreRatingTarget)
{
public:
    /* Please see man pages for details 
        

        
    */
    DataStoreRatingTarget()
    {
        Reset();
    }

    /* Please see man pages for details 
        
    */
    virtual ~DataStoreRatingTarget() {}

    /* Please see man pages for details 
        

        
    */
    void SetDataId(qUnsignedInt64 dataId)
    {
        this->dataId = dataId;
    }

    /* Please see man pages for details 
        

        
    */
    qUnsignedInt64 GetDataId() const
    {
        return this->dataId;
    }

    /* Please see man pages for details 
        

        
    */
    void SetSlot(qInt8 slot)
    {
        this->slot = slot;
    }

    /* Please see man pages for details 
        

        
    */
    qInt8 GetSlot() const
    {
        return this->slot;
    }

    /* Please see man pages for details 
        
    */
    void Reset()
    {
        SetDataId(DataStoreConstants::INVALID_DATAID);
        SetSlot(0);
    }

    /* Please see man pages for details 
        

        
    */
    void Trace(qUnsignedInt64 uiTraceFlags=TRACE_ALWAYS) const
    {
        QTRACE(uiTraceFlags, _T("DataStoreRatingTarget: (")
               << _T("dataId=") << dataId
               << _T(", slot=") << slot
               << _T(")")
              );
    }
};

END_NAMESPACE_NEX

#endif
