﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc. All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C) 2011-2014 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _DataStoreSearchParam_H
#define _DataStoreSearchParam_H

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include "DataStoreSearchParamDDL.h"
#include "DataStoreConstants.h"

BEGIN_NAMESPACE_NEX

/* Please see man pages for details 
    
*/
class DataStoreSearchParam: public DDLCLASS(DataStoreSearchParam)
{
public:
    /* Please see man pages for details 
        
    */
    DataStoreSearchParam()
    {
        Reset();
    }

    /* Please see man pages for details 
        
    */
    virtual ~DataStoreSearchParam() {}

    /* Please see man pages for details 
        

            
            

        
    */
    void SetSearchType(DataStoreConstants::SearchType searchType)
    {
        this->searchTarget = static_cast<qByte>(searchType);
    }

    /* Please see man pages for details 
        

        
    */
    DataStoreConstants::SearchType GetSearchType() const
    {
        return static_cast<DataStoreConstants::SearchType>(this->searchTarget);
    }

    /* Please see man pages for details 
        

            

        
    */
    void SetOwnerIds(const qVector<qUnsignedInt32>& ownerIds)
    {
        this->ownerIds = ownerIds;
    }

    /* Please see man pages for details 
        

        
    */
    const qVector<qUnsignedInt32>& GetOwnerIds() const
    {
        return this->ownerIds;
    }

    /* Please see man pages for details 
        

        
    */
    void SetOwnerType(DataStoreConstants::SearchTarget ownerType)
    {
        this->ownerType = static_cast<qByte>(ownerType);
    }

    /* Please see man pages for details 
        

        
    */
    DataStoreConstants::SearchTarget GetOwnerType() const
    {
        return static_cast<DataStoreConstants::SearchTarget>(this->ownerType);
    }

    /* Please see man pages for details 
        

           
           
           
           
           
           
           
           

        
    */
    void SetDestinationIds(const qVector<qUnsignedInt32>& destinationIds)
    {
        this->destinationIds = destinationIds;
    }

    /* Please see man pages for details 
        

        
    */
    const qVector<qUnsignedInt32>& GetDestinationIds() const
    {
        return this->destinationIds;
    }

    /* Please see man pages for details 
        

            

        
    */
    void SetDataType(const qUnsignedInt16 dataType)
    {
        this->dataType = dataType;
    }

    /* Please see man pages for details 
        

        
    */
    qUnsignedInt16 GetDataType() const
    {
        return this->dataType;
    }

    /* Please see man pages for details 
        

            

            
            

        
    */
    void SetCreatedAfter(const DateTime& createdAfter)
    {
        this->createdAfter = createdAfter;
    }

    /* Please see man pages for details 
        

            

        
    */
    const DateTime& GetCreatedAfter() const
    {
        return this->createdAfter;
    }

    /* Please see man pages for details 
        

            

            
            

        
    */
    void SetCreatedBefore(const DateTime& createdBefore)
    {
        this->createdBefore = createdBefore;
    }

    /* Please see man pages for details 
        

            

        
    */
    const DateTime& GetCreatedBefore() const
    {
        return this->createdBefore;
    }

    /* Please see man pages for details 
        

            

            
            

        
    */
    void SetUpdatedAfter(const DateTime& updatedAfter)
    {
        this->updatedAfter = updatedAfter;
    }

    /* Please see man pages for details 
        

            

        
    */
    const DateTime& GetUpdatedAfter() const
    {
        return this->updatedAfter;
    }

    /* Please see man pages for details 
        

            

            
            

        
    */
    void SetUpdatedBefore(const DateTime& updatedBefore)
    {
        this->updatedBefore = updatedBefore;
    }

    /* Please see man pages for details 
        

            

        
    */
    const DateTime& GetUpdatedBefore() const
    {
        return this->updatedBefore;
    }

    /* Please see man pages for details 
        
        

            

        
    */
    void SetReferDataId(qUnsignedInt32 referDataId)
    {
        this->referDataId = referDataId;
    }

    /* Please see man pages for details 
        
        

        
    */
    qUnsignedInt32 GetReferDataId() const
    {
        return this->referDataId;
    }

    /* Please see man pages for details 
        

            
            

        
    */
    void SetSearchSortOrderColumn(DataStoreConstants::SearchSortColumn resultOrderColumn)
    {
        this->resultOrderColumn = static_cast<qByte>(resultOrderColumn);
    }

    /* Please see man pages for details 
        

        
    */
    DataStoreConstants::SearchSortColumn GetSearchSortOrderColumn() const
    {
        return static_cast<DataStoreConstants::SearchSortColumn>(this->resultOrderColumn);
    }

    /* Please see man pages for details 
        

            

        
    */
    void SetSearchSortOrder(DataStoreConstants::SearchSortOrder resultOrder)
    {
        this->resultOrder = static_cast<qByte>(resultOrder);
    }

    /* Please see man pages for details 
        

        
    */
    DataStoreConstants::SearchSortOrder GetSearchSortOrder() const
    {
        return static_cast<DataStoreConstants::SearchSortOrder>(this->resultOrder);
    }

    /* Please see man pages for details 
        

            
            

            

        
    */
    void SetResultRange(const ResultRange& resultRange)
    {
        this->resultRange = resultRange;
    }

    /* Please see man pages for details 
        

        
    */
    const ResultRange& GetResultRange() const
    {
        return this->resultRange;
    }

    /* Please see man pages for details 
        

            
            
            

        
    */
    void SetResultOption(qUnsignedInt32 resultOption)
    {
        this->resultOption = static_cast<qByte>(resultOption);
    }

    /* Please see man pages for details 
        

        
    */
    qByte GetResultOption() const
    {
        return this->resultOption;
    }

    /* Please see man pages for details 
        

            

        
    */
    void SetTags(const qVector<String>& tags)
    {
#ifdef LOG_ENABLED
        if (tags.size() > DataStoreConstants::NUM_TAG_SLOT)
        {
            QLOG(EventLog::Warning, _T("DataStoreSearchParam::SetTags(): slot size is over the limit. size=") << tags.size());
        }

        qVector<String>::const_iterator it = tags.begin();
        for (; it != tags.end(); ++it)
        {
            if (it->GetLength() > DataStoreConstants::MAX_TAG_LENGTH)
            {
                QLOG(EventLog::Warning, _T("DataStoreSearchParam::SetTags(): tag length is over the limit. ") << _T("tag=") << *it << _T(", length=") << it->GetLength());
            }
        }
#endif
        this->tags = tags;
    }

    /* Please see man pages for details 
        

        
    */
    const qVector<String>& GetTags() const
    {
        return this->tags;
    }

    /* Please see man pages for details 
        

            

        
    */
    void SetMinimalRatingFrequency(const qUnsignedInt32 minimalRatingFrequency)
    {
        this->minimalRatingFrequency = minimalRatingFrequency;
    }

    /* Please see man pages for details 
        

        
    */
    qUnsignedInt32 GetMinimalRatingFrequency()
    {
        return this->minimalRatingFrequency;
    }

    /* Please see man pages for details 
        

            
            
            

        
    */
    void SetUseCache(const qBool useCache)
    {
        this->useCache = useCache;
    }

    /* Please see man pages for details 
        

            
            

        
    */
    qBool GetUseCache()
    {
        return this->useCache;
    }

    /* Please see man pages for details 
        
    */
    void Reset()
    {
        SetSearchType(DataStoreConstants::SEARCH_TYPE_PUBLIC);
        SetOwnerIds(qVector<qUnsignedInt32>());
        SetOwnerType(DataStoreConstants::SEARCH_TARGET_ANYBODY);
        SetDestinationIds(qVector<qUnsignedInt32>());
        SetDataType(DataStoreConstants::INVALID_DATA_TYPE);
        SetCreatedAfter(DataStoreConstants::INVALID_DATE_TIME);
        SetCreatedBefore(DataStoreConstants::INVALID_DATE_TIME);
        SetUpdatedAfter(DataStoreConstants::INVALID_DATE_TIME);
        SetUpdatedBefore(DataStoreConstants::INVALID_DATE_TIME);
        SetReferDataId(DataStoreConstants::INVALID_DATAID);
        SetSearchSortOrderColumn(DataStoreConstants::SEARCH_SORT_COLUMN_DATAID);
        SetSearchSortOrder(DataStoreConstants::SEARCH_SORT_ORDER_ASC);
        SetResultRange(ResultRange());
        SetResultOption(0);
        SetTags(qVector<String>());
        SetMinimalRatingFrequency(0);
        SetUseCache(false);
    }

    /* Please see man pages for details 
        

        
    */
    void Trace(qUnsignedInt64 uiTraceFlags=TRACE_ALWAYS) const
    {
        StringStream ss;

        ss << _T("DataStoreSearchParam: (")
           << _T("searchTarget=") << searchTarget
           << _T(", ownerIds=(");

        for (qVector<qUnsignedInt32>::const_iterator it = ownerIds.begin(); it != ownerIds.end(); ++it)
        {
            ss << *it << _T(", ");
        }

        ss << _T("), ownerType=") << ownerType
           << _T(", destinationIds=(");

        for (qVector<qUnsignedInt32>::const_iterator it = destinationIds.begin(); it != destinationIds.end(); ++it)
        {
            ss << *it << _T(", ");
        }

        ss << _T("), dataType=") << dataType;

        ss << _T(", createdAfter=") << createdAfter << _T(", createdBefore=") << createdBefore
           << _T(", updatedAfter=") << updatedAfter << _T(", updatedBefore=") << updatedBefore
           << _T(", referDataId=") << referDataId
           << _T(", resultOrderColumn=") << resultOrderColumn << _T(", resultOrder=") << resultOrder
           << _T(", resultRange=(") << resultRange << _T(")")
           << _T(", resultOption=") << resultOption
           << _T(", tags=(");

        for (qVector<String>::const_iterator it = tags.begin(); it != tags.end(); ++it)
        {
            ss << *it << _T(", ");
        }

        ss << _T("), minimalRatingFrequency=") << minimalRatingFrequency;
        ss << _T(", useCache=") << useCache;

        ss << _T(")");

        QTRACE(uiTraceFlags, ss.CStr());
    }
};

END_NAMESPACE_NEX

#endif
