﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc. All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _DebugClient_H__
#define _DebugClient_H__

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include <RendezVous/Core/src/Client/ServiceClient.h>
#include <RendezVous/Services/Jugem/Debug/src/Common/DebugDDF.h>
#include <RendezVous/Services/Jugem/Debug/src/Common/DebugProtocolDDL.h>
#include <RendezVous/Services/Jugem/Debug/src/Common/ApiCallData.h>
#include <RendezVous/Services/Jugem/Debug/src/Common/ApiCallSummary.h>
#include <RendezVous/Services/Jugem/Debug/src/Common/DebugConstants.h>

BEGIN_NAMESPACE_NEX

/* Please see man pages for details 
    

           

           
           

           
           
*/
class DebugClient : public ServiceClient
{
public:

    /* Please see man pages for details 
        
    */
    DebugClient();

    /* Please see man pages for details 
        

                       
    */
    virtual ~DebugClient();

    /* Please see man pages for details 
        

        

        
        
    */
    virtual qBool Bind(Credentials* pCredentials);

    /* Please see man pages for details 
        

        
        
    */
    virtual qBool Unbind();

    void UpdateProtocolsDefaultCredentials(Credentials* pCredentials);

    /* Please see man pages for details 
     

               

               
               

     

     
     
     */
    qBool EnableApiRecorder(ProtocolCallContext* pContext);

    /* Please see man pages for details 
     

               
               

               
               
               

     

     
     
     */
    qBool DisableApiRecorder(ProtocolCallContext* pContext);

    /* Please see man pages for details 
     

     
     

     
     
     */
    qBool IsApiRecorderEnabled(ProtocolCallContext* pContext, bool* IsEnabled);

    /* Please see man pages for details 
     

               
               

               

               
               
               

               
               

               

               

     
     
     
     
     

     
     
     */
    qBool GetApiCalls(ProtocolCallContext *pContext,
                      qList<ApiCallData>* pApiCallDatas,
                      qList<PrincipalID>& principalIds,
                      DateTime sinceTime = DateTime::Never,
                      DateTime untilTime = DateTime::Never
                     );

    /* Please see man pages for details 
     

         
         

         

         
         
         

         

           

         
         
         
         
         
         

         
         
     */
    qBool GetApiCallSummary(ProtocolCallContext *pContext,
                            qList<ApiCallSummary> *pApiCallSummaryList,
                            PrincipalID principalId,
                            DateTime sinceTime = DateTime::Never,
                            DateTime untilTime = DateTime::Never,
                            qBool isLimitOverOnly = true);

    /* Please see man pages for details 
     

     
     
     

     
     

     

       

     
     
                                              
                                              
     */
    qBool SetExcludeJoinedMatchmakeSession(ProtocolCallContext *pContext, qBool bAvoidPreviousGathering);

    /* Please see man pages for details 
     

     

       

     
     
                                               
                                               
     */
    qBool GetExcludeJoinedMatchmakeSession(ProtocolCallContext *pContext, qBool* bpAvoidPreviousGathering);

private:
    qBool m_bProtocolRegistered;
    DebugProtocolClient m_oProtocol;
};

END_NAMESPACE_NEX

#endif // _DebugClient_H__
