﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc. All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C) 2011-2014 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _Community_H_
#define _Community_H_

#include <RendezVous/Services/Jugem/Matchmake/src/Common/PersistentGathering.h>
#include <RendezVous/Services/Jugem/Matchmake/src/Common/MatchmakeConstants.h>

BEGIN_NAMESPACE_NEX

// This header file has been provided for generating API references.
// The instance is in PersistentGathering.h.
#ifdef FOR_DOC_PURPOSE
/* Please see man pages for details 
 
 */
namespace CommunityType
{
/* Please see man pages for details 
 
 */
typedef enum
{
    Open,              //
    PasswordLocked,    //
    Official           //
} CommunityType;
}

/* Please see man pages for details 
 
 */
class Community: public Gathering
{
public:

    /* Please see man pages for details 
    

       
    */
    Community();

    /* Please see man pages for details 
    
    */
    virtual ~Community() {};

    /* Please see man pages for details 
    

      
    */
    void Reset();

    /* Please see man pages for details 
    

    
    */
    void SetCommunityType(CommunityType::CommunityType type);

    /* Please see man pages for details 
     

     
     */
    CommunityType::CommunityType GetCommunityType() const;

    /* Please see man pages for details 
     

     

     
     */
    void SetPassword(const String& password)
    {
        m_Password = password;
    }

    /* Please see man pages for details 
     

     

     
     */
    const String& GetPassword() const
    {
        return m_Password;
    }

    /* Please see man pages for details 
    

       

    
    
    */
    void SetAttribute(qUnsignedInt32 uiIndex, qUnsignedInt32 val);

    /* Please see man pages for details 
    

       

    

    
    */
    qUnsignedInt32 GetAttribute(qUnsignedInt32 uiIndex) const;

    /* Please see man pages for details 
    

       

    
    */
    void SetApplicationBuffer(qVector<qByte> buffer)
    {
        m_ApplicationBuffer = buffer;
    }

    /* Please see man pages for details 
    

       

    
    */
    const qVector<qByte>& GetApplicationBuffer() const
    {
        return m_ApplicationBuffer;
    }

    /* Please see man pages for details 
    

       
       
       

    
    */
    void SetParticipationStartDate(const DateTime& date)
    {
        m_ParticipationStartDate = date;
    }

    /* Please see man pages for details 
    

    
    */
    const DateTime& GetParticipationStartDate() const
    {
        return m_ParticipationStartDate;
    }

    /* Please see man pages for details 
    

       
       
       

    
    */
    void SetParticipationEndDate(const DateTime& date)
    {
        m_ParticipationEndDate = date;
    }

    /* Please see man pages for details 
    

    
    */
    const DateTime& GetParticipationEndDate() const
    {
        return m_ParticipationEndDate;
    }

    /* Please see man pages for details 
    

    
    
    */
    qUnsignedInt32 GetMatchmakeSessionCount() const
    {
        return m_MatchmakeSessionCount;
    }

    /* Please see man pages for details 
    

    
    */
    qUnsignedInt32 GetParticipationCount() const
    {
        return m_ParticipationCount;
    }
};
#endif

END_NAMESPACE_NEX

#endif /* _Community_H_ */
