﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc. All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C) 2011-2014 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _MatchmakeParam_H_
#define _MatchmakeParam_H_

#include <RendezVous/Services/Jugem/Matchmake/src/Common/MatchmakeParamDDL.h>
#include <RendezVous/Services/Jugem/Matchmake/src/Common/MatchmakeConstants.h>


BEGIN_NAMESPACE_NEX

/* Please see man pages for details 

*/
class MatchmakeParam: public DDLCLASS(MatchmakeParam)
{
public:

    /* Please see man pages for details 
    

       
    */
    MatchmakeParam()
    {
        Reset();
    };
    
    /* Please see man pages for details 
     
     */
    virtual ~MatchmakeParam() {}

    void SetParam(const String& key, const Variant& value) { m_Params[key] = value; }
    qBool GetParam(const String& key, Variant* value) const
    {
        qMap<String, Variant>::const_iterator v = m_Params.find(key);
        if (v == m_Params.end())
        {
            return false;
        }

        *value = v->second;
        return true;
    }

    /* Please see man pages for details 
    

       

    
                             
    */
    void SetSettingIndex(qUnsignedInt32 settingIndex) { SetParam(MATCHMAKE_PARAM_KEY_SETTING_INDEX, settingIndex); }

    /* Please see man pages for details 
    

       
       

    

    
    */
    qBool GetSettingIndex(qUnsignedInt32* settingIndex) const
    {
        Variant variant;
        qBool result = GetParam(MATCHMAKE_PARAM_KEY_RATING_VALUE, &variant);
        if (result && settingIndex)
        {
            *settingIndex = variant.GetUInt32Value();
        }
        return result;
    }

    /* Please see man pages for details 
    

       

    
    */
    void SetRatingValue(qUnsignedInt32 ratingValue) { SetParam(MATCHMAKE_PARAM_KEY_RATING_VALUE, ratingValue); }

    /* Please see man pages for details 
    

       

    

    
    */
    qBool GetRatingValue(qUnsignedInt32* ratingValue) const
    {
        Variant variant;
        qBool result = GetParam(MATCHMAKE_PARAM_KEY_RATING_VALUE, &variant);
        if (result && ratingValue)
        {
            *ratingValue = variant.GetUInt32Value();
        }
        return result;
    }

    /* Please see man pages for details 
    

       

    
    */
    void SetDisconnectionRate(qUnsignedInt32 disconnectionRate) { SetParam(MATCHMAKE_PARAM_KEY_DISCONNECTION_RATE, disconnectionRate); }

    /* Please see man pages for details 
    

       

    

    
    */
    qBool GetDisconnectionRate(qUnsignedInt32* disconnectionRate) const
    {
        Variant variant;
        qBool result = GetParam(MATCHMAKE_PARAM_KEY_DISCONNECTION_RATE, &variant);
        if (result && disconnectionRate)
        {
            *disconnectionRate = variant.GetUInt32Value();
        }
        return result;
    }

    /* Please see man pages for details 
    

       

    
    */
    void SetViolationRate(qUnsignedInt32 violationRate) { SetParam(MATCHMAKE_PARAM_KEY_VIOLATION_RATE, violationRate); }

    /* Please see man pages for details 
    

       

    

    
    */
    qBool GetViolationRate(qUnsignedInt32* violationRate) const
    {
        Variant variant;
        qBool result = GetParam(MATCHMAKE_PARAM_KEY_VIOLATION_RATE, &variant);
        if (result && violationRate)
        {
            *violationRate = variant.GetUInt32Value();
        }
        return result;
    }

    /* Please see man pages for details 
    

       
       
       
       

    
    */
    void SetNintendoCountryCode(qUnsignedInt32 nintendoCountryCode) { SetParam(MATCHMAKE_PARAM_KEY_NINTENDO_COUNTRY_CODE, nintendoCountryCode); }

    /*
    

       
       
       
       

    

    
    */
    qBool GetNintendoCountryCode(qUnsignedInt32* nintendoCountryCode) const
    {
        Variant variant;
        qBool result = GetParam(MATCHMAKE_PARAM_KEY_NINTENDO_COUNTRY_CODE, &variant);
        if (result && nintendoCountryCode)
        {
            *nintendoCountryCode = variant.GetUInt32Value();
        }
        return result;
    }

    /*
    

       
       
       
       

    

    
    */
    qBool GetCountryCode(String* countryCode) const
    {
        Variant variant;
        qBool result = GetParam(MATCHMAKE_PARAM_KEY_COUNTRY_CODE, &variant);
        if (result && countryCode)
        {
            *countryCode = variant.GetStringValue();
        }
        return result;
    }

    /* Please see man pages for details 
    

       
       
       
       
       

    
    */
    void SetOverrideIpAddress(const String& overrideIpAddress) { SetParam(MATCHMAKE_PARAM_KEY_OVERRIDE_IP_ADDRESS, overrideIpAddress); }

    /* Please see man pages for details 
    

       
       

    

    
    */
    qBool GetOverrideIpAddress(String* overrideIpAddress)
    {
        Variant variant;
        qBool result = GetParam(MATCHMAKE_PARAM_KEY_OVERRIDE_IP_ADDRESS, &variant);
        if (result && overrideIpAddress)
        {
            *overrideIpAddress = variant.GetStringValue();
        }
        return result;
    }

    /*
    

       
       
       

    

    
    */
    qBool GetLatitude(qDouble* latitude) const
    {
        Variant variant;
        qBool result = GetParam(MATCHMAKE_PARAM_KEY_LATITUDE, &variant);
        if (result && latitude)
        {
            *latitude = variant.GetDoubleValue();
        }
        return result;
    }

    /*
    

       
       
       

    

    
    */
    qBool GetLongitude(qDouble* longitude) const
    {
        Variant variant;
        qBool result = GetParam(MATCHMAKE_PARAM_KEY_LONGITUDE, &variant);
        if (result && longitude)
        {
            *longitude = variant.GetDoubleValue();
        }
        return result;
    }

    /*
    

       
       
       
       
       
       

    

    
    */
    qBool GetDistance(qDouble* distance) const
    {
        Variant variant;
        qBool result = GetParam(MATCHMAKE_PARAM_KEY_DISTANCE, &variant);
        if (result && distance)
        {
            *distance = variant.GetDoubleValue();
        }
        return result;
    }

    /* Please see man pages for details 
    

       
       
       
       

    

    
    */
    qBool GetTotalScore(qUnsignedInt32* totalScore) const
    {
        Variant variant;
        qBool result = GetParam(MATCHMAKE_PARAM_KEY_TOTAL_SCORE, &variant);
        if (result && totalScore)
        {
            *totalScore = variant.GetUInt32Value();
        }
        return result;
    }

    /* Please see man pages for details 
    

       
       

    
    */
    void SetUseGeoIp(qBool useGeoIp) { SetParam(MATCHMAKE_PARAM_KEY_USE_GEO_IP, useGeoIp); }

    /* Please see man pages for details 
    

       

    

    
    */
    qBool GetUseGeoIp(qBool* useGeoIp) const
    {
        Variant variant;
        qBool result = GetParam(MATCHMAKE_PARAM_KEY_USE_GEO_IP, &variant);
        if (result && useGeoIp)
        {
            *useGeoIp = variant.GetBoolValue();
        }
        return result;
    }

    /* Please see man pages for details 
    

       
       
       
       
       
       

    
    */
    void SetUpdateGeoIp(qBool updateGeoIp) { SetParam(MATCHMAKE_PARAM_KEY_UPDATE_GEO_IP, updateGeoIp); }

    /* Please see man pages for details 
    

       
       

    

    
    */
    qBool GetUpdateGeoIp(qBool* updateGeoIp) const
    {
        Variant variant;
        qBool result = GetParam(MATCHMAKE_PARAM_KEY_UPDATE_GEO_IP, &variant);
        if (result && updateGeoIp)
        {
            *updateGeoIp = variant.GetBoolValue();
        }
        return result;
    }

    /* Please see man pages for details 
    

       
       

    

    
    */
    qBool GetGeoIpResult(MATCHMAKE_GEO_IP_RESULT* geoIpResult) const
    {
        Variant variant;
        qBool result = GetParam(MATCHMAKE_PARAM_KEY_GEO_IP_RESULT, &variant);
        if (result && geoIpResult)
        {
            *geoIpResult = static_cast<MATCHMAKE_GEO_IP_RESULT>(variant.GetUInt32Value());
        }
        return result;
    }

    /* Please see man pages for details 
        
    

        
        
        
        

    

    
    */
    qBool GetLastGidForParticipationCheck(GatheringID* gid) const
    {
        Variant variant;
        qBool result = GetParam(MATCHMAKE_PARAM_KEY_LAST_GID_FOR_PARTICIPATION_CHECK, &variant);
        if (result && gid)
        {
            *gid = variant.GetUInt32Value();
        }
        return result;
    }

    /* Please see man pages for details 
        
    */
    void Reset()
    {
        m_Params.clear();
    }

    /* Please see man pages for details 
        

        
    */
    void Trace(qUnsignedInt64 uiTraceFlags=TRACE_ALWAYS) const
    {
        QTRACE(uiTraceFlags, *this);
    }

    /* Please see man pages for details 
        
        
    */
    inline friend StringStream& operator<<(StringStream& oStr, const MatchmakeParam& rhs);
};

inline StringStream& operator<<(StringStream& oStr, const MatchmakeParam& rhs)
{
    oStr << _T("MatchmakeParam: (")
               << _T("m_Params=(");

    qMap<String, Variant>::const_iterator itr = rhs.m_Params.begin();
    for (int i = 0; itr != rhs.m_Params.end(); ++i, ++itr)
    {
        if (i != 0)
        {
            oStr << _T(", ");
        }
        oStr << _T("(key=") << itr->first << _T(", value=") << itr->second << _T(")");
    }

    oStr << _T("))");
    return oStr;
}

END_NAMESPACE_NEX

#endif // _MatchmakeParam_H_
