#ifndef _Quazal_MatchmakeSessionDDL_H_
#define _Quazal_MatchmakeSessionDDL_H_
#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma push
#pragma diag_suppress 228,381,550,1300,1301,2530
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)

#include <OnlineCore/src/DDLTypes/CGCoreExports.h>
#include "RendezVous/Services/MatchMaking/src/Common/MatchMakingServiceProperties.h"
#include "RendezVous/Services/MatchMaking/src/Common/Gathering.h"
#include "OnlineCore/src/DDLTypes/OnlineCoreTypes.h"
#include "MatchmakeParam.h"

BEGIN_NAMESPACE_NEX
class MatchmakeSession;
END_NAMESPACE_NEX

BEGIN_NAMESPACE_NEX

class DDLCLASS(MatchmakeSession): public Gathering {
public:
    DDLCLASS(MatchmakeSession)():_mRevision_MatchmakeSession(3)
    , m_Attribs(0)    , m_ApplicationBuffer(0)    , m_SessionKey(0)     {};
    DDLCLASS(MatchmakeSession)(const DDLCLASS(MatchmakeSession) &oOther):
        Gathering(oOther),
        _mRevision_MatchmakeSession(oOther._mRevision_MatchmakeSession),
        m_GameMode(oOther.m_GameMode),
        m_Attribs(oOther.m_Attribs),
        m_OpenParticipation(oOther.m_OpenParticipation),
        m_MatchmakeSystemType(oOther.m_MatchmakeSystemType),
        m_ApplicationBuffer(oOther.m_ApplicationBuffer),
        m_ParticipationCount(oOther.m_ParticipationCount),
        m_ProgressScore(oOther.m_ProgressScore),
        m_SessionKey(oOther.m_SessionKey),
        m_Option0(oOther.m_Option0),
        m_MatchmakeParam(oOther.m_MatchmakeParam),
        m_StartedTime(oOther.m_StartedTime),
        m_UserPassword(oOther.m_UserPassword),
        m_ReferGid(oOther.m_ReferGid),
        m_UserPasswordEnabled(oOther.m_UserPasswordEnabled),
        m_SystemPasswordEnabled(oOther.m_SystemPasswordEnabled)
    {
    }
    virtual ~DDLCLASS(MatchmakeSession)() {};
    const DDLCLASS(MatchmakeSession) &operator=(const DDLCLASS(MatchmakeSession) &oOther);
    qBool operator==(const DDLCLASS(MatchmakeSession) &oOther) const;
    #ifdef OSDK_DLL_SUPPORT
    qBool operator<(const DDLCLASS(MatchmakeSession) &oOther) const;
    #endif
    static void Add(Message *pMessageToSend, const DDLCLASS(MatchmakeSession) &oValue);
    static void Extract(Message *pReceivedMessage, DDLCLASS(MatchmakeSession) *pValue);
    qByte _mRevision_MatchmakeSession;
    qByte GetClassRevision_MatchmakeSession() const {return _mRevision_MatchmakeSession;}
    void SetClassRevision_MatchmakeSession(qByte revision) {_mRevision_MatchmakeSession=revision;}
    static qByte GetKnownMaxClassRevision_MatchmakeSession() {return 3;}
    DDLTYPE(uint32)::CPPType m_GameMode;
    NEX_CLASS_VALID_REVISION_DEF(m_GameMode, 0);
    qBool NEX_CLASS_ISVALID(m_GameMode) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(qvector)< DDLTYPE(uint32) >::CPPType m_Attribs;
    NEX_CLASS_VALID_REVISION_DEF(m_Attribs, 0);
    qBool NEX_CLASS_ISVALID(m_Attribs) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(bool)::CPPType m_OpenParticipation;
    NEX_CLASS_VALID_REVISION_DEF(m_OpenParticipation, 0);
    qBool NEX_CLASS_ISVALID(m_OpenParticipation) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(uint32)::CPPType m_MatchmakeSystemType;
    NEX_CLASS_VALID_REVISION_DEF(m_MatchmakeSystemType, 0);
    qBool NEX_CLASS_ISVALID(m_MatchmakeSystemType) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(qvector)< DDLTYPE(byte) >::CPPType m_ApplicationBuffer;
    NEX_CLASS_VALID_REVISION_DEF(m_ApplicationBuffer, 0);
    qBool NEX_CLASS_ISVALID(m_ApplicationBuffer) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(uint32)::CPPType m_ParticipationCount;
    NEX_CLASS_VALID_REVISION_DEF(m_ParticipationCount, 0);
    qBool NEX_CLASS_ISVALID(m_ParticipationCount) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(byte)::CPPType m_ProgressScore;
    NEX_CLASS_VALID_REVISION_DEF(m_ProgressScore, 0);
    qBool NEX_CLASS_ISVALID(m_ProgressScore) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(qvector)< DDLTYPE(byte) >::CPPType m_SessionKey;
    NEX_CLASS_VALID_REVISION_DEF(m_SessionKey, 0);
    qBool NEX_CLASS_ISVALID(m_SessionKey) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(uint32)::CPPType m_Option0;
    NEX_CLASS_VALID_REVISION_DEF(m_Option0, 0);
    qBool NEX_CLASS_ISVALID(m_Option0) const { return true; /* The revision is 0. Always true */}
    MatchmakeParam m_MatchmakeParam;
    NEX_CLASS_VALID_REVISION_DEF(m_MatchmakeParam, 1);
    qBool NEX_CLASS_ISVALID(m_MatchmakeParam) const { return NEX_CLASS_VALID_REVISION(m_MatchmakeParam) <= _mRevision_MatchmakeSession;}
    DDLTYPE(datetime)::CPPType m_StartedTime;
    NEX_CLASS_VALID_REVISION_DEF(m_StartedTime, 1);
    qBool NEX_CLASS_ISVALID(m_StartedTime) const { return NEX_CLASS_VALID_REVISION(m_StartedTime) <= _mRevision_MatchmakeSession;}
    DDLTYPE(string)::CPPType m_UserPassword;
    NEX_CLASS_VALID_REVISION_DEF(m_UserPassword, 2);
    qBool NEX_CLASS_ISVALID(m_UserPassword) const { return NEX_CLASS_VALID_REVISION(m_UserPassword) <= _mRevision_MatchmakeSession;}
    DDLTYPE(uint32)::CPPType m_ReferGid;
    NEX_CLASS_VALID_REVISION_DEF(m_ReferGid, 3);
    qBool NEX_CLASS_ISVALID(m_ReferGid) const { return NEX_CLASS_VALID_REVISION(m_ReferGid) <= _mRevision_MatchmakeSession;}
    DDLTYPE(bool)::CPPType m_UserPasswordEnabled;
    NEX_CLASS_VALID_REVISION_DEF(m_UserPasswordEnabled, 3);
    qBool NEX_CLASS_ISVALID(m_UserPasswordEnabled) const { return NEX_CLASS_VALID_REVISION(m_UserPasswordEnabled) <= _mRevision_MatchmakeSession;}
    DDLTYPE(bool)::CPPType m_SystemPasswordEnabled;
    NEX_CLASS_VALID_REVISION_DEF(m_SystemPasswordEnabled, 3);
    qBool NEX_CLASS_ISVALID(m_SystemPasswordEnabled) const { return NEX_CLASS_VALID_REVISION(m_SystemPasswordEnabled) <= _mRevision_MatchmakeSession;}
    public:
	_PR_gathering_methods_pudecl()
    protected:
	_PR_gathering_methods_prdecl()
};


class DDLTYPE(MatchmakeSession): public DDLType {
public:
    typedef MatchmakeSession CPPType;
    static void Add(Message* pMessageToSend, const DDLCLASS(MatchmakeSession)& oMatchmakeSession) {
        DDLCLASS(MatchmakeSession)::Add(pMessageToSend,oMatchmakeSession);
    }
    static void Extract(Message* pReceivedMessage, DDLCLASS(MatchmakeSession)* pMatchmakeSessionToRefresh) {
        DDLCLASS(MatchmakeSession)::Extract(pReceivedMessage,pMatchmakeSessionToRefresh);
    }
};


END_NAMESPACE_NEX

#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma pop
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#endif // _Quazal_MatchmakeSessionDDL.h_H_
