﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc. All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C) 2011-2014 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _MatchmakeSessionSearchCriteria_H_
#define _MatchmakeSessionSearchCriteria_H_

#include <RendezVous/Services/Jugem/Matchmake/src/Common/MatchmakeSessionSearchCriteriaDDL.h>


BEGIN_NAMESPACE_NEX

/* Please see man pages for details 


   
  
   
   
*/
class MatchmakeSessionSearchCriteria: public DDLCLASS(MatchmakeSessionSearchCriteria)
{
public:

    /* Please see man pages for details 
    

       
       
       
       
       
    */
    MatchmakeSessionSearchCriteria();

    /* Please see man pages for details 
    

       
       
       
    */
    MatchmakeSessionSearchCriteria(qUnsignedInt32 gameMode, MatchmakeSystemType matchmakeSystemType);

    /* Please see man pages for details 
     
     */
    virtual ~MatchmakeSessionSearchCriteria() {}

    /* Please see man pages for details 
    

       

    
    */
    void SetGameMode(qUnsignedInt32 gameMode);

    /* Please see man pages for details 
    

       

    
    */
    void SetMinParticipants(qUnsignedInt16 minParticipants);

    /* Please see man pages for details 
    

       
       

    
    
    */
    void SetMinParticipantsWithRange(qUnsignedInt16 min, qUnsignedInt16 max);

    /* Please see man pages for details 
    

       

    
    */
    void SetMaxParticipants(qUnsignedInt16 maxParticipants);

    /* Please see man pages for details 
    

       
       

    
    
    */
    void SetMaxParticipantsWithRange(qUnsignedInt16 min, qUnsignedInt16 max);

    /* Please see man pages for details 
    

    

       

       

    
    
    */
    void SetAttribute(qUnsignedInt32 uiIndex, qUnsignedInt32 val);

    /* Please see man pages for details 
    

    

       

       

    
    
    
                
    */
    qBool SetAttribute(qUnsignedInt32 uiIndex, const qVector<qUnsignedInt32>& vals);

    /* Please see man pages for details 
    

       
       
       

       

    
    
    
    */
    void SetAttributeWithRange(qUnsignedInt32 uiIndex, qUnsignedInt32 min, qUnsignedInt32 max);

    /* Please see man pages for details 
    

       
       

    
    */
    void SetMatchmakeSystemType(MatchmakeSystemType matchmakeSystemType);

    /* Please see man pages for details 
    

       
       
       
      
       
       

    
    */
    void SetExcludeLocked(bool excludeLocked);

    /* Please see man pages for details 
    

    

       
      
       
       


    
    */
    void SetVacantOnly(bool vacantOnly);

    /* Please see man pages for details 
    

    

       
       

       

       

    
    

    
    
    */
    qBool SetVacantOnly(bool vacantOnly, qUnsignedInt16 participants);

    /* Please see man pages for details 
    

       
       

    
    */
    void SetExcludeNonHostPid(bool excludeNonHostPid_);

    /* Please see man pages for details 
    

       

       
       

    
    */
    void SetExcludeUserPasswordSet(bool excludeUserPasswordSet_);

    /* Please see man pages for details 
    

    

       
       

    
    */
    void SetSelectionMethod(MatchmakeSelectionMethod selectionMethod);

    /* Please see man pages for details 
    

    

       
       

    
    
    */
    void SetSelectionMethod(MatchmakeSelectionMethod selectionMethod, const MatchmakeParam& param);

    /* Please see man pages for details 
    

       

    
                              
    */
    void SetReferPersistentGatheringId(GatheringID referPersistentGatheringId)
    {
        m_ReferGid = referPersistentGatheringId;
    }

    /* Please see man pages for details 
    

       
    */
    void Reset();

    /* Please see man pages for details 
    

       
       
    
    */
    qBool IsValid() const
    {
        return m_GameMode != _T("") && m_MatchmakeSystemType != _T("");
    }

};

END_NAMESPACE_NEX

#endif // _MatchmakeSessionSearchCriteria_H_
