#ifndef _Quazal_PlayingSessionDDL_H_
#define _Quazal_PlayingSessionDDL_H_
#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma push
#pragma diag_suppress 228,381,550,1300,1301,2530
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)

#include <OnlineCore/src/DDLTypes/CGCoreExports.h>
#include "OnlineCore/src/DDLTypes/OnlineCoreTypes.h"
#include "RendezVous/Core/src/Common/ProtocolFoundationTypes.h"
#include "RendezVous/Services/MatchMaking/src/Common/Gathering.h"

BEGIN_NAMESPACE_NEX
class PlayingSession;
END_NAMESPACE_NEX

BEGIN_NAMESPACE_NEX

class DDLCLASS(PlayingSession): public RootObject {
public:
    DDLCLASS(PlayingSession)():_mRevision_PlayingSession(0)
     {};
    DDLCLASS(PlayingSession)(const DDLCLASS(PlayingSession) &oOther):
        RootObject(oOther),
        _mRevision_PlayingSession(oOther._mRevision_PlayingSession),
        m_PrincipalId(oOther.m_PrincipalId),
        m_Gathering(oOther.m_Gathering)
    {
    }
    virtual ~DDLCLASS(PlayingSession)() {};
    const DDLCLASS(PlayingSession) &operator=(const DDLCLASS(PlayingSession) &oOther);
    qBool operator==(const DDLCLASS(PlayingSession) &oOther) const;
    #ifdef OSDK_DLL_SUPPORT
    qBool operator<(const DDLCLASS(PlayingSession) &oOther) const;
    #endif
    static void Add(Message *pMessageToSend, const DDLCLASS(PlayingSession) &oValue);
    static void Extract(Message *pReceivedMessage, DDLCLASS(PlayingSession) *pValue);
    qByte _mRevision_PlayingSession;
    qByte GetClassRevision_PlayingSession() const {return _mRevision_PlayingSession;}
    void SetClassRevision_PlayingSession(qByte revision) {_mRevision_PlayingSession=revision;}
    static qByte GetKnownMaxClassRevision_PlayingSession() {return 0;}
    DDLTYPE(uint32)::CPPType m_PrincipalId;
    NEX_CLASS_VALID_REVISION_DEF(m_PrincipalId, 0);
    qBool NEX_CLASS_ISVALID(m_PrincipalId) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(any)< CLASSMETATYPE(Gathering), DDLTYPE(string) >::CPPType m_Gathering;
    NEX_CLASS_VALID_REVISION_DEF(m_Gathering, 0);
    qBool NEX_CLASS_ISVALID(m_Gathering) const { return true; /* The revision is 0. Always true */}
};


class DDLTYPE(PlayingSession): public DDLType {
public:
    typedef PlayingSession CPPType;
    static void Add(Message* pMessageToSend, const DDLCLASS(PlayingSession)& oPlayingSession) {
        DDLCLASS(PlayingSession)::Add(pMessageToSend,oPlayingSession);
    }
    static void Extract(Message* pReceivedMessage, DDLCLASS(PlayingSession)* pPlayingSessionToRefresh) {
        DDLCLASS(PlayingSession)::Extract(pReceivedMessage,pPlayingSessionToRefresh);
    }
};


END_NAMESPACE_NEX

#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma pop
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#endif // _Quazal_PlayingSessionDDL.h_H_
