﻿/*---------------------------------------------------------------------------*
  Copyright (C)2011-2014 Nintendo Co., Ltd.  All rights reserved.
 
  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.
 *---------------------------------------------------------------------------*/

#ifndef _MATCHMAKE_REFEREE_PERSONAL_ROUND_RESULT_H
#define _MATCHMAKE_REFEREE_PERSONAL_ROUND_RESULT_H

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include "MatchmakeRefereePersonalRoundResultDDL.h"

BEGIN_NAMESPACE_NEX

/* Please see man pages for details 
    
*/
class MatchmakeRefereePersonalRoundResult: public DDLCLASS(MatchmakeRefereePersonalRoundResult)
{
public:
    /* Please see man pages for details 
        
    */
    MatchmakeRefereePersonalRoundResult()
    {
        Reset();
    }

    /* Please see man pages for details 
        
    */
    virtual ~MatchmakeRefereePersonalRoundResult() {}

    /* Please see man pages for details 
        
    */
    void Reset()
    {
        SetPrincipalId(0);
        SetPersonalRoundResultFlag(0);
        SetRoundWinLoss(0);
        SetRatingValueChange(0);
        this->buffer.clear();
    }

    /* Please see man pages for details 
        

        
    */
    void SetPrincipalId(PrincipalID pid)
    {
        this->pid = pid;
    }

    /* Please see man pages for details 
        

        
    */
    PrincipalID GetPrincipalId() const
    {
        return this->pid;
    }

    /* Please see man pages for details 
        

        
    */
    void SetPersonalRoundResultFlag(qUnsignedInt32 personalRoundResultFlag)
    {
        this->personalRoundResultFlag = personalRoundResultFlag;
    }

    /* Please see man pages for details 
        

        
    */
    qUnsignedInt32 GetPersonalRoundResultFlag() const
    {
        return this->personalRoundResultFlag;
    }

    /* Please see man pages for details 
        

        
    */
    void SetRoundWinLoss(qUnsignedInt32 roundWinLoss)
    {
        this->roundWinLoss = roundWinLoss;
    }

    /* Please see man pages for details 
        

        
    */
    qUnsignedInt32 GetRoundWinLoss() const
    {
        return this->roundWinLoss;
    }

    /* Please see man pages for details 
        

        
    */
    void SetRatingValueChange(qInt32 ratingValueChange)
    {
        this->ratingValueChange = ratingValueChange;
    }

    /* Please see man pages for details 
        

        
    */
    qInt32 GetRatingValueChange() const
    {
        return this->ratingValueChange;
    }

    /* Please see man pages for details 
        

        
        
       

        
        
    */
    void SetBuffer(const void* src, qUnsignedInt32 size)
    {
        this->buffer.clear();
        this->buffer.push_back((const qByte*)src, size);
    }

    /* Please see man pages for details 
        

        
    */
    const qBuffer& GetBuffer() const
    {
        return this->buffer;
    }

    /* Please see man pages for details 
        

        
        
    */
    void Trace(qUnsignedInt64 uiTraceFlags=TRACE_ALWAYS, qBool bShowBufferContents=false) const
    {
        StringStream ss;
        ss << _T("MatchmakeRefereePersonalRoundResult: (")
           << _T("pid=") << this->pid
           << _T(", personalRoundResultFlag=") << this->personalRoundResultFlag
           << _T(", roundWinLoss=") << roundWinLoss
           << _T(", ratingValueChange=") << this->ratingValueChange
           << _T(", buffer size=") << this->buffer.size();
        if (bShowBufferContents)
        {
            ss << _T(", buffer contents=");
            for (qBuffer::const_iterator it = this->buffer.begin(); it != this->buffer.end(); ++it)
            {
                ss << hex << *it;
            }
        }
        ss << _T(")");
        QTRACE(uiTraceFlags, ss.CStr());
    }
};

END_NAMESPACE_NEX

#endif
