﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc. All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef RANKING_ERRORS_H__
#define RANKING_ERRORS_H__

BEGIN_NAMESPACE_NEX

//group=Error Code Enumerations

/*
Description: This enumeration defines the error codes that may be returned for the Ranking facility.
*/
namespace RankingSuccessCode
{
//group= Type Definitions

/*
Description: Enumerates the error codes for the Ranking facility that a call may return.
*/
enum SuccessCode
{
    /*
    */
    Success = 1
};
}

//group=Error Code Enumerations

/* Please see man pages for details 
    
*/
#ifdef SWIG
class RankingErrorCode
{
public:
#else
namespace RankingErrorCode
{
#endif
    //group= Type Definitions

    /*
    Description: Enumerates the error codes for the Ranking facility that a call may return.
    */
    /* Please see man pages for details 
        

               

               
               

               

               

               
    */
    enum ErrorCode
    {
        /*
        */
        NotInitialized              = 1,  //

        /*
        */
        InvalidArgument             = 2,  //

        /*
        */
        RegistrationError           = 3,  //

        /*
        */
        //NotActivated                = 4,  //!<    Not activated.

        /*
        */
        NotFound                    = 5,  //

        /*
        */
        InvalidScore                = 6,  //

        /*
        */
        InvalidDataSize             = 7,  //

        /*
        */
        //AccessLimitReached          = 8,  //!<    The access limit has been reached.

        /*
        */
        PermissionDenied            = 9,  //

        /*
        */
        Unknown                     = 10, //

        /*
        */
        NotImplemented              = 11  //
    };

    //Note: When adding new results, it is necessary to change NEX_QRESULT_TO_STR in OnlineCore/src/Platform/Core/Result.cpp.
    //See operations done when adding error codes to the wiki.
    //If the errors the application should handle have increased, add them to the list of errors the application should handle in theoverall.rst of the common manual.

#ifdef SWIG
};
#else
}
#endif

END_NAMESPACE_NEX

#endif // RANKING_ERRORS_H__
