/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc. All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _RankingOrderParam_H_
#define _RankingOrderParam_H_

#include <RendezVous/Services/Jugem/Ranking/src/Common/RankingOrderParamDDL.h>
#include <RendezVous/Services/Jugem/Ranking/src/Common/RankingConstants.h>

BEGIN_NAMESPACE_NEX


#ifdef FOR_DOC_PURPOSE
/* Please see man pages for details 
    
*/
class RankingOrderParam
#else
class RankingOrderParam: public DDLCLASS(RankingOrderParam)
#endif
{
public:
    /* Please see man pages for details 
        
    */
    RankingOrderParam()
    {
        SetOrderCalculation(RankingConstants::ORDER_CALCULATION_113);
        SetTimeScope(RankingConstants::TIME_SCOPE_ALL);
        SetFilterGroupIndex(RankingConstants::FILTER_GROUP_INDEX_NONE);
        SetFilterGroupNum(0);
        SetOffset(0);
        SetLength(10);
    }

    /* Please see man pages for details 
        
    */
    virtual ~RankingOrderParam() {};

    /* Please see man pages for details 
        

            

        
    */
    void SetOrderCalculation(RankingConstants::OrderCalculation orderCalculation)
    {
        this->orderCalculation = static_cast<qByte>(orderCalculation);
    };

    /* Please see man pages for details 
        

        
    */
    RankingConstants::OrderCalculation GetOrderCalculation() const
    {
        return static_cast<RankingConstants::OrderCalculation>(this->orderCalculation);
    };

    /* Please see man pages for details 
        

            

        
    */
    void SetFilterGroupIndex(RankingConstants::FilterGroupIndex groupIndex)
    {
        this->groupIndex = static_cast<qByte>(groupIndex);
    };

    /* Please see man pages for details 
        

        
    */
    RankingConstants::FilterGroupIndex GetFilterGroupIndex() const
    {
        return static_cast<RankingConstants::FilterGroupIndex>(this->groupIndex);
    };

    /* Please see man pages for details 
        

            

        
    */
    void SetFilterGroupNum(qByte groupNum)
    {
        this->groupNum = groupNum;
    };

    /* Please see man pages for details 
        

        
    */
    qByte GetFilterGroupNum() const
    {
        return this->groupNum;
    };

    /* Please see man pages for details 
        

            

        
    */
    void SetTimeScope(RankingConstants::TimeScope timeScope)
    {
        this->timeScope = static_cast<qByte>(timeScope);
    };

    /* Please see man pages for details 
        

        
    */
    qByte GetTimeScope() const
    {
        return static_cast<RankingConstants::TimeScope>(this->timeScope);
    };

    /* Please see man pages for details 
        

            

        
    */
    void SetOffset(qUnsignedInt32 offset)
    {
        this->offset = offset;
    };

    /* Please see man pages for details 
        

        
    */
    qUnsignedInt32 GetOffset() const
    {
        return this->offset;
    };

    /* Please see man pages for details 
        

            

        
    */
    void SetLength(qByte length)
    {
        this->length = length;
    };

    /* Please see man pages for details 
        

        
    */
    qByte GetLength() const
    {
        return this->length;
    };

};

END_NAMESPACE_NEX

#endif
