﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc. All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _RankingRankData_H_
#define _RankingRankData_H_

#include <RendezVous/Services/Jugem/Ranking/src/Common/RankingRankDataDDL.h>
#include <RendezVous/Services/Jugem/Utility/src/Common/UniqueId.h>

BEGIN_NAMESPACE_NEX

#ifdef FOR_DOC_PURPOSE
/* Please see man pages for details 
    
 */
class RankingRankData
#else
class RankingRankData: public DDLCLASS(RankingRankData)
#endif
{
public:
    /* Please see man pages for details 
        
    */
    RankingRankData()
    {
        this->principalId = 0;
        this->uniqueId = 0;
        this->order = 0;
        this->category = 0;
        this->param = 0;
        this->score = 0;
        // Set the memory consumption of the common ranking data.
        this->commonData.clear(); // (MAX_COMMON_DATA_SIZE + 1) / 2
        this->updateTime = DateTime::Never;
    };

    /* Please see man pages for details 
        
    */
    virtual ~RankingRankData() {};

    /* Please see man pages for details 
        

        
    */
    qUnsignedInt32 GetPrincipalId() const
    {
        return this->principalId;
    };

    /* Please see man pages for details 
        

        
    */
    UniqueId GetUniqueId() const
    {
        return this->uniqueId;
    };

    /* Please see man pages for details 
        

        
    */
    qUnsignedInt32 GetOrder() const
    {
        return this->order;
    };

    /* Please see man pages for details 
        

        
    */
    qUnsignedInt32 GetCategory() const
    {
        return this->category;
    };

    /* Please see man pages for details 
        

        
    */
    qUnsignedInt32 GetScore() const
    {
        return this->score;
    };

    const qVector<qByte>& GetGroups() const
    {
        return this->groups;
    };

    /* Please see man pages for details 
        

        
    */
    qByte GetGroup0() const
    {
        if( this->groups.size() < 1) return 0;
        return this->groups[0];
    };

    /* Please see man pages for details 
        

        
    */
    qByte GetGroup1() const
    {
        if( this->groups.size() < 2) return 0;
        return this->groups[1];
    };

    /* Please see man pages for details 
        

        
    */
    qUnsignedInt64 GetParam() const
    {
        return this->param;
    };

    /* Please see man pages for details 
        

        
    */
    const qVector<qByte>& GetCommonData() const
    {
        return this->commonData;
    };

    /* Please see man pages for details 
        

        
    */
    const DateTime& GetUpdateTime() const
    {
        return this->updateTime;
    };

};

END_NAMESPACE_NEX

#endif /* _RankingRankData_H_ */
