/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc. All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _RankingScoreData_H_
#define _RankingScoreData_H_

#include <RendezVous/Services/Jugem/Ranking/src/Common/RankingScoreDataDDL.h>
#include <RendezVous/Services/Jugem/Ranking/src/Common/RankingConstants.h>

BEGIN_NAMESPACE_NEX


#ifdef FOR_DOC_PURPOSE
/* Please see man pages for details 
    
*/
class RankingScoreData
#else
class RankingScoreData: public DDLCLASS(RankingScoreData)
#endif
{
public:
    /* Please see man pages for details 
        
    */
    RankingScoreData()
    {
        SetCategory(0);
        SetScore(0);
        SetOrderBy(RankingConstants::ORDER_BY_DESC);
        SetUpdateMode(RankingConstants::UPDATE_MODE_NORMAL);
        this->groups.assign(4,0);
        SetParam(0);
    };

    /* Please see man pages for details 
        
    */
    virtual ~RankingScoreData() {};

    /* Please see man pages for details 
        

        
    */
    qUnsignedInt32 GetCategory() const
    {
        return this->category;
    };

    /* Please see man pages for details 
        

            

        
    */
    void SetCategory(qUnsignedInt32 category)
    {
        this->category = category;
    };

    /* Please see man pages for details 
        

            

        
    */
    void SetScore(qUnsignedInt32 score)
    {
        this->score = score;
    };

    /* Please see man pages for details 
        

        
    */
    qUnsignedInt32 GetScore() const
    {
        return this->score;
    };

    /* Please see man pages for details 
        

            
            
            
            

        
    */
    void SetOrderBy(RankingConstants::OrderBy orderBy)
    {
        this->orderBy = static_cast<qByte>(orderBy);
    };

    /* Please see man pages for details 
        

        
    */
    RankingConstants::OrderBy GetOrderBy() const
    {
        return static_cast<RankingConstants::OrderBy>(this->orderBy);
    };

    /* Please see man pages for details 
        

            
            
            
            
            
            

        
    */
    void SetUpdateMode(RankingConstants::UpdateMode updateMode)
    {
        this->updateMode = static_cast<qByte>(updateMode);
    };

    /* Please see man pages for details 
        

        
    */
    RankingConstants::UpdateMode GetUpdateMode() const
    {
        return static_cast<RankingConstants::UpdateMode>(this->updateMode);
    };

    /* Please see man pages for details 
        

            

        
    */
    void SetGroup0(qByte group0)
    {
        this->groups[0] = group0;
    };

    /* Please see man pages for details 
        

        
    */
    qByte GetGroup0() const
    {
        return this->groups[0];
    };

    /* Please see man pages for details 
        

            

        
    */
    void SetGroup1(qByte group1)
    {
        this->groups[1] = group1;
    };

    /* Please see man pages for details 
        

        
    */
    qByte GetGroup1() const
    {
        return this->groups[1];
    };

    void SetGroups(const qVector<qByte>& groups)
    {
        this->groups = groups;
    };

    const qVector<qByte>& GetGroups() const
    {
        return this->groups;
    };

    /* Please see man pages for details 
        

            

        
    */
    void SetParam(qUnsignedInt64 param)
    {
        this->param = param;
    };

    /* Please see man pages for details 
        

        
    */
    qUnsignedInt64 GetParam() const
    {
        return this->param;
    };
};

END_NAMESPACE_NEX

#endif
