﻿/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc. All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C) 2011-2014 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _SUBSCRIBER_GET_TIMELINE_PARAM_H
#define _SUBSCRIBER_GET_TIMELINE_PARAM_H

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include "SubscriberGetTimelineParamDDL.h"

BEGIN_NAMESPACE_NEX

/* Please see man pages for details 
    
*/
class SubscriberGetTimelineParam: public DDLCLASS(SubscriberGetTimelineParam)
{
public:
    /* Please see man pages for details 
        
    */
    SubscriberGetTimelineParam()
    {
        Reset();
    }

    /* Please see man pages for details 
        
    */
    virtual ~SubscriberGetTimelineParam() {}


    /* Please see man pages for details 
    

        

    
    */
    void SetTargetPrincipalId(PrincipalID pid) { this->pid = pid; }

    /* Please see man pages for details 
    

    
    */
    PrincipalID GetTargetPrincipalId() const { return pid; }

    /* Please see man pages for details 
    

        
        

    
    */
    void SetSize(qUnsignedInt32 size) { this->size = size; }

    /* Please see man pages for details 
    

    
    */
    qUnsignedInt32 GetSize() const { return size; }

    /* Please see man pages for details 
    

        

    
    */
    void SetOffset(qUnsignedInt32 offset) { this->offset = offset; }

    /* Please see man pages for details 
    

    
    */
    qUnsignedInt32 GetOffset() const { return offset; }

    /*
    

        

    
    */
    void SetForceCreate(qBool forceCreate) { this->forceCreate = forceCreate; }

    /*
    

    
    */
    qUnsignedInt32 GetForceCreate() const { return forceCreate; }

    /* Please see man pages for details 
        
    */
    void Reset()
    {
        SetTargetPrincipalId(INVALID_PRINCIPALID);
        SetSize(20);
        SetOffset(0);
        SetForceCreate(false);
    }

    /* Please see man pages for details 
        

        
    */
    void Trace(qUnsignedInt64 uiTraceFlags=TRACE_ALWAYS) const
    {
        QTRACE(uiTraceFlags, *this);
    }

    /* Please see man pages for details 
        
        
    */
    inline friend StringStream& operator<<(StringStream& oStr, const SubscriberGetTimelineParam& rhs);
};

inline StringStream& operator<<(StringStream& oStr, const SubscriberGetTimelineParam& rhs)
{
    oStr << _T("SubscriberGetTimelineParam: (")
               << _T("pid=") << rhs.pid
               << _T(", size=") << rhs.size
               << _T(", offset=") << rhs.offset
               << _T(", forceCreate=") << rhs.forceCreate;
    oStr << _T(")");
    return oStr;
}

END_NAMESPACE_NEX

#endif
