#ifndef _Quazal_SubscriberProtocolDDL_H_
#define _Quazal_SubscriberProtocolDDL_H_
#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma push
#pragma diag_suppress 228,381,550,1300,1301,2530
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)


#include <OnlineCore/src/DDLTypes/CGCoreExports.h>

#include <RendezVous/Core/src/Common/ClientProtocol.h>
#include <RendezVous/Core/src/Common/ServerProtocol.h>
#include <OnlineCore/src/Core/CallContextRegister.h>
#include <RendezVous/Core/src/Common/ProtocolCGMacros.h>
#include <RendezVous/Core/src/Common/ProtocolCallContext.h>
#include <RendezVous/Core/src/Common/ProtocolRequestBrokerInterface.h>
#include <RendezVous/Core/src/Common/Protocol.h>
#include <RendezVous/Core/src/Common/ProtocolList.h>
#include <OnlineCore/src/Transport/Interface/TransportError.h>
#include <RendezVous/Core/src/Client/RVClientCore.h>
#include <RendezVous/Core/src/Client/ProtocolRegistry.h>
#include "OnlineCore/src/DDLTypes/OnlineCoreTypes.h"
#include "SubscriberPostContentParam.h"
#include "SubscriberGetContentParam.h"
#include "SubscriberContent.h"
#include "SubscriberGetFollowerParam.h"
#include "SubscriberGetFollowerResult.h"
#include "SubscriberGetTimelineParam.h"

BEGIN_NAMESPACE_NEX

PROTO_DEFINE_RMCID(SubscriberProtocol, Hello, 1 );
PROTO_DEFINE_RMCID(SubscriberProtocol, PostContent, 2 );
PROTO_DEFINE_RMCID(SubscriberProtocol, GetContent, 3 );
PROTO_DEFINE_RMCID(SubscriberProtocol, Follow, 4 );
PROTO_DEFINE_RMCID(SubscriberProtocol, UnfollowAllAndFollow, 5 );
PROTO_DEFINE_RMCID(SubscriberProtocol, Unfollow, 6 );
PROTO_DEFINE_RMCID(SubscriberProtocol, GetFollowing, 7 );
PROTO_DEFINE_RMCID(SubscriberProtocol, GetFollower, 8 );
PROTO_DEFINE_RMCID(SubscriberProtocol, GetNumFollowers, 9 );
PROTO_DEFINE_RMCID(SubscriberProtocol, GetTimeline, 10 );
PROTO_DEFINE_RMCID(SubscriberProtocol, DeleteContent, 11 );
PROTO_DEFINE_NUM_RMC(SubscriberProtocol, 11);

class SubscriberProtocolClient : public ClientProtocol {
    public:
        typedef DDLTYPE(string) THello_name;
        PROTO_RMCIMPL_RETURN(SubscriberProtocol, Hello)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        typedef CLASSMETATYPE(SubscriberPostContentParam) TPostContent_param;
        typedef DDLTYPE(uint64) TPostContent_contentId;
        PROTO_RMCIMPL_RETURN(SubscriberProtocol, PostContent)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TPostContent_contentId,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef CLASSMETATYPE(SubscriberGetContentParam) TGetContent_param;
        typedef DDLTYPE(qvector)< CLASSMETATYPE(SubscriberContent) > TGetContent_contents;
        PROTO_RMCIMPL_RETURN(SubscriberProtocol, GetContent)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetContent_contents,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(qvector)< DDLTYPE(string) > TFollow_topics;
        PROTO_RMCIMPL_RETURN(SubscriberProtocol, Follow)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(qvector)< DDLTYPE(string) > TUnfollowAllAndFollow_topics;
        PROTO_RMCIMPL_RETURN(SubscriberProtocol, UnfollowAllAndFollow)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(qvector)< DDLTYPE(string) > TUnfollow_topics;
        PROTO_RMCIMPL_RETURN(SubscriberProtocol, Unfollow)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TGetFollowing_pid;
        typedef DDLTYPE(qvector)< DDLTYPE(string) > TGetFollowing_topics;
        PROTO_RMCIMPL_RETURN(SubscriberProtocol, GetFollowing)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetFollowing_topics,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef CLASSMETATYPE(SubscriberGetFollowerParam) TGetFollower_param;
        typedef CLASSMETATYPE(SubscriberGetFollowerResult) TGetFollower_result;
        PROTO_RMCIMPL_RETURN(SubscriberProtocol, GetFollower)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetFollower_result,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(string) TGetNumFollowers_topic;
        typedef DDLTYPE(uint32) TGetNumFollowers_numFollowers;
        PROTO_RMCIMPL_RETURN(SubscriberProtocol, GetNumFollowers)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetNumFollowers_numFollowers,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef CLASSMETATYPE(SubscriberGetTimelineParam) TGetTimeline_param;
        typedef DDLTYPE(qvector)< CLASSMETATYPE(SubscriberContent) > TGetTimeline_contents;
        PROTO_RMCIMPL_RETURN(SubscriberProtocol, GetTimeline)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetTimeline_contents,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(qvector)< DDLTYPE(string) > TDeleteContent_topics;
        typedef DDLTYPE(uint64) TDeleteContent_contentId;
        PROTO_RMCIMPL_RETURN(SubscriberProtocol, DeleteContent)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        SubscriberProtocolClient(ProtocolID uiProtocolID=ProtocolList::Unknown);
        virtual ClientProtocol* CreateResponder() const { return qNew SubscriberProtocolClient(); }
        virtual void ExtractCallSpecificResults(Message *pMessage, ProtocolCallContext* pContext);
        
        qBool CallHello(ProtocolCallContext *pContext, const DDLTYPE(string)::CPPType& name);
        static qBool Hello_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(string)::CPPType& name);
        qBool CallPostContent(ProtocolCallContext *pContext, const SubscriberPostContentParam& param, DDLTYPE(uint64)::CPPType* contentId);
        static qBool PostContent_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const SubscriberPostContentParam& param, DDLTYPE(uint64)::CPPType* contentId);
        qBool CallGetContent(ProtocolCallContext *pContext, const SubscriberGetContentParam& param, DDLTYPE(qvector)< CLASSMETATYPE(SubscriberContent) >::CPPType* contents);
        static qBool GetContent_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const SubscriberGetContentParam& param, DDLTYPE(qvector)< CLASSMETATYPE(SubscriberContent) >::CPPType* contents);
        qBool CallFollow(ProtocolCallContext *pContext, const DDLTYPE(qvector)< DDLTYPE(string) >::CPPType& topics);
        static qBool Follow_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(qvector)< DDLTYPE(string) >::CPPType& topics);
        qBool CallUnfollowAllAndFollow(ProtocolCallContext *pContext, const DDLTYPE(qvector)< DDLTYPE(string) >::CPPType& topics);
        static qBool UnfollowAllAndFollow_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(qvector)< DDLTYPE(string) >::CPPType& topics);
        qBool CallUnfollow(ProtocolCallContext *pContext, const DDLTYPE(qvector)< DDLTYPE(string) >::CPPType& topics);
        static qBool Unfollow_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(qvector)< DDLTYPE(string) >::CPPType& topics);
        qBool CallGetFollowing(ProtocolCallContext *pContext, const DDLTYPE(uint32)::CPPType& pid, DDLTYPE(qvector)< DDLTYPE(string) >::CPPType* topics);
        static qBool GetFollowing_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint32)::CPPType& pid, DDLTYPE(qvector)< DDLTYPE(string) >::CPPType* topics);
        qBool CallGetFollower(ProtocolCallContext *pContext, const SubscriberGetFollowerParam& param, SubscriberGetFollowerResult* result);
        static qBool GetFollower_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const SubscriberGetFollowerParam& param, SubscriberGetFollowerResult* result);
        qBool CallGetNumFollowers(ProtocolCallContext *pContext, const DDLTYPE(string)::CPPType& topic, DDLTYPE(uint32)::CPPType* numFollowers);
        static qBool GetNumFollowers_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(string)::CPPType& topic, DDLTYPE(uint32)::CPPType* numFollowers);
        qBool CallGetTimeline(ProtocolCallContext *pContext, const SubscriberGetTimelineParam& param, DDLTYPE(qvector)< CLASSMETATYPE(SubscriberContent) >::CPPType* contents);
        static qBool GetTimeline_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const SubscriberGetTimelineParam& param, DDLTYPE(qvector)< CLASSMETATYPE(SubscriberContent) >::CPPType* contents);
        qBool CallDeleteContent(ProtocolCallContext *pContext, const DDLTYPE(qvector)< DDLTYPE(string) >::CPPType& topics, const DDLTYPE(uint64)::CPPType& contentId);
        static qBool DeleteContent_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(qvector)< DDLTYPE(string) >::CPPType& topics, const DDLTYPE(uint64)::CPPType& contentId);
        
        protected:
        static ProtoReturnFunction s_protoReturnFunctions[PROTO_NUM_RMC(SubscriberProtocol) + 1];
};

class DDLPROTOCOL(SubscriberProtocolServer) : public ServerProtocol {
    public:
        typedef DDLTYPE(string) THello_name;
        PROTO_RMCIMPL_STUB(SubscriberProtocol, Hello)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(string)::CPPType name;
            _MSG_EXTRACT_VARIABLE(THello_name, name);
            pProtocol->Hello( name );
            PROTO_PREPARE_RETURN(SubscriberProtocol,Hello);
        }
        
        typedef CLASSMETATYPE(SubscriberPostContentParam) TPostContent_param;
        typedef DDLTYPE(uint64) TPostContent_contentId;
        PROTO_RMCIMPL_STUB(SubscriberProtocol, PostContent)
        {
            PROTO_PREPARE_EXTRACTION();
            SubscriberPostContentParam param;
            _MSG_EXTRACT_VARIABLE(TPostContent_param, param);
            DDLTYPE(uint64)::CPPType contentId;
            pProtocol->PostContent( param, &contentId );
            PROTO_PREPARE_RETURN(SubscriberProtocol,PostContent);
            _MSG_ADD_VARIABLE(TPostContent_contentId, contentId);
        }
        
        typedef CLASSMETATYPE(SubscriberGetContentParam) TGetContent_param;
        typedef DDLTYPE(qvector)< CLASSMETATYPE(SubscriberContent) > TGetContent_contents;
        PROTO_RMCIMPL_STUB(SubscriberProtocol, GetContent)
        {
            PROTO_PREPARE_EXTRACTION();
            SubscriberGetContentParam param;
            _MSG_EXTRACT_VARIABLE(TGetContent_param, param);
            DDLTYPE(qvector)< CLASSMETATYPE(SubscriberContent) >::CPPType contents;
            pProtocol->GetContent( param, &contents );
            PROTO_PREPARE_RETURN(SubscriberProtocol,GetContent);
            _MSG_ADD_VARIABLE(TGetContent_contents, contents);
        }
        
        typedef DDLTYPE(qvector)< DDLTYPE(string) > TFollow_topics;
        PROTO_RMCIMPL_STUB(SubscriberProtocol, Follow)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(qvector)< DDLTYPE(string) >::CPPType topics;
            _MSG_EXTRACT_VARIABLE(TFollow_topics, topics);
            pProtocol->Follow( topics );
            PROTO_PREPARE_RETURN(SubscriberProtocol,Follow);
        }
        
        typedef DDLTYPE(qvector)< DDLTYPE(string) > TUnfollowAllAndFollow_topics;
        PROTO_RMCIMPL_STUB(SubscriberProtocol, UnfollowAllAndFollow)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(qvector)< DDLTYPE(string) >::CPPType topics;
            _MSG_EXTRACT_VARIABLE(TUnfollowAllAndFollow_topics, topics);
            pProtocol->UnfollowAllAndFollow( topics );
            PROTO_PREPARE_RETURN(SubscriberProtocol,UnfollowAllAndFollow);
        }
        
        typedef DDLTYPE(qvector)< DDLTYPE(string) > TUnfollow_topics;
        PROTO_RMCIMPL_STUB(SubscriberProtocol, Unfollow)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(qvector)< DDLTYPE(string) >::CPPType topics;
            _MSG_EXTRACT_VARIABLE(TUnfollow_topics, topics);
            pProtocol->Unfollow( topics );
            PROTO_PREPARE_RETURN(SubscriberProtocol,Unfollow);
        }
        
        typedef DDLTYPE(uint32) TGetFollowing_pid;
        typedef DDLTYPE(qvector)< DDLTYPE(string) > TGetFollowing_topics;
        PROTO_RMCIMPL_STUB(SubscriberProtocol, GetFollowing)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType pid;
            _MSG_EXTRACT_VARIABLE(TGetFollowing_pid, pid);
            DDLTYPE(qvector)< DDLTYPE(string) >::CPPType topics;
            pProtocol->GetFollowing( pid, &topics );
            PROTO_PREPARE_RETURN(SubscriberProtocol,GetFollowing);
            _MSG_ADD_VARIABLE(TGetFollowing_topics, topics);
        }
        
        typedef CLASSMETATYPE(SubscriberGetFollowerParam) TGetFollower_param;
        typedef CLASSMETATYPE(SubscriberGetFollowerResult) TGetFollower_result;
        PROTO_RMCIMPL_STUB(SubscriberProtocol, GetFollower)
        {
            PROTO_PREPARE_EXTRACTION();
            SubscriberGetFollowerParam param;
            _MSG_EXTRACT_VARIABLE(TGetFollower_param, param);
            SubscriberGetFollowerResult result;
            pProtocol->GetFollower( param, &result );
            PROTO_PREPARE_RETURN(SubscriberProtocol,GetFollower);
            _MSG_ADD_VARIABLE(TGetFollower_result, result);
        }
        
        typedef DDLTYPE(string) TGetNumFollowers_topic;
        typedef DDLTYPE(uint32) TGetNumFollowers_numFollowers;
        PROTO_RMCIMPL_STUB(SubscriberProtocol, GetNumFollowers)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(string)::CPPType topic;
            _MSG_EXTRACT_VARIABLE(TGetNumFollowers_topic, topic);
            DDLTYPE(uint32)::CPPType numFollowers;
            pProtocol->GetNumFollowers( topic, &numFollowers );
            PROTO_PREPARE_RETURN(SubscriberProtocol,GetNumFollowers);
            _MSG_ADD_VARIABLE(TGetNumFollowers_numFollowers, numFollowers);
        }
        
        typedef CLASSMETATYPE(SubscriberGetTimelineParam) TGetTimeline_param;
        typedef DDLTYPE(qvector)< CLASSMETATYPE(SubscriberContent) > TGetTimeline_contents;
        PROTO_RMCIMPL_STUB(SubscriberProtocol, GetTimeline)
        {
            PROTO_PREPARE_EXTRACTION();
            SubscriberGetTimelineParam param;
            _MSG_EXTRACT_VARIABLE(TGetTimeline_param, param);
            DDLTYPE(qvector)< CLASSMETATYPE(SubscriberContent) >::CPPType contents;
            pProtocol->GetTimeline( param, &contents );
            PROTO_PREPARE_RETURN(SubscriberProtocol,GetTimeline);
            _MSG_ADD_VARIABLE(TGetTimeline_contents, contents);
        }
        
        typedef DDLTYPE(qvector)< DDLTYPE(string) > TDeleteContent_topics;
        typedef DDLTYPE(uint64) TDeleteContent_contentId;
        PROTO_RMCIMPL_STUB(SubscriberProtocol, DeleteContent)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(qvector)< DDLTYPE(string) >::CPPType topics;
            _MSG_EXTRACT_VARIABLE(TDeleteContent_topics, topics);
            DDLTYPE(uint64)::CPPType contentId;
            _MSG_EXTRACT_VARIABLE(TDeleteContent_contentId, contentId);
            pProtocol->DeleteContent( topics, contentId );
            PROTO_PREPARE_RETURN(SubscriberProtocol,DeleteContent);
        }
        
        private:
        // Call this function with a message previously generated by a
        // <RMC name>_PrepareRequest() call to have it dispatched to the correct RMC.
        virtual void DispatchProtocolMessage( Message *pMessage, Message *pReturnMessage, qBool *boReturnsMessage, EndPoint *pEndPoint);
        public:
        
        virtual void Hello(const DDLTYPE(string)::CPPType& name) = 0;
        virtual void PostContent(const SubscriberPostContentParam& param, DDLTYPE(uint64)::CPPType* contentId) = 0;
        virtual void GetContent(const SubscriberGetContentParam& param, DDLTYPE(qvector)< CLASSMETATYPE(SubscriberContent) >::CPPType* contents) = 0;
        virtual void Follow(const DDLTYPE(qvector)< DDLTYPE(string) >::CPPType& topics) = 0;
        virtual void UnfollowAllAndFollow(const DDLTYPE(qvector)< DDLTYPE(string) >::CPPType& topics) = 0;
        virtual void Unfollow(const DDLTYPE(qvector)< DDLTYPE(string) >::CPPType& topics) = 0;
        virtual void GetFollowing(const DDLTYPE(uint32)::CPPType& pid, DDLTYPE(qvector)< DDLTYPE(string) >::CPPType* topics) = 0;
        virtual void GetFollower(const SubscriberGetFollowerParam& param, SubscriberGetFollowerResult* result) = 0;
        virtual void GetNumFollowers(const DDLTYPE(string)::CPPType& topic, DDLTYPE(uint32)::CPPType* numFollowers) = 0;
        virtual void GetTimeline(const SubscriberGetTimelineParam& param, DDLTYPE(qvector)< CLASSMETATYPE(SubscriberContent) >::CPPType* contents) = 0;
        virtual void DeleteContent(const DDLTYPE(qvector)< DDLTYPE(string) >::CPPType& topics, const DDLTYPE(uint64)::CPPType& contentId) = 0;
    };


END_NAMESPACE_NEX

#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma pop
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#endif // _Quazal_SubscriberProtocolDDL.h_H_
