#ifndef _Quazal_GatheringDDL_H_
#define _Quazal_GatheringDDL_H_
#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma push
#pragma diag_suppress 228,381,550,1300,1301,2530
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)

#include <OnlineCore/src/DDLTypes/CGCoreExports.h>
#include "MatchMakingServiceProperties.h"
#include "OnlineCore/src/DDLTypes/OnlineCoreTypes.h"

BEGIN_NAMESPACE_NEX
class Gathering;
END_NAMESPACE_NEX

BEGIN_NAMESPACE_NEX

class DDLCLASS(Gathering): public RootObject {
public:
    DDLCLASS(Gathering)():_mRevision_Gathering(0)
     {};
    DDLCLASS(Gathering)(const DDLCLASS(Gathering) &oOther):
        RootObject(oOther),
        _mRevision_Gathering(oOther._mRevision_Gathering),
        m_idMyself(oOther.m_idMyself),
        m_pidOwner(oOther.m_pidOwner),
        m_pidHost(oOther.m_pidHost),
        m_uiMinParticipants(oOther.m_uiMinParticipants),
        m_uiMaxParticipants(oOther.m_uiMaxParticipants),
        m_uiParticipationPolicy(oOther.m_uiParticipationPolicy),
        m_uiPolicyArgument(oOther.m_uiPolicyArgument),
        m_uiFlags(oOther.m_uiFlags),
        m_uiState(oOther.m_uiState),
        m_strDescription(oOther.m_strDescription)
    {
    }
    virtual ~DDLCLASS(Gathering)() {};
    const DDLCLASS(Gathering) &operator=(const DDLCLASS(Gathering) &oOther);
    qBool operator==(const DDLCLASS(Gathering) &oOther) const;
    #ifdef OSDK_DLL_SUPPORT
    qBool operator<(const DDLCLASS(Gathering) &oOther) const;
    #endif
    static void Add(Message *pMessageToSend, const DDLCLASS(Gathering) &oValue);
    static void Extract(Message *pReceivedMessage, DDLCLASS(Gathering) *pValue);
    qByte _mRevision_Gathering;
    qByte GetClassRevision_Gathering() const {return _mRevision_Gathering;}
    void SetClassRevision_Gathering(qByte revision) {_mRevision_Gathering=revision;}
    static qByte GetKnownMaxClassRevision_Gathering() {return 0;}
    DDLTYPE(uint32)::CPPType m_idMyself;
    NEX_CLASS_VALID_REVISION_DEF(m_idMyself, 0);
    qBool NEX_CLASS_ISVALID(m_idMyself) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(uint32)::CPPType m_pidOwner;
    NEX_CLASS_VALID_REVISION_DEF(m_pidOwner, 0);
    qBool NEX_CLASS_ISVALID(m_pidOwner) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(uint32)::CPPType m_pidHost;
    NEX_CLASS_VALID_REVISION_DEF(m_pidHost, 0);
    qBool NEX_CLASS_ISVALID(m_pidHost) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(uint16)::CPPType m_uiMinParticipants;
    NEX_CLASS_VALID_REVISION_DEF(m_uiMinParticipants, 0);
    qBool NEX_CLASS_ISVALID(m_uiMinParticipants) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(uint16)::CPPType m_uiMaxParticipants;
    NEX_CLASS_VALID_REVISION_DEF(m_uiMaxParticipants, 0);
    qBool NEX_CLASS_ISVALID(m_uiMaxParticipants) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(uint32)::CPPType m_uiParticipationPolicy;
    NEX_CLASS_VALID_REVISION_DEF(m_uiParticipationPolicy, 0);
    qBool NEX_CLASS_ISVALID(m_uiParticipationPolicy) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(uint32)::CPPType m_uiPolicyArgument;
    NEX_CLASS_VALID_REVISION_DEF(m_uiPolicyArgument, 0);
    qBool NEX_CLASS_ISVALID(m_uiPolicyArgument) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(uint32)::CPPType m_uiFlags;
    NEX_CLASS_VALID_REVISION_DEF(m_uiFlags, 0);
    qBool NEX_CLASS_ISVALID(m_uiFlags) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(uint32)::CPPType m_uiState;
    NEX_CLASS_VALID_REVISION_DEF(m_uiState, 0);
    qBool NEX_CLASS_ISVALID(m_uiState) const { return true; /* The revision is 0. Always true */}
    DDLTYPE(string)::CPPType m_strDescription;
    NEX_CLASS_VALID_REVISION_DEF(m_strDescription, 0);
    qBool NEX_CLASS_ISVALID(m_strDescription) const { return true; /* The revision is 0. Always true */}
    public:
	_PR_gathering_methods_pudecl()
    protected:
	_PR_gathering_methods_prdecl()
};


class DDLTYPE(Gathering): public DDLType {
public:
    typedef Gathering CPPType;
    static void Add(Message* pMessageToSend, const DDLCLASS(Gathering)& oGathering) {
        DDLCLASS(Gathering)::Add(pMessageToSend,oGathering);
    }
    static void Extract(Message* pReceivedMessage, DDLCLASS(Gathering)* pGatheringToRefresh) {
        DDLCLASS(Gathering)::Extract(pReceivedMessage,pGatheringToRefresh);
    }
};


END_NAMESPACE_NEX

#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma pop
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#endif // _Quazal_GatheringDDL.h_H_
