/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc. All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _NN_NEX_GatheringURLs_H_
#define _NN_NEX_GatheringURLs_H_

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include <RendezVous/Services/MatchMaking/src/Common/GatheringID.h>
#include <RendezVous/Services/MatchMaking/src/Common/GatheringURLsDDL.h>

BEGIN_NAMESPACE_NEX

/* Please see man pages for details 
 
 */
#ifdef FOR_DOC_PURPOSE
class GatheringURLs: public RootObject
#else
class GatheringURLs: public DDLCLASS(GatheringURLs)
#endif
{
public:

    /* Please see man pages for details 
    
    */
    GatheringURLs()
    {
        m_gid = 0;
        m_lstStationURLs.clear();
    }

    /* Please see man pages for details 
    
    */
    virtual ~GatheringURLs() {}

    /* Please see man pages for details 
     
     */
    GatheringID GetGatheringID() const
    {
        return m_gid;
    }

    /* Please see man pages for details 
     
     */
    const qList<StationURL>& GetStationURLs() const
    {
        return m_lstStationURLs;
    }

    /* Please see man pages for details 
     
     
     */
    void SetGatheringID(GatheringID gid)
    {
        m_gid = gid;
    }

    /* Please see man pages for details 
     
     
     */
    void SetStationURLs(const qList<StationURL>& stationURLList)
    {
        m_lstStationURLs = stationURLList;
    }
};

END_NAMESPACE_NEX

#endif /* _NN_NEX_GatheringURLs_H_ */
