/*---------------------------------------------------------------------------*
  (C) Copyright 1998-2014, Technologies Quazal Inc. All rights reserved.
  Quazal Net-Z, Quazal Rendez-Vous and Quazal are trademarks of Quazal.

  Copyright (C)2011-2014 Nintendo  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensors and are
  protected by national and international copyright laws.
  They may not be disclosed to third parties or copied or duplicated
  in any form, in whole or in part, without the prior written consent
  of Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
 *---------------------------------------------------------------------------*/

#ifndef _MessagingNotificationHandler_H
#define _MessagingNotificationHandler_H

#include <OnlineCore/src/Platform/Core/PlatformDecl.h>
#include <RendezVous/Core/src/Common/DataHolder.h>


BEGIN_NAMESPACE_NEX

//group=Messaging Service

/*
Description: Abstract base class definition for incoming instant messages event handler.
*/

/* Please see man pages for details 
 

 
 
 
 

 
 */
class MessagingNotificationHandler: public RootObject
{
public:

    //group=Methods

    /*
    Description: Default constructor.
    */
    /* Please see man pages for details 
     
     */
    MessagingNotificationHandler();

    /* Please see man pages for details 
     
     */
    virtual ~MessagingNotificationHandler();

    /*
    Description: Callback method to override. Called whenever a
    new message is received through instant messaging.
    Parameters:
    hMsg: Holder for message data, namely an object deriving from
    UserMessage.
    Remarks: Creates a class deriving from MessagingNotificationHandler,
    and overriding this method. Since all messages you receive derive from
    UserMessage, and they are delivered with MessagingClient::SendInstant or
    MessagingClient::SendChat, UserMessage::GetID() returns 0 for each of them.
    Example:
    UserMessage* pUserMsg = static_cast<UserMessage*>( hMsg.Get() );
    See also: MessagingClient, UserMessage
    */
    /* Please see man pages for details 
     

     
     

     
     */
    virtual void DeliverInstantMessage(const DataHolder& hMsg) = 0;
};

END_NAMESPACE_NEX

#endif
