#ifndef _Quazal_MessageDeliveryProtocolDDL_H_
#define _Quazal_MessageDeliveryProtocolDDL_H_
#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma push
#pragma diag_suppress 228,381,550,1300,1301,2530
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)


#include <OnlineCore/src/DDLTypes/CGCoreExports.h>

#include <RendezVous/Core/src/Common/ClientProtocol.h>
#include <RendezVous/Core/src/Common/ServerProtocol.h>
#include <OnlineCore/src/Core/CallContextRegister.h>
#include <RendezVous/Core/src/Common/ProtocolCGMacros.h>
#include <RendezVous/Core/src/Common/ProtocolCallContext.h>
#include <RendezVous/Core/src/Common/ProtocolRequestBrokerInterface.h>
#include <RendezVous/Core/src/Common/Protocol.h>
#include <RendezVous/Core/src/Common/ProtocolList.h>
#include <OnlineCore/src/Transport/Interface/TransportError.h>
#include <RendezVous/Core/src/Client/RVClientCore.h>
#include <RendezVous/Core/src/Client/ProtocolRegistry.h>
#include "RendezVous/Core/src/Common/ProtocolFoundationTypes.h"
#include "RendezVous/Core/src/Common/Data.h"
#include "OnlineCore/src/DDLTypes/OnlineCoreTypes.h"

BEGIN_NAMESPACE_NEX

PROTO_DEFINE_RMCID(MessageDeliveryProtocol, DeliverMessage, 1 );
PROTO_DEFINE_NUM_RMC(MessageDeliveryProtocol, 1);

class MessageDeliveryProtocolClient : public ClientProtocol {
    public:
        typedef DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) > TDeliverMessage_oUserMessage;
        PROTO_RMCIMPL_RETURN(MessageDeliveryProtocol, DeliverMessage)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        MessageDeliveryProtocolClient(ProtocolID uiProtocolID=ProtocolList::Unknown);
        virtual ClientProtocol* CreateResponder() const { return qNew MessageDeliveryProtocolClient(); }
        virtual void ExtractCallSpecificResults(Message *pMessage, ProtocolCallContext* pContext);
        
        qBool CallDeliverMessage(ProtocolCallContext *pContext, const DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType& oUserMessage);
        static qBool DeliverMessage_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType& oUserMessage);
        
        protected:
        static ProtoReturnFunction s_protoReturnFunctions[PROTO_NUM_RMC(MessageDeliveryProtocol) + 1];
};

class DDLPROTOCOL(MessageDeliveryProtocolServer) : public ServerProtocol {
    public:
        typedef DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) > TDeliverMessage_oUserMessage;
        PROTO_RMCIMPL_STUB(MessageDeliveryProtocol, DeliverMessage)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType oUserMessage;
            _MSG_EXTRACT_VARIABLE(TDeliverMessage_oUserMessage, oUserMessage);
            pProtocol->DeliverMessage( oUserMessage );
            PROTO_PREPARE_RETURN(MessageDeliveryProtocol,DeliverMessage);
        }
        
        private:
        // Call this function with a message previously generated by a
        // <RMC name>_PrepareRequest() call to have it dispatched to the correct RMC.
        virtual void DispatchProtocolMessage( Message *pMessage, Message *pReturnMessage, qBool *boReturnsMessage, EndPoint *pEndPoint);
        public:
        
        virtual void DeliverMessage(const DDLTYPE(any)< CLASSMETATYPE(Data), DDLTYPE(string) >::CPPType& oUserMessage) = 0;
    };


END_NAMESPACE_NEX

#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma pop
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#endif // _Quazal_MessageDeliveryProtocolDDL.h_H_
