#ifndef _Quazal_NATTraversalProtocolDDL_H_
#define _Quazal_NATTraversalProtocolDDL_H_
#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma push
#pragma diag_suppress 228,381,550,1300,1301,2530
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)


#include <OnlineCore/src/DDLTypes/CGCoreExports.h>

#include <RendezVous/Core/src/Common/ClientProtocol.h>
#include <RendezVous/Core/src/Common/ServerProtocol.h>
#include <OnlineCore/src/Core/CallContextRegister.h>
#include <RendezVous/Core/src/Common/ProtocolCGMacros.h>
#include <RendezVous/Core/src/Common/ProtocolCallContext.h>
#include <RendezVous/Core/src/Common/ProtocolRequestBrokerInterface.h>
#include <RendezVous/Core/src/Common/Protocol.h>
#include <RendezVous/Core/src/Common/ProtocolList.h>
#include <OnlineCore/src/Transport/Interface/TransportError.h>
#include <RendezVous/Core/src/Client/RVClientCore.h>
#include <RendezVous/Core/src/Client/ProtocolRegistry.h>
#include "OnlineCore/src/DDLTypes/OnlineCoreTypes.h"

BEGIN_NAMESPACE_NEX

PROTO_DEFINE_RMCID(NATTraversalProtocol, RequestProbeInitiation, 1 );
PROTO_DEFINE_RMCID(NATTraversalProtocol, InitiateProbe, 2 );
PROTO_DEFINE_RMCID(NATTraversalProtocol, RequestProbeInitiationExt, 3 );
PROTO_DEFINE_RMCID(NATTraversalProtocol, ReportNATTraversalResult, 4 );
PROTO_DEFINE_RMCID(NATTraversalProtocol, ReportNATProperties, 5 );
PROTO_DEFINE_RMCID(NATTraversalProtocol, GetRelaySignatureKey, 6 );
PROTO_DEFINE_RMCID(NATTraversalProtocol, ReportNATTraversalResultDetail, 7 );
PROTO_DEFINE_NUM_RMC(NATTraversalProtocol, 7);

class NATTraversalProtocolClient : public ClientProtocol {
    public:
        typedef DDLTYPE(qlist)< DDLTYPE(stationurl) > TRequestProbeInitiation_urlTargetList;
        PROTO_RMCIMPL_RETURN(NATTraversalProtocol, RequestProbeInitiation)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(stationurl) TInitiateProbe_urlStationToProbe;
        PROTO_RMCIMPL_RETURN(NATTraversalProtocol, InitiateProbe)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(qlist)< DDLTYPE(stationurl) > TRequestProbeInitiationExt_urlTargetList;
        typedef DDLTYPE(stationurl) TRequestProbeInitiationExt_urlStationToProbe;
        PROTO_RMCIMPL_RETURN(NATTraversalProtocol, RequestProbeInitiationExt)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TReportNATTraversalResult_cid;
        typedef DDLTYPE(bool) TReportNATTraversalResult_result;
        typedef DDLTYPE(uint32) TReportNATTraversalResult_rtt;
        PROTO_RMCIMPL_RETURN(NATTraversalProtocol, ReportNATTraversalResult)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TReportNATProperties_natmapping;
        typedef DDLTYPE(uint32) TReportNATProperties_natfiltering;
        typedef DDLTYPE(uint32) TReportNATProperties_rtt;
        PROTO_RMCIMPL_RETURN(NATTraversalProtocol, ReportNATProperties)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(int32) TGetRelaySignatureKey_relayMode;
        typedef DDLTYPE(datetime) TGetRelaySignatureKey_currentUTCTime;
        typedef DDLTYPE(string) TGetRelaySignatureKey_address;
        typedef DDLTYPE(uint16) TGetRelaySignatureKey_port;
        typedef DDLTYPE(int32) TGetRelaySignatureKey_relayAddressType;
        typedef DDLTYPE(uint32) TGetRelaySignatureKey_gameServerID;
        PROTO_RMCIMPL_RETURN(NATTraversalProtocol, GetRelaySignatureKey)
        {
            PROTO_RETURNSTUB_IMPL();
            _DO_RMC_ExtractReturnValue(TGetRelaySignatureKey_relayMode,1);
            _DO_RMC_ExtractReturnValue(TGetRelaySignatureKey_currentUTCTime,1);
            _DO_RMC_ExtractReturnValue(TGetRelaySignatureKey_address,1);
            _DO_RMC_ExtractReturnValue(TGetRelaySignatureKey_port,1);
            _DO_RMC_ExtractReturnValue(TGetRelaySignatureKey_relayAddressType,1);
            _DO_RMC_ExtractReturnValue(TGetRelaySignatureKey_gameServerID,1);
            PROTO_RETURNSTUB_END();
        };
        
        typedef DDLTYPE(uint32) TReportNATTraversalResultDetail_cid;
        typedef DDLTYPE(bool) TReportNATTraversalResultDetail_result;
        typedef DDLTYPE(int32) TReportNATTraversalResultDetail_detail;
        typedef DDLTYPE(uint32) TReportNATTraversalResultDetail_rtt;
        PROTO_RMCIMPL_RETURN(NATTraversalProtocol, ReportNATTraversalResultDetail)
        {
            PROTO_RETURNSTUB_IMPL();
            PROTO_RETURNSTUB_END();
        };
        
        NATTraversalProtocolClient(ProtocolID uiProtocolID=ProtocolList::Unknown);
        virtual ClientProtocol* CreateResponder() const { return qNew NATTraversalProtocolClient(); }
        virtual void ExtractCallSpecificResults(Message *pMessage, ProtocolCallContext* pContext);
        
        qBool CallRequestProbeInitiation(ProtocolCallContext *pContext, const DDLTYPE(qlist)< DDLTYPE(stationurl) >::CPPType& urlTargetList);
        static qBool RequestProbeInitiation_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(qlist)< DDLTYPE(stationurl) >::CPPType& urlTargetList);
        qBool CallInitiateProbe(ProtocolCallContext *pContext, const DDLTYPE(stationurl)::CPPType& urlStationToProbe);
        static qBool InitiateProbe_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(stationurl)::CPPType& urlStationToProbe);
        qBool CallRequestProbeInitiationExt(ProtocolCallContext *pContext, const DDLTYPE(qlist)< DDLTYPE(stationurl) >::CPPType& urlTargetList, const DDLTYPE(stationurl)::CPPType& urlStationToProbe);
        static qBool RequestProbeInitiationExt_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(qlist)< DDLTYPE(stationurl) >::CPPType& urlTargetList, const DDLTYPE(stationurl)::CPPType& urlStationToProbe);
        qBool CallReportNATTraversalResult(ProtocolCallContext *pContext, const DDLTYPE(uint32)::CPPType& cid, const DDLTYPE(bool)::CPPType& result, const DDLTYPE(uint32)::CPPType& rtt);
        static qBool ReportNATTraversalResult_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint32)::CPPType& cid, const DDLTYPE(bool)::CPPType& result, const DDLTYPE(uint32)::CPPType& rtt);
        qBool CallReportNATProperties(ProtocolCallContext *pContext, const DDLTYPE(uint32)::CPPType& natmapping, const DDLTYPE(uint32)::CPPType& natfiltering, const DDLTYPE(uint32)::CPPType& rtt);
        static qBool ReportNATProperties_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint32)::CPPType& natmapping, const DDLTYPE(uint32)::CPPType& natfiltering, const DDLTYPE(uint32)::CPPType& rtt);
        qBool CallGetRelaySignatureKey(ProtocolCallContext *pContext, DDLTYPE(int32)::CPPType* relayMode, DDLTYPE(datetime)::CPPType* currentUTCTime, DDLTYPE(string)::CPPType* address, DDLTYPE(uint16)::CPPType* port, DDLTYPE(int32)::CPPType* relayAddressType, DDLTYPE(uint32)::CPPType* gameServerID);
        static qBool GetRelaySignatureKey_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, DDLTYPE(int32)::CPPType* relayMode, DDLTYPE(datetime)::CPPType* currentUTCTime, DDLTYPE(string)::CPPType* address, DDLTYPE(uint16)::CPPType* port, DDLTYPE(int32)::CPPType* relayAddressType, DDLTYPE(uint32)::CPPType* gameServerID);
        qBool CallReportNATTraversalResultDetail(ProtocolCallContext *pContext, const DDLTYPE(uint32)::CPPType& cid, const DDLTYPE(bool)::CPPType& result, const DDLTYPE(int32)::CPPType& detail, const DDLTYPE(uint32)::CPPType& rtt);
        static qBool ReportNATTraversalResultDetail_PrepareRequest(ProtocolCallContext *pContext, Message *pMsg, const DDLTYPE(uint32)::CPPType& cid, const DDLTYPE(bool)::CPPType& result, const DDLTYPE(int32)::CPPType& detail, const DDLTYPE(uint32)::CPPType& rtt);
        
        protected:
        static ProtoReturnFunction s_protoReturnFunctions[PROTO_NUM_RMC(NATTraversalProtocol) + 1];
};

class DDLPROTOCOL(NATTraversalProtocolServer) : public ServerProtocol {
    public:
        typedef DDLTYPE(qlist)< DDLTYPE(stationurl) > TRequestProbeInitiation_urlTargetList;
        PROTO_RMCIMPL_STUB(NATTraversalProtocol, RequestProbeInitiation)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(qlist)< DDLTYPE(stationurl) >::CPPType urlTargetList;
            _MSG_EXTRACT_VARIABLE(TRequestProbeInitiation_urlTargetList, urlTargetList);
            pProtocol->RequestProbeInitiation( urlTargetList );
            PROTO_PREPARE_RETURN(NATTraversalProtocol,RequestProbeInitiation);
        }
        
        typedef DDLTYPE(stationurl) TInitiateProbe_urlStationToProbe;
        PROTO_RMCIMPL_STUB(NATTraversalProtocol, InitiateProbe)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(stationurl)::CPPType urlStationToProbe;
            _MSG_EXTRACT_VARIABLE(TInitiateProbe_urlStationToProbe, urlStationToProbe);
            pProtocol->InitiateProbe( urlStationToProbe );
            PROTO_PREPARE_RETURN(NATTraversalProtocol,InitiateProbe);
        }
        
        typedef DDLTYPE(qlist)< DDLTYPE(stationurl) > TRequestProbeInitiationExt_urlTargetList;
        typedef DDLTYPE(stationurl) TRequestProbeInitiationExt_urlStationToProbe;
        PROTO_RMCIMPL_STUB(NATTraversalProtocol, RequestProbeInitiationExt)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(qlist)< DDLTYPE(stationurl) >::CPPType urlTargetList;
            _MSG_EXTRACT_VARIABLE(TRequestProbeInitiationExt_urlTargetList, urlTargetList);
            DDLTYPE(stationurl)::CPPType urlStationToProbe;
            _MSG_EXTRACT_VARIABLE(TRequestProbeInitiationExt_urlStationToProbe, urlStationToProbe);
            pProtocol->RequestProbeInitiationExt( urlTargetList, urlStationToProbe );
            PROTO_PREPARE_RETURN(NATTraversalProtocol,RequestProbeInitiationExt);
        }
        
        typedef DDLTYPE(uint32) TReportNATTraversalResult_cid;
        typedef DDLTYPE(bool) TReportNATTraversalResult_result;
        typedef DDLTYPE(uint32) TReportNATTraversalResult_rtt;
        PROTO_RMCIMPL_STUB(NATTraversalProtocol, ReportNATTraversalResult)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType cid;
            _MSG_EXTRACT_VARIABLE(TReportNATTraversalResult_cid, cid);
            DDLTYPE(bool)::CPPType result;
            _MSG_EXTRACT_VARIABLE(TReportNATTraversalResult_result, result);
            DDLTYPE(uint32)::CPPType rtt;
            _MSG_EXTRACT_VARIABLE(TReportNATTraversalResult_rtt, rtt);
            pProtocol->ReportNATTraversalResult( cid, result, rtt );
            PROTO_PREPARE_RETURN(NATTraversalProtocol,ReportNATTraversalResult);
        }
        
        typedef DDLTYPE(uint32) TReportNATProperties_natmapping;
        typedef DDLTYPE(uint32) TReportNATProperties_natfiltering;
        typedef DDLTYPE(uint32) TReportNATProperties_rtt;
        PROTO_RMCIMPL_STUB(NATTraversalProtocol, ReportNATProperties)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType natmapping;
            _MSG_EXTRACT_VARIABLE(TReportNATProperties_natmapping, natmapping);
            DDLTYPE(uint32)::CPPType natfiltering;
            _MSG_EXTRACT_VARIABLE(TReportNATProperties_natfiltering, natfiltering);
            DDLTYPE(uint32)::CPPType rtt;
            _MSG_EXTRACT_VARIABLE(TReportNATProperties_rtt, rtt);
            pProtocol->ReportNATProperties( natmapping, natfiltering, rtt );
            PROTO_PREPARE_RETURN(NATTraversalProtocol,ReportNATProperties);
        }
        
        typedef DDLTYPE(int32) TGetRelaySignatureKey_relayMode;
        typedef DDLTYPE(datetime) TGetRelaySignatureKey_currentUTCTime;
        typedef DDLTYPE(string) TGetRelaySignatureKey_address;
        typedef DDLTYPE(uint16) TGetRelaySignatureKey_port;
        typedef DDLTYPE(int32) TGetRelaySignatureKey_relayAddressType;
        typedef DDLTYPE(uint32) TGetRelaySignatureKey_gameServerID;
        PROTO_RMCIMPL_STUB(NATTraversalProtocol, GetRelaySignatureKey)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(int32)::CPPType relayMode;
            DDLTYPE(datetime)::CPPType currentUTCTime;
            DDLTYPE(string)::CPPType address;
            DDLTYPE(uint16)::CPPType port;
            DDLTYPE(int32)::CPPType relayAddressType;
            DDLTYPE(uint32)::CPPType gameServerID;
            pProtocol->GetRelaySignatureKey( &relayMode, &currentUTCTime, &address, &port, &relayAddressType, &gameServerID );
            PROTO_PREPARE_RETURN(NATTraversalProtocol,GetRelaySignatureKey);
            _MSG_ADD_VARIABLE(TGetRelaySignatureKey_relayMode, relayMode);
            _MSG_ADD_VARIABLE(TGetRelaySignatureKey_currentUTCTime, currentUTCTime);
            _MSG_ADD_VARIABLE(TGetRelaySignatureKey_address, address);
            _MSG_ADD_VARIABLE(TGetRelaySignatureKey_port, port);
            _MSG_ADD_VARIABLE(TGetRelaySignatureKey_relayAddressType, relayAddressType);
            _MSG_ADD_VARIABLE(TGetRelaySignatureKey_gameServerID, gameServerID);
        }
        
        typedef DDLTYPE(uint32) TReportNATTraversalResultDetail_cid;
        typedef DDLTYPE(bool) TReportNATTraversalResultDetail_result;
        typedef DDLTYPE(int32) TReportNATTraversalResultDetail_detail;
        typedef DDLTYPE(uint32) TReportNATTraversalResultDetail_rtt;
        PROTO_RMCIMPL_STUB(NATTraversalProtocol, ReportNATTraversalResultDetail)
        {
            PROTO_PREPARE_EXTRACTION();
            DDLTYPE(uint32)::CPPType cid;
            _MSG_EXTRACT_VARIABLE(TReportNATTraversalResultDetail_cid, cid);
            DDLTYPE(bool)::CPPType result;
            _MSG_EXTRACT_VARIABLE(TReportNATTraversalResultDetail_result, result);
            DDLTYPE(int32)::CPPType detail;
            _MSG_EXTRACT_VARIABLE(TReportNATTraversalResultDetail_detail, detail);
            DDLTYPE(uint32)::CPPType rtt;
            _MSG_EXTRACT_VARIABLE(TReportNATTraversalResultDetail_rtt, rtt);
            pProtocol->ReportNATTraversalResultDetail( cid, result, detail, rtt );
            PROTO_PREPARE_RETURN(NATTraversalProtocol,ReportNATTraversalResultDetail);
        }
        
        private:
        // Call this function with a message previously generated by a
        // <RMC name>_PrepareRequest() call to have it dispatched to the correct RMC.
        virtual void DispatchProtocolMessage( Message *pMessage, Message *pReturnMessage, qBool *boReturnsMessage, EndPoint *pEndPoint);
        public:
        
        virtual void RequestProbeInitiation(const DDLTYPE(qlist)< DDLTYPE(stationurl) >::CPPType& urlTargetList) = 0;
        virtual void InitiateProbe(const DDLTYPE(stationurl)::CPPType& urlStationToProbe) = 0;
        virtual void RequestProbeInitiationExt(const DDLTYPE(qlist)< DDLTYPE(stationurl) >::CPPType& urlTargetList, const DDLTYPE(stationurl)::CPPType& urlStationToProbe) = 0;
        virtual void ReportNATTraversalResult(const DDLTYPE(uint32)::CPPType& cid, const DDLTYPE(bool)::CPPType& result, const DDLTYPE(uint32)::CPPType& rtt) = 0;
        virtual void ReportNATProperties(const DDLTYPE(uint32)::CPPType& natmapping, const DDLTYPE(uint32)::CPPType& natfiltering, const DDLTYPE(uint32)::CPPType& rtt) = 0;
        virtual void GetRelaySignatureKey(DDLTYPE(int32)::CPPType* relayMode, DDLTYPE(datetime)::CPPType* currentUTCTime, DDLTYPE(string)::CPPType* address, DDLTYPE(uint16)::CPPType* port, DDLTYPE(int32)::CPPType* relayAddressType, DDLTYPE(uint32)::CPPType* gameServerID) = 0;
        virtual void ReportNATTraversalResultDetail(const DDLTYPE(uint32)::CPPType& cid, const DDLTYPE(bool)::CPPType& result, const DDLTYPE(int32)::CPPType& detail, const DDLTYPE(uint32)::CPPType& rtt) = 0;
    };


END_NAMESPACE_NEX

#if defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#pragma pop
#endif // defined(__ARMCC_VERSION) && (__ARMCC_VERSION >= 5000000)
#endif // _Quazal_NATTraversalProtocolDDL.h_H_
